
void pillar_mtl(ENTITY* eEnt_,LF_MATERIAL* mtlLF_Pillar_)
{
	LF_MATERIAL_add(eEnt_,mtlLF_Pillar_);
	
	LF_EntMtl_Roughness(eEnt_,0.8,0.95);
	
	eEnt_->skill43=floatv(0.2);
	eEnt_->skill44=floatv(0.5);
	
	eEnt_->skill45=floatv(1.3);		
}

void stick_mtl(ENTITY* eEnt_,LF_MATERIAL* mtlLF_Stick_)
{
	LF_MATERIAL_add(eEnt_,mtlLF_Stick_);
	
	eEnt_->skill41=floatv(0.2);
	eEnt_->skill42=floatv(0.6);
	
	eEnt_->skill43=floatv(0.6);
	eEnt_->skill44=floatv(0.6);
	
	eEnt_->skill45=floatv(1.4);		
}

void attach_rods_to_pillar(ENTITY* eRods_,ENTITY* ePillar_)
{
	proc_mode=PROC_LATE;
	
	while(eRods_!=NULL && ePillar_!=NULL)
	{
		vec_set(eRods_->x,ePillar_->x);	
		vec_set(eRods_->pan,ePillar_->pan);	
		
		wait(1);
	}
}

ENTITY* create_Pillar(VECTOR* vcPosition_,ANGLE* aAngle_,LF_MATERIAL* mtlLF)
{
	ENTITY* ePillar=ent_create("pillar2.mdl",vcPosition_,NULL);
	vec_set(ePillar->pan,aAngle_);
	set(ePillar,PASSABLE);
	pillar_mtl(ePillar,mtlLF);

	ENTITY* eRods=ent_create("rods.mdl",nullvector,NULL);
	stick_mtl(eRods,mtlLF);
	attach_rods_to_pillar(eRods,ePillar);
	set(eRods,PASSABLE);
	
	return ePillar;		
}

void vec_lerp2(VECTOR* vcLerp_,VECTOR* vcStart_,VECTOR* vcTraget_,var vLF_)
{
	vcLerp_->x=vcStart_->x+ang(vcTraget_->x-vcStart_->x)*vLF_;
	vcLerp_->y=vcStart_->y+(vcTraget_->y-vcStart_->y)*vLF_;
	vcLerp_->z=vcStart_->z+(vcTraget_->z-vcStart_->z)*vLF_;
}

int _iCamFocus=1;
void change_CamFocus()
{
	VECTOR vcTemp1,vcOldCamValues,vcOldCamCenter,vcNewCamValues,vcNewCamCenter;
	vec_zero(vcTemp1);
	
	var vRadius=400;
	var vMove=0;
	
	int iSteps=9;
	
	_iCamFocus=cycle(_iCamFocus+(key_cur-key_cul),0,iSteps);
	fix=0;
	
	_vCamValues[0]=ang(_vCamValues[0]);
	
	vec_set(vcOldCamValues,_vCamValues);
	vec_set(vcOldCamCenter,_vcCamCenter);
	
	vcNewCamCenter.x=cos((360/iSteps)*_iCamFocus)*vRadius;
	vcNewCamCenter.y=sin((360/iSteps)*_iCamFocus)*vRadius;
	vcNewCamCenter.z=_vcCamCenter->z;
	
	vcNewCamValues.x=ang(ang(360/iSteps*_iCamFocus)+180);
	vcNewCamValues.y=-40;
	vcNewCamValues.z=_vCamValues[2];
	
	while(1)
	{
		vec_lerp(_vcCamCenter,vcOldCamCenter,vcNewCamCenter,vMove/100);
		vec_lerp2(_vCamValues,vcOldCamValues,vcNewCamValues,vMove/100);
		
		if(vMove>=100)break;
		
		vMove+=time_step*8;
		vMove=minv(100,vMove);
		
		wait(1);
	}
	
	fix=1;
}

STRING* _sInfo[9][3];

void init_InfoStr()
{
	int i,j;
	for(i=0;i<9;i++)
	for(j=0;j<3;j++)
	_sInfo[i][j]=str_create("");
	
	str_cpy(_sInfo[0][0],"pointlight with shadowmap and cookie");
	str_cpy(_sInfo[0][1],"rotating cookie");
	str_cpy(_sInfo[0][2],"SM3 and 32bit fp RTs required");
	
	str_cpy(_sInfo[1][0],"3 spotlights with shadowmaps and decent cookies");
	str_cpy(_sInfo[1][1],"---");
	str_cpy(_sInfo[1][2],"SM3 and 32bit fp RTs required");
	
	str_cpy(_sInfo[2][0],"spotlight with shadowmap and cookie");
	str_cpy(_sInfo[2][1],"rotating cookie");
	str_cpy(_sInfo[2][2],"SM3 and 32bit fp RTs required");
	
	str_cpy(_sInfo[3][0],"spotlight with shadowmap");
	str_cpy(_sInfo[3][1],"---");
	str_cpy(_sInfo[3][2],"SM3 and 32bit fp RTs required");
	
	str_cpy(_sInfo[4][0],"spotlight with cookie");
	str_cpy(_sInfo[4][1],"aperture angle changing");
	str_cpy(_sInfo[4][2],"SM3");
	
	str_cpy(_sInfo[5][0],"spotlight");
	str_cpy(_sInfo[5][1],"angular attenuation changing");
	str_cpy(_sInfo[5][2],"PS2");
	
	str_cpy(_sInfo[6][0],"pointlight");
	str_cpy(_sInfo[6][1],"light range changing");
	str_cpy(_sInfo[6][2],"PS2");
	
	str_cpy(_sInfo[7][0],"pointlight with cookie");
	str_cpy(_sInfo[7][1],"rotating cookie");
	str_cpy(_sInfo[7][2],"SM3");
	
	str_cpy(_sInfo[8][0],"pointlight with shadowmap");
	str_cpy(_sInfo[8][1],"---");
	str_cpy(_sInfo[8][2],"SM3 and 32bit fp RTs required");
	
	while(1)
	{
		str_cpy(debug_str1,_sInfo[_iCamFocus][0]);
		str_cpy(debug_str2,_sInfo[_iCamFocus][1]);
		str_cpy(debug_str3,_sInfo[_iCamFocus][2]);
		
		wait(1);
	}
}

void DemoStuff1_create()
{
	VECTOR vcTemp1,vcTemp2,vcTemp3;
	vec_zero(vcTemp1);
	vec_zero(vcTemp2);
	vec_zero(vcTemp3);
	
	int i,j,k;
	
	change_CamFocus();
	init_InfoStr();
	
	LF_MATERIAL* mtlLF_Bumpy=LF_MATERIAL_create(_mtlC_Bumpy,"1","2","3","4");
	
	var vRadius=400;
	int iSteps=9;
	
	for(i=0;i<iSteps;i++)
	{
		if(i==1)continue;
		
		vcTemp1.x=cos((360/iSteps)*i)*vRadius;
		vcTemp1.y=sin((360/iSteps)*i)*vRadius;
		
		ENTITY* eEnt=ent_create("ground_wall4.mdl",vcTemp1,NULL);
		eEnt->pan=(360/iSteps)*i;
		
		LF_MATERIAL_add(eEnt,mtlLF_Bumpy);
		
		eEnt->skill41=floatv(0.05);
		eEnt->skill42=floatv(0.6);
		
		eEnt->skill43=floatv(0.2);
		eEnt->skill44=floatv(0.6);
		
		eEnt->skill45=floatv(1);
	}
	
	/////////////////////////////////////////////////////////////////////
	
	ENTITY* eEnt=ent_create("ground_wall4.mdl",nullvector,NULL);//the model with the glowing points
	LF_MATERIAL* mtlLF_BumpyG=LF_MATERIAL_create(_mtlC_Bumpy,"_bFloorWall_col2","_bFloorWall_nm2","3","_bFloorWall_f2");
	
	LF_MATERIAL_add(eEnt,mtlLF_BumpyG);
	
	eEnt->skill41=floatv(0.05);
	eEnt->skill42=floatv(0.6);
	
	eEnt->skill43=floatv(0.2);
	eEnt->skill44=floatv(0.6);
	
	eEnt->skill45=floatv(1);
	LF_EntMtl_MaskType(eEnt,2);
	LF_EntMtl_MaskIntens(eEnt,0);
	
	ent_setskin(eEnt,_bFloorWall_col,1);
	ent_setskin(eEnt,_bFloorWall_nm,2);
	ent_setskin(eEnt,_bFloorWall_r,3);
	ent_setskin(eEnt,_bFloorWall_f,4);
	
	//////////////////////////////////////////
	vcTemp1.x=cos((360/iSteps))*vRadius;
	vcTemp1.y=sin((360/iSteps))*vRadius;
	vcTemp1.z=0;
	
	vec_to_angle(vcTemp2,vcTemp1);
	//////////////////////////////////////////
	ent_transform_pos(eEnt,vcTemp2,vcTemp1);
	/////////////////////////////////////////////////////////////////////
	ENTITY* eEnt=ent_create("rods.mdl",nullvector,NULL);
	ent_setskin(eEnt,_bStick_col,1);
	ent_setskin(eEnt,_bStick_nm,2);
	ent_setskin(eEnt,_bStick_r,3);
	
	ptr_remove(eEnt);
	
	ENTITY* eEnt=create_Pillar(vector(-13,19,18.5),vector(-10,0,0),mtlLF_Bumpy);
	ent_transform_pos(eEnt,vcTemp2,vcTemp1);
	/////////////////////////////////
	ent_setskin(eEnt,_bPillar_col,1);
	ent_setskin(eEnt,_bPillar_nm,2);
	ent_setskin(eEnt,_bPillar_r,3);
	ent_setskin(eEnt,_bPillar_f,4);
	
	ENTITY* eEnt=create_Pillar(vector(13,-38.4,10.5),vector(116.6,83.5,6.5),mtlLF_Bumpy);
	
	ent_transform_pos(eEnt,vcTemp2,vcTemp1);
	/////////////////////////////////
	
	create_Pillar(vector(-368.45,-113.62,18.8),vector(0,0,0),mtlLF_Bumpy);
	create_Pillar(vector(-163.69,-348.33,10.38),vector(0,96,0),mtlLF_Bumpy);
	create_Pillar(vector(60,-397,20.63),vector(20.63,-28.83,-24.22),mtlLF_Bumpy);
	create_Pillar(vector(292.34,-233.12,20.95),vector(-45,24,-3.2),mtlLF_Bumpy);
	create_Pillar(vector(409.58,0,8.52),vector(80.29,-89.91,0),mtlLF_Bumpy);
	create_Pillar(vector(76.42,377.58,18.38),vector(-76.88,0,0),mtlLF_Bumpy);
	create_Pillar(vector(-218.06,324.23,18.38),vector(99.3,0,0),mtlLF_Bumpy);
	create_Pillar(vector(-368.23,157.66,11.98),vector(747.53,-214.95,630.14),mtlLF_Bumpy);

	create_Pillar(vector(77.23,357.75,53.21),vector(-66.31,-72.29,0),mtlLF_Bumpy);
	create_Pillar(vector(-199.62,345.68,18.38),vector(-90.7,0,0),mtlLF_Bumpy);
	create_Pillar(vector(-377.25,120.78,20.38),vector(67.77,20.5,0),mtlLF_Bumpy);
	create_Pillar(vector(-214.57,-306.51,20.09),vector(-127.54,20.5,0),mtlLF_Bumpy);
	create_Pillar(vector(75.27,-386.72,6.27),vector(-64.19,-84.57,0),mtlLF_Bumpy);
	create_Pillar(vector(321.3,-249.53,19.59),vector(131.98,19.14,0),mtlLF_Bumpy);
	create_Pillar(vector(404,7.64,38),vector(13.5,0,0),mtlLF_Bumpy);
	create_Pillar(vector(-400,-184.35,10.72),vector(55.87,81.66,0),mtlLF_Bumpy);
	
	////////create the Lights
	LF_LIGHT* litTemp=LF_LIGHT_create_SL(3,vector(85,0,16),vector(180,0,0),200,80,4,vector(202,237,201),512,_bSpotlight_Cookie);
	LF_LIGHT_transform_pos(litTemp,vcTemp2,vcTemp1);
	
	LF_LIGHT* litTemp=LF_LIGHT_create_SL(4,vector(-33,-105,14),vector(90,0,0),200,60,2,vector(128,255,255),512,_bSpotlight_Cookie);
	LF_LIGHT_transform_pos(litTemp,vcTemp2,vcTemp1);
	
	LF_LIGHT* litTemp=LF_LIGHT_create_SL(3,vector(-83,83,96),vector(-60,-32,0),200,60,2,vector(196,251,113),512,_bSpotlight_Cookie);
	LF_LIGHT_transform_pos(litTemp,vcTemp2,vcTemp1);
	
	////////
	LF_LIGHT_create_SL(3,vector(-278,427.6,27),vector(306,0,0),200,100,2,vector(248,239,86),512);
	LF_LIGHT* litSL_C=LF_LIGHT_create_SL(3,vector(123.32,461.44,60),vector(242.27,-25.55,-10),200,100,4,vector(120,219,252),512,_bSpotlight_Cookie2);
	LF_LIGHT* litSL_C2=LF_LIGHT_create_SL(2,vector(-410,126,46.34),vector(7.56,-49.5,-60),200,80,4,vector(115,254,112),_bSpotlight_Cookie1);
	LF_LIGHT* litSL=LF_LIGHT_create_SL(2,vector(-397.23,-210.9,28.78),vector(53.86,17.57,0),200,100,1,vector(255,128,192));
	
	LF_LIGHT* litPL=LF_LIGHT_create_PL(3,vector(-172,-356.9,22.4),150,vector(5,245,216));
	LF_LIGHT* litPL_C=LF_LIGHT_create_PL(3,vector(91,-383,35),150,vector(250,84,88),_bCubemap_Cookie);
	LF_LIGHT_create_PL(3,vector(316.13,-234.51,55.76),150,vector(112,154,254),256);
	LF_LIGHT* litPL_C_SM=LF_LIGHT_create_PL(3,vector(439,16,84-5),150,vector(255,217,85),256,_bCubemap_Cookie);
	
	LF_LIGHT* DLight=	LF_LIGHT_create_DL(camera,0.15,sun_angle,vector(178,230,255));
	
	while(1)
	{
		litSL_C->aLightAng->roll+=2*time_step;
		
		litSL_C2->vApertureAng=(sin(total_ticks*0.07)+1)*60+50;
		LF_LIGHT_update(litSL_C2);
		
		litSL->vAngularAtt=(sin(total_ticks*0.07)+1)*7+1;
		LF_LIGHT_update(litSL);
		
		litPL->vLightRange=(sin(total_ticks*0.07)+1)*60+40;
		LF_LIGHT_update(litPL);
		
		litPL_C->aLightAng->roll=(sin(total_ticks*0.05))*80;
		
		litPL_C_SM->aLightAng->pan+=1*time_step;
		litPL_C_SM->aLightAng->tilt+=0.5*time_step;
		litPL_C_SM->aLightAng->roll+=1.5*time_step;
		
		draw_textmode("Arial", 0, 14, 75);
		draw_text("move camera with mouse and wheel\n<- -> - change camera focus\nshiftl - fix camera\nO - toggle fps limit on/off\nK/J - remove/add glow\nB - toggle 'show light primitives' on/off\nF11 - statistics\nF5 - change resolution\nAlt + Enter - fullscreen/window\nF6 - highest resolution\nESC - leave", screen_size.x-200, screen_size.y-155, vector(255, 255, 255));
		
		
		wait(1);
	}
}