bool AUTORELOAD;

float4x4 matWorldViewProj;
float4x4 matWorld;

float4 vecSkill41;

float _vCameraClipFar_var;

texture entSkin1;

sampler COLOR_SAMPLER = sampler_state { Texture   = <entSkin1>; MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = clamp; AddressV  = clamp; };

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float cut_zero(float F) { return F/small2+small; }

void VS(		
in float4 vPos		   : POSITION,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,			
out float3  wPos	      : TEXCOORD1,			
out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	wPos= mul(vPos,matWorld);
	
	OutTex = InTex;
}


void PS(	
in float2 Tex	      : TEXCOORD0,
in float3  wPos	      : TEXCOORD1,			

out float4 COL :COLOR0,
out float4 NM  :COLOR1,
out float4 ND  :COLOR2
) 
{
	COL = tex2D(COLOR_SAMPLER,Tex);
	
	float3 col2=(vecSkill41.rgb/255.f)*dot(COL.rgb,0.33f);
	
	COL.rgb=lerp(COL.rgb,col2,vecSkill41.w);
	//	COL=0;
	COL.a=cut_zero(0.5);

	NM=float4(0,0,0,0);
	ND=float4(1,0,0,0);
}

technique Shading
{
	pass P0
	{
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}