bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4 vecViewPort;

float4x4 matWorldViewProj;
float4x4 matWorld;

texture entSkin1;
texture entSkin4;

sampler COLOR_SAMPLER = sampler_state { Texture   = <entSkin1>; MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler F_SAMPLER     = sampler_state { Texture   = <entSkin4>; MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

void VS(		
in float4 vPos		   : POSITION,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	   : TEXCOORD0,			

out float4 Pos	      : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	OutTex = InTex;//*vecSkill45.y;
}

void PS(	
in float2 Tex	         : TEXCOORD0,			

out float4 COL :COLOR0
) 
{
	float4 diff_color=tex2D(COLOR_SAMPLER,Tex);
	
	COL.rgb=diff_color.rgb;
	COL.a=mask_alpha(diff_color.a);
	
	////////////////////////////////////////////////////////////////////
	float4 fsampler=tex2D(F_SAMPLER,Tex);
	
	fsampler.ag*=vecSkill45.zw;
	
	fsampler.a=(1-fsampler.a)*0.5f;
	fsampler.b=fsampler.g;
	fsampler.g=lerp(0.5f+small,1.f,fsampler.g);
	fsampler.b=lerp(fsampler.a,fsampler.g,mask_alpha(fsampler.b));
	
	COL.a=cut_zero(fsampler.b)*COL.a;
	////////////////////////////////////////////////////////////////////
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}