
#include <acknex.h>
#include <default.c>

//#define PRAGMA_PATH "textures";
//#define PRAGMA_PATH "models";
//
#include "Demo_Declarations.c"

#include "LightFrog.h"

#include "DemoStuff.c"

TEXT* _tDebug=
{
	strings=3;
	string=debug_str1,debug_str2,debug_str3;
	flags=SHOW;
}

void init_place_DebugTxt_startup()
{
	while(1)
	{
		_tDebug->pos_y=screen_size.y-30;
		wait(1);
	}
}

void isometric_camera() 
{
	camera->z=40;
	camera->x=100;
	camera->pan=140;

	ENTITY* eColli=ent_create("cam_colli.mdl",camera.x,NULL);
	vec_set(eColli.pan,camera.pan);
	set(eColli,INVISIBLE);

	var vMoveForce[3]={0,0,0};
	while(1)
	{
		if(iCamMode==0)
		{
			if(fix==1)
			vec_set(_vCamValues,vector(_vCamValues[0]+(mouse_force.x)*16*time_step*fix,clamp(_vCamValues[1]+(mouse_force.y)*16*time_step*fix,-90,90),_vCamValues[2]+(mickey.z/2)*time_step));

			vec_set(camera->pan,vector(_vCamValues[0],_vCamValues[1],0));

			vec_set(camera->x,vector((- _vCamValues[2] *cos(camera->tilt)*cos(_vCamValues[0])),(- _vCamValues[2] *cos(camera->tilt)*sin(_vCamValues[0])), - _vCamValues[2] * sin(camera->tilt)));
			
			vec_add(camera->x,_vcCamCenter);			
		}
		else
		{
			if(fix==1)
			{
				eColli->pan-=mouse_force.x*15*time_step;
				eColli->tilt+=mouse_force.y*15*time_step;				
			}
			
			vMoveForce[0]=(key_w-key_s)*(15+50*key_ctrl-10*key_alt)*time_step;
			vMoveForce[1]=(key_a-key_d)*(15+50*key_ctrl-10*key_alt)*time_step;
			
			c_move(eColli,vMoveForce,nullvector,GLIDE + IGNORE_PASSABLE + USE_POLYGON);
			
			vec_set(camera->x,eColli->x);
			vec_set(camera->pan,eColli->pan);
		}
		
		wait(1);
	}
}

void sun_startup() 
{
	sun_angle.pan=145;
	sun_angle.tilt=50;
	
	while (1)
	{
		sun_angle.tilt += 4 * time_step *(key_m-key_n);
		sun_angle.pan += 2 * time_step *key_space;

		wait (1);
	}
}

void init_mouse_startup()
{
	proc_mode=PROC_EARLY;
	mouse_mode=1;

	while(1)
	{		
		vec_set(mouse_pos,mouse_cursor);		
		wait(1);
	}
}

ENTITY* _eSkyCube =
{
	type = "Nacht+6.tga"; 
	layer=1;
	flags2 = SKY | CUBE | SHOW; // sky cube, visible
}


void fix_cam()
{
	fix=1-fix;
}

void toggle_FPSLimit()
{
	fps_max=50-fps_max;
}

void main()
{
	on_shiftl=fix_cam;
	on_cul=change_CamFocus;
	on_cur=change_CamFocus;
	on_o=toggle_FPSLimit;
	on_b=LF_toggle_GlobalLightDebugging;
	on_f6=change_to_highes_resolution;

	fps_max=50;
	
	video_mode=10;
	
	max_entities=2000;
	
	level_load("");
	
	wait(2);
	
	video_window(NULL,NULL,NULL,"LightFrog Demo1");
	
	isometric_camera();
	
	//////////////////////////////
	//	_vLF_SaturationMode=1;
	//	_vLF_AccFormat=1;
	//	_vLF_NormalFormat=1;
	
	LF_INI();
	LF_init_pipeline(camera);
	
	LF_SkyCube_init(_eSkyCube);
	
	LF_set_AmbientLight(camera,vector(163,183,192),0.05);
	//	LF_set_TonemappingFactor(camera,1);


	//////////////////////////////
	
	int i,j,k;
	
	DemoStuff1_create();

	wait(3);
	LF_add_glow(camera,0.3,1);
	
	while(1)
	{
		
		if(key_j)
		{
			LF_add_glow(camera,0.3,1);
			
			while(key_j)wait(1);
		}
		
		if(key_k)
		{
			LF_remove_glow(camera,_vLF_LightingMode);
			
			while(key_k)wait(1);
		}
		
		wait(1);
	}
	
}