
ENTITY* create_simplePillar(VECTOR* vcPos_,LF_MATERIAL* mtlLF_)
{
	ENTITY* eEnt=ent_create("pillar2.mdl",vcPos_,NULL);
	LF_MATERIAL_add(eEnt,mtlLF_);
	
	eEnt->skill41=floatv(0.0);
	eEnt->skill42=floatv(0.2);
	
	eEnt->skill43=floatv(0.2);
	eEnt->skill44=floatv(0.5);
	
	eEnt->skill45=floatv(1.3);
	
	place_down(eEnt);
	
	return eEnt;
}

void DemoStuff2_create()
{	
	int i,j,k;
	
	iCamMode=1;
	
	LF_MATERIAL* mtlLF_Bumpy=LF_MATERIAL_create(_mtlC_Bumpy,"1","2","3","4");
	LF_MATERIAL* mtlLF_Atrium=LF_MATERIAL_create(_mtlC_Standard,"1");
	
	LF_MATERIAL* mtlLF_Terr=LF_MATERIAL_create(_mtlC_MTBumpy,
	"bTerr_col","bTerr_nm","bTerr_mask","bTerr_d","bDetail_nm",
	"bTex1","bTex2","bTex3","bTex4","bTex5","bTex1_nm","bTex2_nm","bTex3_nm","bTex4_nm","bTex5_nm");
	
	ENTITY* eTerr;
	ENTITY* eEnt=eTerr=ent_create("terr_ground3.hmp",nullvector,NULL);
	LF_MATERIAL_add(eEnt,mtlLF_Terr);
	
	wait(1);
	eEnt->skill2=2;//nm intens
	eEnt->skill3=0;//use nm
	eEnt->skill5=1.5;//detail scale
	
	LF_EntMtl_Roughness(eEnt,1);//dont use specular for any texture

	/////////////////////////////////
	
	ENTITY* eEnt=create_simplePillar(nullvector,mtlLF_Bumpy);
	
	ent_setskin(eEnt,_bPillar_col,1);
	ent_setskin(eEnt,_bPillar_nm,2);
	ent_setskin(eEnt,_bPillar_r,3);
	ent_setskin(eEnt,_bPillar_f,4);
	
	VECTOR vcAtriumPos;
	vcAtriumPos.x=-37.65;
	vcAtriumPos.y=14;
	vcAtriumPos.z=-73.45;
	
	var vAtriumPan=-48;
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	ENTITY* eAtrium;
	ENTITY* eEnt=ent_create("atrium.mdl",vcAtriumPos,NULL); eEnt->pan=vAtriumPan;
	LF_MATERIAL_add(eEnt,mtlLF_Atrium);
	
	ENTITY* eEnt=ent_create("roof.mdl",vcAtriumPos,NULL); eEnt->pan=vAtriumPan;
	LF_MATERIAL_add(eEnt,mtlLF_Atrium);
	
	ENTITY* eEnt=ent_create("shell.mdl",vcAtriumPos,NULL); eEnt->pan=vAtriumPan;
	LF_MATERIAL_add(eEnt,mtlLF_Atrium);
	
	ENTITY* eEnt=ent_create("plateLionhead.mdl",vector(-398.51,437.13,0),NULL); eEnt->pan=vAtriumPan;
	LF_MATERIAL_add(eEnt,mtlLF_Atrium);
	
	ENTITY* eEnt=ent_create("plateLionhead.mdl",vector(194.8,-221.93,376.8),NULL); eEnt->pan=vAtriumPan+180;
	LF_MATERIAL_add(eEnt,mtlLF_Atrium);
	
	ENTITY* eEnt=ent_create("plateLionhead.mdl",vector(-399.17,437.49,188.39),NULL); eEnt->pan=vAtriumPan;
	LF_MATERIAL_add(eEnt,mtlLF_Atrium);
	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	int count=10;
	var spread=400;
	var off_spread=100;
	
	for(i=-count;i<=count;i++)
	for(j=-count;j<=count;j++)
	{
		ENTITY* eEnt=create_simplePillar(vector(i*spread+(random(off_spread)*2-off_spread),j*spread+(random(off_spread)*2-off_spread),0),mtlLF_Bumpy);
		eEnt->pan=random(360);
	}
	
	var vCascadeSize[4]={300,1000,3000,8000};
	var vBlurStrength[3]={5,2,2};
	var vShadowBias[4]={1,4,6,10};
	
	vCascadeSize[3]=0;//use 3 cascades
	
	//SUNLIGHT
	LF_LIGHT* DLight1=	LF_LIGHT_create_DL_CSM(camera,0.5,&sun_angle,vector(178,230,255),512,vCascadeSize,vBlurStrength,vShadowBias);

	//red point lights inside the atrium
	LF_LIGHT_create_PL(1,vector(405,-193,30),140,vector(224,20,10));
	LF_LIGHT_create_PL(1,vector(143.5,-419,30),140,vector(224,20,10));
	LF_LIGHT_create_PL(1,vector(-492,262.5,29.5),140,vector(224,20,10));
	LF_LIGHT_create_PL(1,vector(-228,502,30),140,vector(224,20,10));
	
	LF_LIGHT_create_PL(1,vector(-392,427.5,126),200,vector(224,20,10));
	LF_LIGHT_create_PL(1,vector(-173,-71,221.5),200,vector(224,20,10));
	LF_LIGHT_create_PL(1,vector(86,163,221),200,vector(224,20,10));
	LF_LIGHT_create_PL(1,vector(274.5,-311.5,221.5),200,vector(224,20,10));
	
	while(1)
	{		
		vec_set(DLight1->aLightAng,sun_angle);
		wait(1);
	}
}