bool AUTORELOAD;

float4 vecSkill45;
float4 vecSkill41;//LightColor.rgb LightRange
float4 vecSkill17;//ClipFar.x Arc.y

float _vLF_LightingMode_var;
float _vLF_SaturationMode_var;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4x4 matWorldViewProj;
float4x4 matWorld;
float4x4 matViewInv;
float4 vecViewPort;
float4x4 matProj;

texture mtlSkin1;
texture mtlSkin2;

sampler NORMAL_SAMPLER = sampler_state { Texture   = <mtlSkin1>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };
sampler DEPTH_SAMPLER  = sampler_state { Texture   = <mtlSkin2>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };

float add_zero(float F) { return (F-small)*small2; }
float add_zero2(float F) { return lerp(F,(F-small)*small2,_vLF_LightingMode_var); }
//float add_zero2(float F) { return (F-small*_vLF_LightingMode_var)*(1+small*_vLF_LightingMode_var); }

void VS(		
in float4 vPos		   : POSITION,

out float4  pPos        : TEXCOORD1,
out float4  WorldPos    : TEXCOORD3,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	pPos=Pos;
	
	float3 wPos = mul(vPos,matWorld);

	WorldPos.xyz=wPos;
	WorldPos.w=matWorldViewProj[3].w;
}

float3 get_WorldPos_from_View(float Depth, float2 Tex)
{
	float2 sTex=float2(Tex.x,1-Tex.y)*2-1;
	
	float2 XY=tan(radians(vecSkill17.y))*Depth*float2(1,vecViewPort.y/vecViewPort.x);

	return mul(float4(XY*sTex,Depth,1),matViewInv).xyz;
}

float2 calc_ScreenPos(float4 pPos)
{
	return (float2(pPos.x,-pPos.y)/pPos.w+vecViewPort.zw)*0.5+0.5;
}


void PS(	
in float4  pPos        : TEXCOORD1,
in float4  WorldPos    : TEXCOORD3,

out float4 DIFF :COLOR0
) 
{
	float2 pTex=calc_ScreenPos(pPos);//+0.5*vecViewPort.zw;
	
	float4 D=tex2D(DEPTH_SAMPLER,pTex);
	
	float oDepth=D.x+(D.y/255.f)+(D.z/255.f/255.f);
	
	if(oDepth==1)
	clip(-1);
	
	oDepth*=vecSkill17.x;
	
	float3 wPos=get_WorldPos_from_View(oDepth,pTex);
	
	float3 oPos=wPos-matWorld[3].xyz;

	///////////////////Attenuation
	float att_x=length(oPos)/vecSkill41.x;
	
	if(att_x>1)clip(-1);
	
	att_x=1-min(1,att_x);

	att_x=att_x*att_x*(3-2*att_x);//smooth cubic

	///////////////////
	float4 NM=tex2D(NORMAL_SAMPLER,pTex);
	float3 normal=normalize(NM.xyz*2-1);
	
	float3 LightDir=-normalize(oPos);
	float LN=saturate(dot(LightDir,normal));
	
	float Amb=att_x*min(1,LN+vecSkill45.w)*vecSkill45.z;
	///////////////////////////////////////
	DIFF.rgb=Amb;
	DIFF.a=Amb;
}

technique Shading
{
	pass P0
	{		
		cullmode=cw;
		alphablendenable=true;
		zfunc=always;
		blendop=revsubtract;
		srcblend=one;
		destblend=one;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}