bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill5;

float4 vecSkill41;//LightColor.rgb LightRange
float4 vecSkill45;
float4 vecSkill17;//ClipFar.x Arc.y z SM res

float4 vecFog;//x contains the cone angle

float _vLF_LightingMode_var;
float _vLF_SaturationMode_var;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4x4 matWorldViewProj;
float4x4 matWorldView;
float4x4 matWorld;
float4x4 matViewInv;
//float4x4 matView;
//float4x4 matViewProj;
float4x4 matMtl;

float4x4 matEffect1;
float4x4 matEffect2;

float4x4 matEffect3;
float4x4 matEffect4;

float4x4 matProj;

//float4 vecSunDir;		
float4 vecViewPos;
float4 vecViewPort;
float4 vecViewDir;
//float4 vecTime;

texture mtlSkin1;
texture mtlSkin2;
texture entSkin3;

texture _bRT_Normal_Buffer_bmap;
texture _bRT_Depth_Buffer_bmap;

sampler NORMAL_SAMPLER = sampler_state { Texture   = <mtlSkin1>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };
sampler DEPTH_SAMPLER  = sampler_state { Texture   = <mtlSkin2>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };

sampler SHADOWCUBE_SAMPLER = sampler_state { Texture   = <entSkin3>; MinFilter = Linear;MagFilter = Linear;MipFilter = Linear;   AddressU  = clamp; AddressV  = clamp; };

float add_zero(float F) { return (F-small)*small2; }
float add_zero2(float F) { return lerp(F,(F-small)*small2,_vLF_LightingMode_var); }
//float add_zero2(float F) { return (F-small*_vLF_LightingMode_var)*(1+small*_vLF_LightingMode_var); }

float g_MinVariance=10.f;

float ReduceLightBleeding(float p_max, float Amount)
{
	return saturate((p_max-Amount)/(1-Amount));	
}

float ChebyshevUpperBound(float2 Moments, float t)
{
	float p=(t<=Moments.x);
	
	float Variance=Moments.y-(Moments.x*Moments.x);
	Variance = max(Variance, g_MinVariance);
	
	float d=t-Moments.x;
	float p_max=Variance/(Variance+d*d);
	
	return max(p,p_max);
}

float3 toCube[4][2]=
{
{{1,0,0},{-1,1,1}},
{{0,0,1},{1,1,1}},
{{1,0,0},{1,1,-1}},
{{0,0,1},{-1,1,-1}},
};

//	CubeTex[0]=float3(-1,Tex.y,Tex.x);
//	CubeTex[1]=float3(Tex.x,Tex.y,1);
//	CubeTex[2]=float3(1,Tex.y,-Tex.x);
//	CubeTex[3]=float3(-Tex.x,Tex.y,-1);

float3 Tex_to_CubeTex(float2 Tex,int FaceNum)
{
	Tex=clamp(Tex,0,1)*2-1;
	Tex.y*=-1;
	
	float3 cTex=float3(Tex.x,Tex.y,Tex.x);
	
	cTex-=cTex*toCube[FaceNum][0];
	cTex+=toCube[FaceNum][0];
	cTex*=toCube[FaceNum][1];
	
	return cTex;
}

float4 blur_shadowmap1(int FaceNum,float2 TexCoords,float offset, float DistanceToLight)
{
//	return texCUBE(SHADOWCUBE_SAMPLER,Tex_to_CubeTex(TexCoords,FaceNum));
	
	float count=1.f;
	offset/=count;
	
	float4 Value=0;
	
	offset/=max(1,sqrt(DistanceToLight)*0.2f);//reduce light bleeding
	
	for(float i=-count;i<=count;i++)
	for(float j=-count;j<=count;j++)
	{		
		float2 newTexCoords=TexCoords + float2(i,j)*offset;
		
		float4 d=texCUBE(SHADOWCUBE_SAMPLER,Tex_to_CubeTex(newTexCoords,FaceNum));

		Value+=d;
	}
	
	return Value/pow(count*2+1,2);	
}

float4 blur_shadowmap2(int FaceNum,float2 TexCoords,float offset, float DistanceToLight)
{
	float count=2.f;
	offset/=count;
	
	float4 Value=0;
	
	offset/=max(1,sqrt(DistanceToLight)*0.2f);//reduce light bleeding
	
	for(float i=-count;i<=count;i++)
	for(float j=-count;j<=count;j++)
	{		
		float2 newTexCoords=TexCoords + float2(i,j)*offset;
		
		float4 d=texCUBE(SHADOWCUBE_SAMPLER,Tex_to_CubeTex(newTexCoords,FaceNum));

		Value+=d;
	}
	
	return Value/pow(count*2+1,2);	
}

void VS(		
in float4 vPos		   : POSITION,

out float4  pPos        : TEXCOORD1,
out float3  LightColor  : TEXCOORD2,

out float4 Pos	         : POSITION
)
{
	//////////////////////
	float2 vertex_mask=sign(vPos.zy);
	
	vPos=mul(vPos,matWorldView);
	
	vPos.xy=vertex_mask.xy*100;
	vPos.z=15;
	//	vPos.z=10.217775f;
	
	Pos = mul(vPos,matProj);
	//////////////////////
	
	pPos=Pos;
	
	LightColor=vecSkill41.yzw/255.f;
	LightColor*=dot(LightColor,float3(0.3505f,0.2065f,0.443f));
	LightColor*=vecSkill45.z;
	
	float3 LightColor_norm=LightColor.rgb/max(LightColor.r,max(LightColor.g,LightColor.b));
	LightColor_norm=min(LightColor_norm,LightColor);
	
	LightColor=lerp(LightColor_norm,LightColor,_vLF_SaturationMode_var);
	//	LightColor*=dot(LightColor,float3(0.299f,0.587f,0.114f));
	
}

float3 get_WorldPos_from_View(float Depth, float2 Tex)
{
	float2 sTex=float2(Tex.x,1-Tex.y)*2-1;
	
	float2 XY=tan(radians(vecSkill17.y))*Depth*float2(1,vecViewPort.y/vecViewPort.x);

	return mul(float4(XY*sTex,Depth,1),matViewInv).xyz;
}

float2 calc_ScreenPos(float4 pPos)
{
	return (float2(pPos.x,-pPos.y)/pPos.w+vecViewPort.zw)*0.5+0.5;
}

float2 calc_ScreenPos2(float4 pPos)
{
	return (float2(pPos.x,-pPos.y)+(1.f/vecSkill17.z))*0.5+0.5;
}

float extBlinn(float NH,float roughness,float fresnel)
{
	float e=pow(2,9*roughness);
	
	float n=1-(1-roughness)*(1-roughness);//approx. normalization 
	
	return pow(NH,e)*n*fresnel;
}

//float VSM_Cascade0(float3 wPos,float4x4 matEffect,int Num,float bias,float blur)
//{
//	float4 SpPos=mul(float4(wPos,1),matEffect);
//	float2 SpTex=calc_ScreenPos2(SpPos);
//	float SpD=(dot(normalize(matEffect1[Num].xzy),wPos - matEffect2[Num].xzy));
//	
//	float2 Moments=texCUBE(SHADOWCUBE_SAMPLER,Tex_to_CubeTex(SpTex,Num)).xy;
//
//	float vsm=ChebyshevUpperBound(Moments,SpD-bias);
//	
//	return ReduceLightBleeding(vsm,0.3f);
//}

float VSM_Cascade1(float3 wPos,float4x4 matEffect,int Num,float bias,float blur)
{
	float4 SpPos=mul(float4(wPos,1),matEffect);
	float2 SpTex=calc_ScreenPos2(SpPos);
	float SpD=(dot(normalize(matEffect1[Num].xzy),wPos - matEffect2[Num].xzy));
	
	float2 Moments=blur_shadowmap1(Num,SpTex,0.008f*blur,SpD-bias).xy;

	float vsm=ChebyshevUpperBound(Moments,SpD-bias);
	
	return ReduceLightBleeding(vsm,0.3f);
}

float VSM_Cascade2(float3 wPos,float4x4 matEffect,int Num,float bias,float blur)
{
	float4 SpPos=mul(float4(wPos,1),matEffect);
	float2 SpTex=calc_ScreenPos2(SpPos);
	float SpD=(dot(normalize(matEffect1[Num].xzy),wPos - matEffect2[Num].xzy));
	
	float2 Moments=blur_shadowmap2(Num,SpTex,0.008f*blur,SpD-bias).xy;

	float vsm=ChebyshevUpperBound(Moments,SpD-bias);
	
	return ReduceLightBleeding(vsm,0.3f);
}

void PS(	
in float4  pPos        : TEXCOORD1,
in float3  LightColor  : TEXCOORD2,

out float4 DIFF :COLOR0

//out float4 COL :COLOR0,
//out float4 NM  :COLOR1,
//out float4 D   :COLOR2
) 
{
	float2 pTex=calc_ScreenPos(pPos);//+0.5*vecViewPort.zw;
	
	float4 D=tex2D(DEPTH_SAMPLER,pTex);
	
	float oDepth=D.x+(D.y/255.f)+(D.z/255.f/255.f);
	
	if(oDepth==1)
	clip(-1);
	
	oDepth*=vecSkill17.x;
	
	float3 wPos=get_WorldPos_from_View(oDepth,pTex);
	//	
	//	float3 oPos=wPos-matWorld[3].xyz;
	
	float4 NM=tex2D(NORMAL_SAMPLER,pTex);
	
	float3 normal=normalize(NM.xyz*2-1);
	
	float3 LightDir=normalize(matWorld[0].xyz);
	//	float3 LightDir=-normalize(oPos);
	
	float3 View=vecViewPos.xyz-wPos;
	float3 ViewDir=normalize(View);
	
	float3 H=normalize(LightDir+ViewDir);
	
	////	float LH=saturate(dot(H,LightDir));
	float NH=saturate(dot(H,normal));
	float LN=saturate(dot(LightDir,normal));
	
	////////////
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	float VSM=1;
	float VSM3,VSM4;

	//////////////////////////////////////////////////
//	if(oDepth<matEffect1[1].w+matEffect2[1].w)
//	{
		float3 dir=vecViewDir.xyz;

		float Areas[2]={0,0};
		float Areas2[2]={0,0};

		for(int i=0;i<2;i++)
		{
			Areas[i]=1-length(wPos-(vecViewPos.xyz+dir*matEffect1[i].w))/matEffect2[i].w;
			Areas2[i]=Areas[i]>0;	
		}

		float lerpAreas[2]={0,0};
		
		lerpAreas[0]=lerp(Areas2[0],saturate(Areas[0]*4),saturate(Areas2[0]+Areas2[1]-1));
		
		lerpAreas[1]=1-saturate((length(View)-matEffect1[1].w)/(matEffect2[1].w*vecSkill5.w));
		
		//////////////////////////////////////////////////
		if(Areas2[1]==1) { VSM3=VSM=VSM_Cascade1(wPos,matEffect4,1,vecSkill5.x,vecSkill1.y); }
			
		if(Areas2[0]==1) { VSM4=VSM=VSM_Cascade2(wPos,matEffect3,0,vecSkill1.w,vecSkill1.x); }
		////////////////////////////

		if(Areas2[1]==1 && Areas2[0]==1) { VSM=lerp(VSM3,VSM4,lerpAreas[0]); }
		
		VSM=lerp(1,VSM,saturate(lerpAreas[1]*4));		
//	}
	
	
	///////////////////////////////////////
	DIFF.rgb=LightColor*LN*VSM;
	//	DIFF.rgb=LightColor*min(VSM,LN);
	DIFF.a=extBlinn(NH,add_zero(D.w),add_zero(NM.w)*2)*saturate(LN*3)*saturate(vecSkill45.z)*VSM;

	
//			DIFF.rgb=-matEffect1[3].w*0.000001;
	//		DIFF.r=lerpAreas[0];
//		DIFF.g=lerpAreas[1];
//		DIFF.b=lerpAreas[2];
//
//		DIFF.r=lerpAreas[3];
////		DIFF.r=Areas2[3];
	//	DIFF.r=1-pow((length(wPos-(vecViewPos.xyz+dir*matEffect1[0].w))/matEffect2[0].w),300);
//		DIFF.g=1-pow((length(wPos-(vecViewPos.xyz+dir*matEffect1[1].w))/matEffect2[1].w),1000);
//		DIFF.b=1-pow((length(wPos-(vecViewPos.xyz+dir*matEffect1[2].w))/matEffect2[2].w),2000);
//		DIFF.r=1-pow((length(wPos-(vecViewPos.xyz+dir*matEffect1[3].w))/matEffect2[3].w),2000);
	//
	//	COL.w=1;
	//	NM=0;
	//	D=0;
}

technique Shading
{
	pass P0
	{		
		//				fillmode=2;
		//		cullmode=ccw;
		//		
		//		zenable=true;
		//		zwriteenable=true;
		//		alphablendenable=false;
		//		alphatestenable=true;
		//		
		//		AlphaRef=0;
		//		AlphaFunc=Greater;
		
		cullmode=ccw;
		alphablendenable=true;
		zfunc=always;
		srcblend=one;
		destblend=one;
		
		VertexShader = compile vs_3_0 VS();
		PixelShader  = compile ps_3_0 PS();
	}
}