bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4x4 matWorldViewProj;
float4x4 matWorld;

texture entSkin1;
texture entSkin4;

sampler R_SAMPLER     = sampler_state { Texture   = <entSkin4>; MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler COLOR_SAMPLER = sampler_state { Texture   = <entSkin1>; MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

void VS(		
in float4 vPos		   : POSITION,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,			
out float  Depth        : TEXCOORD1,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	Depth=Pos.w/vecSkill17.x;
	
	OutTex = InTex*vecSkill45.y;
}

half2 splitt_float_to_2half(float F)
{
	return half2(floor(F*255.f)/255.f,frac(F*255.f));
}

half3 splitt_float_to_3half(float F)
{
	return half3(floor(F*255.f)/255.f,splitt_float_to_2half(frac(F*255.f)));
}

void PS(	
in float2 Tex	         : TEXCOORD0,			
in float  Depth         : TEXCOORD1,

out float4 D   :COLOR0
) 
{
	float A=tex2D(COLOR_SAMPLER,Tex).a;
	A=mask_alpha(A);
	
	////////////
	float roughness =tex2D(R_SAMPLER,Tex).r;
	roughness=lerp(vecSkill41.x,vecSkill41.y,roughness);
	
	D.xyz=splitt_float_to_3half(Depth);
	D.w=cut_zero(roughness)*A;
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}