bool AUTORELOAD;

static const float pi=3.141592653589793238462643383279502884197169399375105820974944592f;

float4 vecSkill5;
float4 vecSkill1;

float4 vecViewPort;
float4 vecViewPos;
float4 vecTime;

//float4x4 matMtl;
//float4x4 matEffect;
float4x4 matView;

texture mtlSkin1;
texture mtlSkin2;
texture mtlSkin3;
//texture mtlSkin4;
texture _bAttenuationMap_PL_bmap;
texture _bAttenuationMap_SL_bmap;

sampler COLOR_SAMPLER = sampler_state { Texture   = <mtlSkin1>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };

sampler LIGHTACC_SAMPLER = sampler_state { Texture   = <mtlSkin2>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };
sampler TEST_SAMPLER = sampler_state { Texture   = <mtlSkin3>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };

sampler ATT_SAMPLER = sampler_state { Texture   = <_bAttenuationMap_SL_bmap>; MinFilter = Point; MagFilter = Linear; MipFilter = Linear;    AddressU  = clamp; AddressV  = clamp; };

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float mask_alpha(float A) { return 1-step(1,1-A); }
float add_zero(float F) { return (F-small)*small2; }

const	float RecipLwhiteSqrd=1.f/20.f;

float3 ToneMapper(float3 hdr, float BarLw)
{
	float lumi = dot(hdr,float3(.2126f ,.7152f,.0722f));
	lumi=max(lumi,1);
	
	float aOverBarLw = (0.18f / BarLw);
	float Lxy = aOverBarLw * lumi;
	float numer = (1 + (Lxy * RecipLwhiteSqrd)) * Lxy;
	float denum = 1 + Lxy;
	float Ld = numer / denum ;	
	
	return hdr/Ld;
}

float3 SmoothCurveSin(float3 f)
{
	return sin((f*2-1)*pi*0.5)*0.5+0.5;
}

float3 SmoothCurve(float3 x)
{
	return x*x*(3-2*x);
}

float3 SmoothCurve2(float3 f)
{
	float3 F2=SmoothCurve(f);
	
	float3 lf=1-abs(f*2-1);
	float3 F=lerp(f,F2,lf);
	
	F=SmoothCurve(F);
	
	return F;
}

float3 ContrastCurve(float3 x)
{
	return x*x*x*(4-3*x);
}

float3 bleach_bypass(float3 col,float ds_f)
{
	col=saturate(lerp(col,dot(col,col),ds_f));
	col=SmoothCurve(col);
	return col;
}

float3 norm_color(float3 col)
{
	return col.rgb/max(col.r,max(col.g,col.b));
}

void PS(
in float2 Tex : TEXCOORD0,

out float4 COL : COLOR0
) 
{	
	float4 diff_color=tex2D(COLOR_SAMPLER,Tex);
	
	float mask=add_zero(diff_color.a);
	float diff_mask=min(1,mask*2);
	float glow_mask=(mask-0.5)*2;
	
	diff_mask-=step(small,glow_mask);
	diff_mask=max(diff_mask,glow_mask);
	
	float4 light=max(0,(tex2D(LIGHTACC_SAMPLER,Tex)-small)/(1-small));
	
	float3 spec=light.a*light.rgb;
	float3 amb=vecSkill5.xyz/255.f*vecSkill5.w;
	light.rgb=lerp(light.rgb+amb,1,diff_mask);
	
	///////////////////
	
	COL.rgb=diff_color.rgb*light.rgb+spec;

	COL.rgb=ToneMapper(COL.rgb,0.04f*vecSkill1.x);
	//	COL.rgb=ToneMapper(COL.rgb,0.04f*_vLF_ToneMapperFac_var);
	
	//	COL.rgb=lerp(COL.rgb,bleach_bypass(COL.rgb,0.6),0.6);
	
//	COL.rgb=mask;
	
	COL.w=1;
}

technique Shading
{
	pass one
	{
		PixelShader = compile ps_2_0 PS();
	}
}

