bool AUTORELOAD;

static const float pi=3.141592653589793238462643383279502884197169399375105820974944592f;

//float4 vecSkill5;
float4 vecSkill1;

float4 vecViewPort;
float4 vecViewPos;
float4 vecTime;

//float4x4 matMtl;
//float4x4 matEffect;
float4x4 matView;

texture mtlSkin1;
texture mtlSkin2;
texture mtlSkin3;
//texture mtlSkin4;

sampler COLOR_SAMPLER = sampler_state { Texture   = <mtlSkin1>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };
sampler LCOLOR_SAMPLER= sampler_state { Texture   = <mtlSkin2>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };


const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float mask_alpha(float A) { return 1-step(1,1-A); }
float add_zero(float F) { return (F-small)*small2; }

const	float RecipLwhiteSqrd=1.f/20.f;

float3 norm_color(float3 col)
{
	return col.rgb/max(col.r,max(col.g,col.b));
}

void PS(
in float2 Tex : TEXCOORD0,

out float4 GMASK : COLOR0
) 
{	
	//Tex.y-=0.5;
	float4 diff_color=tex2D(COLOR_SAMPLER,Tex);
	
	float mask=add_zero(diff_color.a);
	float glow_mask=(mask-0.5)*2;
	
	float3 COL=tex2D(LCOLOR_SAMPLER,Tex);
	
	float lum=dot(COL.rgb,float3(0.2126,0.7152,0.0722));
	float lum_mask=max(0,lum-vecSkill1.y);
	
	GMASK.rgb=norm_color(COL.rgb)*lum_mask;
	GMASK.rgb=lerp(GMASK.rgb,diff_color.rgb,glow_mask);
	GMASK.a=1;
	
}

technique Shading
{
	pass one
	{
		PixelShader = compile ps_2_0 PS();
	}
}

