
STRING* _sMtl_Bump_MRT="COLOR_SAMPLER;NM_SAMPLER;R_SAMPLER;F_SAMPLER;~

bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

float4x4 matWorldViewProj;
float4x4 matWorld;
float4x4 matProj;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4 vecSunDir;		
float4 vecViewPos;
float4 vecViewDir;

void VS(		
in float4 vPos		   : POSITION,
in float3 normal	   : NORMAL,
in float2 InTex	   : TEXCOORD0,
in float4 InTangent	: TEXCOORD2,

out float2 OutTex	      : TEXCOORD0,			
out float3 View	      : TEXCOORD1,
out float3 wPos         : TEXCOORD2,
out float  Depth        : TEXCOORD3,
out float3x3 matTangent : TEXCOORD4,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	Depth=Pos.w/vecSkill17.x;
	
	OutTex = InTex*vecSkill45.y;

	wPos = mul(vPos,matWorld);
	
	View=vecViewPos.xyz-wPos;
	
	//		Depth=dot(vecViewDir,wPos - vecViewPos)/_vCameraClipFar_var;
	
	matTangent[0] = mul(InTangent.xyz,matWorld);	
	matTangent[1] = mul(cross(InTangent.xyz,normal)*InTangent.w,matWorld);
	matTangent[2] = mul(normal,matWorld);
}

half2 splitt_float_to_2half(float F)
{
	return half2(floor(F*255.f)/255.f,frac(F*255.f));
}

half3 splitt_float_to_3half(float F)
{
	return half3(floor(F*255.f)/255.f,splitt_float_to_2half(frac(F*255.f)));
}

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

float get_MtlMask(float mask,float type,float intens)
{
	mask*=intens;
	mask=(1-mask)*step(0.5,type);
	
	type=max(0,(type-0.5)*2);
	mask=lerp(mask*0.5,mask*0.5+0.5+small,type);
	
	return cut_zero(mask);
}

void PS(	
in float2 Tex	         : TEXCOORD0,			
in float3 View	         : TEXCOORD1,
in float3 wPos          : TEXCOORD2,
in float  Depth         : TEXCOORD3,
in float3x3 matTangent  : TEXCOORD4,

out float4 COL :COLOR0,
out float4 NM  :COLOR1,
out float4 D   :COLOR2
) 
{
	COL =tex2D(COLOR_SAMPLER,Tex);
	
	COL.a=mask_alpha(COL.a);
	
	float roughness =tex2D(R_SAMPLER,Tex).r;
	//	COL =1;
	
	float3 bump_normal=tex2D(NM_SAMPLER,Tex)*2-1;
	bump_normal.xy*=vecSkill45.x;
	bump_normal=normalize(bump_normal);
	
	bump_normal=mul(bump_normal,matTangent);

	/////////////////////////////////////////////////////////////////////////////
	float3 ViewDir=normalize(View);
	float NV=saturate(dot(ViewDir,bump_normal));
	
	////////////////////////////////////////////////////////////////////
	float4 fsampler=tex2D(F_SAMPLER,Tex);
	
	COL.a=get_MtlMask(fsampler.a,int(vecSkill45.z)*0.5,frac(vecSkill45.z)*10)*COL.a;
	////////////////////////////////////////////////////////////////////
	
	float refindex=lerp(vecSkill41.z,vecSkill41.w,fsampler.r);
	
	float fresnel=lerp(refindex,1,pow(1-NV,5));//approx. fresnel for specular lighting
	
	roughness=lerp(vecSkill41.x,vecSkill41.y,roughness);
	/////////////////////////////////////////////////////////////////////////////
	
	bump_normal=bump_normal*0.5f+0.5f;
	
	NM.xyz=bump_normal.xyz;
//	NM.w=cut_zero(refindex);
	NM.w=cut_zero(fresnel);
	
	D.xyz=splitt_float_to_3half(Depth);
	D.w=cut_zero(roughness);
	
//	COL.a=1;
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}

";

STRING* _sMtl_Bump_Normals="NULL;NM_SAMPLER;NULL;F_SAMPLER;~

bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4x4 matWorldViewProj;
float4x4 matWorld;

float4 vecViewPos;

float cut_zero(float F) { return F/small2+small; }

void VS(		
in float4 vPos		   : POSITION,
in float3 normal	   : NORMAL,
in float2 InTex	   : TEXCOORD0,
in float4 InTangent	: TEXCOORD2,

out float2 OutTex	      : TEXCOORD1,
out float3 View	      : TEXCOORD2,
out float3x3 matTangent : TEXCOORD3,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	OutTex = InTex*vecSkill45.y;

	float3 wPos = mul(vPos,matWorld);
	
	View=vecViewPos.xyz-wPos;

	matTangent[0] = mul(InTangent.xyz,matWorld);	
	matTangent[1] = mul(cross(InTangent.xyz,normal)*InTangent.w,matWorld);
	matTangent[2] = mul(normal,matWorld);
}

void PS(	
in float2 Tex	         : TEXCOORD1,
in float3 View	         : TEXCOORD2,
in float3x3 matTangent  : TEXCOORD3,

out float4 NM  :COLOR0
) 
{
	float3 bump_normal=tex2D(NM_SAMPLER,Tex)*2-1;
	bump_normal.xy*=vecSkill45.x;
	bump_normal=normalize(bump_normal);
	bump_normal=mul(bump_normal,matTangent);

	/////////////////////////////////////////////////////////////////////////////
	float3 ViewDir=normalize(View);
	float NV=saturate(dot(ViewDir,bump_normal));
	
	float refindex=tex2D(F_SAMPLER,Tex).r;
	refindex=lerp(vecSkill41.z,vecSkill41.w,refindex);
	
	float fresnel=lerp(refindex,1,pow(1-NV,5));//approx. fresnel for specular lighting
	/////////////////////////////////////////////////////////////////////////////
	
	bump_normal=bump_normal*0.5f+0.5f;
	
	NM.xyz=bump_normal.xyz;
	
//	NM.w=cut_zero(refindex);
	NM.w=cut_zero(fresnel);
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}
";

STRING* _sMtl_Bump_Color="COLOR_SAMPLER;NULL;NULL;F_SAMPLER;~
bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4 vecViewPort;

float4x4 matWorldViewProj;
float4x4 matWorld;

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

float get_MtlMask(float mask,float type,float intens)
{
	mask*=intens;
	mask=(1-mask)*step(0.5,type);
	
	type=max(0,(type-0.5)*2);
	mask=lerp(mask*0.5,mask*0.5+0.5+small,type);
	
	return cut_zero(mask);
}

void VS(		
in float4 vPos		   : POSITION,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	   : TEXCOORD0,			

out float4 Pos	      : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	OutTex = InTex*vecSkill45.y;
}

void PS(	
in float2 Tex	         : TEXCOORD0,			

out float4 COL :COLOR0
) 
{
	float4 diff_color=tex2D(COLOR_SAMPLER,Tex);
	
	COL.rgb=diff_color.rgb;
	COL.a=mask_alpha(diff_color.a);
	
	////////////////////////////////////////////////////////////////////
	float4 fsampler=tex2D(F_SAMPLER,Tex);
	
	COL.a=get_MtlMask(fsampler.a,int(vecSkill45.z)*0.5,frac(vecSkill45.z)*10)*COL.a;
	////////////////////////////////////////////////////////////////////
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}";

STRING* _sMtl_Bump_Depth="NULL;NULL;R_SAMPLER;~
bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4x4 matWorldViewProj;
float4x4 matWorld;

float cut_zero(float F) { return F/small2+small; }

void VS(		
in float4 vPos		   : POSITION,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,			
out float  Depth        : TEXCOORD1,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	Depth=Pos.w/vecSkill17.x;
	
	OutTex = InTex*vecSkill45.y;
}

half2 splitt_float_to_2half(float F)
{
	return half2(floor(F*255.f)/255.f,frac(F*255.f));
}

half3 splitt_float_to_3half(float F)
{
	return half3(floor(F*255.f)/255.f,splitt_float_to_2half(frac(F*255.f)));
}

void PS(	
in float2 Tex	         : TEXCOORD0,			
in float  Depth         : TEXCOORD1,

out float4 D   :COLOR0
) 
{
	float roughness =tex2D(R_SAMPLER,Tex).r;
	roughness=lerp(vecSkill41.x,vecSkill41.y,roughness);
	
	D.xyz=splitt_float_to_3half(Depth);
	D.w=cut_zero(roughness);
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}";

STRING* _sMtl_Bump_VSMDepth="NULL;~
bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

float4 vecViewDir;
float4 vecViewPos;

float4x4 matWorldViewProj;
float4x4 matWorld;

void VS(		
in float4 vPos		   : POSITION,
//in float2 InTex	   : TEXCOORD0,

//out float2 OutTex	      : TEXCOORD0,			
out float  Depth        : TEXCOORD1,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
//	Depth=Pos.w;
	Depth=dot(vecViewDir,mul(vPos,matWorld) - vecViewPos);
	
	//	OutTex = InTex*vecSkill45.y;
}


void PS(	
//in float2 Tex	         : TEXCOORD0,			
in float  Depth         : TEXCOORD1,

out float4 D   :COLOR0
) 
{
	D=float4(Depth,Depth*Depth,0,1);
//	D=100;
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}
";

LF_MTL_CONTAINER* _mtlC_Bumpy=
{
	sMRT=_sMtl_Bump_MRT;
	sCOL=_sMtl_Bump_Color;
	sNM=_sMtl_Bump_Normals;
	sD=_sMtl_Bump_Depth;
	sVSMD=_sMtl_Bump_VSMDepth;
	
	lFlags=TANGENT;
}