
STRING* _sMtl_MTBump_MRT="COLOR_SAMPLER;OSNM_SAMPLER;MASK_SAMPLER;DINTENS_SAMPLER;DETAIL_SAMPLER;C1_SAMPLER;C2_SAMPLER;C3_SAMPLER;C4_SAMPLER;C5_SAMPLER;NM1_SAMPLER;NM2_SAMPLER;NM3_SAMPLER;NM4_SAMPLER;NM5_SAMPLER;~

bool AUTORELOAD;

float4 vecSkill1;
float4x4 matMtl;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

float4x4 matWorldViewProj;
float4x4 matWorld;
float4x4 matProj;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4 vecSunDir;		
float4 vecViewPos;
float4 vecViewDir;

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

float get_MtlMask(float mask,float type,float intens)
{
	mask*=intens;
	mask=(1-mask)*step(0.5,type);
	
	type=max(0,(type-0.5)*2);
	mask=lerp(mask*0.5,mask*0.5+0.5+small,type);
	
	return cut_zero(mask);
}

void VS(		
in float4 vPos		   : POSITION,
in float3 normal	   : NORMAL,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,			
out float3 View	      : TEXCOORD1,
out float3 outnormal	   : TEXCOORD2,
out float  Depth        : TEXCOORD3,
out float2 tTex         : TEXCOORD4,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	Depth=Pos.w/vecSkill17.x;
	
	OutTex = InTex;

	float3 wPos = mul(vPos,matWorld);
	
	tTex=vPos.xz*0.01*vecSkill45.y;
	tTex.x*=-1;
	
	outnormal=normal;
	
	View=vecViewPos.xyz-wPos;
}

half2 splitt_float_to_2half(float F)
{
	return half2(floor(F*255.f)/255.f,frac(F*255.f));
}

half3 splitt_float_to_3half(float F)
{
	return half3(floor(F*255.f)/255.f,splitt_float_to_2half(frac(F*255.f)));
}

void PS(	
in float2 Tex	         : TEXCOORD0,			
in float3 View	         : TEXCOORD1,
in float3 normal	      : TEXCOORD2,
in float  Depth         : TEXCOORD3,
in float2 tTex          : TEXCOORD4,

out float4 COL :COLOR0,
out float4 NM  :COLOR1,
out float4 D   :COLOR2
) 
{
	float4 mask =tex2D(MASK_SAMPLER,Tex);
	mask.a=1-mask.a;
	
	float2 tTex1=tTex*matMtl[0].y;
	float2 tTex2=tTex*matMtl[0].z;
	float2 tTex3=tTex*matMtl[0].w;
	float2 tTex4=tTex*matMtl[1].x;
	float2 tTex5=tTex*matMtl[1].y;
	
	float4 col_black=tex2D(C1_SAMPLER,tTex1); col_black.a*=matMtl[1].z;
	float4 col_red  =tex2D(C2_SAMPLER,tTex2); col_red.a*=matMtl[1].w;
	float4 col_green=tex2D(C3_SAMPLER,tTex3); col_green.a*=matMtl[2].x;
	float4 col_blue =tex2D(C4_SAMPLER,tTex4); col_blue.a*=matMtl[2].y;
	float4 col_alpha=tex2D(C5_SAMPLER,tTex5); col_alpha.a*=matMtl[2].z;
	
	float4 nm_black=tex2D(NM1_SAMPLER,tTex1); nm_black.a*=matMtl[2].w;
	float4 nm_red  =tex2D(NM2_SAMPLER,tTex2); nm_red.a*=matMtl[3].x;
	float4 nm_green=tex2D(NM3_SAMPLER,tTex3); nm_green.a*=matMtl[3].y;
	float4 nm_blue =tex2D(NM4_SAMPLER,tTex4); nm_blue.a*=matMtl[3].z;
	float4 nm_alpha=tex2D(NM5_SAMPLER,tTex5); nm_alpha.a*=matMtl[3].w;
	
	float4 col=lerp(col_black,col_red,mask.r);
	col=lerp(col,col_green,mask.g);
	col=lerp(col,col_blue,mask.b);
	col=lerp(col,col_alpha,mask.a);
	
	////////////////////////////////////////////
	
	float4 nm=lerp(nm_black,nm_red,mask.r);
	nm=lerp(nm,nm_green,mask.g);
	nm=lerp(nm,nm_blue,mask.b);
	nm=lerp(nm,nm_alpha,mask.a);
	
	nm.rgb=nm.rbg*2-1;
	nm.r*=-1;
	
	////////////////////////////////////////////
	
	float detail_intens=tex2D(DINTENS_SAMPLER,Tex);
	float4 detail=tex2D(DETAIL_SAMPLER,tTex*2*matMtl[0].x);
	detail.rgb=detail.rbg*2-1;
	detail.r*=-1;
	
	detail.a=0.5+lerp(0.5,detail.a,detail_intens*vecSkill1.w);
	
	float4 global_col=tex2D(COLOR_SAMPLER,Tex);
	
	col.rgb*=min(1,global_col.rgb+1-vecSkill1.x)*detail.a;
	
	float roughness =col.a;
	
	if(vecSkill1.z==0)
	{
		float3 os_nm=tex2D(OSNM_SAMPLER,Tex).rbg*2-1;
		os_nm.b*=-1;
		normal=os_nm;	
	}
	
	normal.rb*=vecSkill1.y;
	normal.rb+=nm.rb*vecSkill45.x+detail.rb*detail_intens*vecSkill1.w;
	normal=mul(normal,matWorld);
	normal=normalize(normal);
	/////////////////////////////////////////////////////////////////////////////
	float3 ViewDir=normalize(View);
	float NV=saturate(dot(ViewDir,normal));
	
	////////////////////////////////////////////////////////////////////
	
	////////////////////////////////////////////////////////////////////
	
	float refindex=lerp(vecSkill41.z,vecSkill41.w,nm.a);
	
	float fresnel=lerp(refindex,1,pow(1-NV,5));//approx. fresnel for specular lighting
	
	roughness=lerp(vecSkill41.x,vecSkill41.y,roughness);
	
	//	roughness=1;
	//	fresnel=1;
	/////////////////////////////////////////////////////////////////////////////
	COL.rgb=col_black.rgb;
	COL.rgb=mask.rgb;
	COL.rgb=col.rgb;
	//	COL.rgb=detail_intens;
	
	COL.a=mask_alpha(global_col.a)*small;
	
	normal=normal*0.5f+0.5f;
	
	NM.xyz=normal.xyz;
	NM.w=fresnel;
	
	D.xyz=splitt_float_to_3half(Depth);
	D.w=roughness;
	
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_3_0 VS();
		PixelShader  = compile ps_3_0 PS();
	}
}
";

STRING* _sMtl_MTBump_Normals="COLOR_SAMPLER;OSNM_SAMPLER;MASK_SAMPLER;DINTENS_SAMPLER;DETAIL_SAMPLER;NULL;NULL;NULL;NULL;NULL;NM1_SAMPLER;NM2_SAMPLER;NM3_SAMPLER;NM4_SAMPLER;NM5_SAMPLER;~

bool AUTORELOAD;

float4 vecSkill1;
float4x4 matMtl;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

float4x4 matWorldViewProj;
float4x4 matWorld;
float4x4 matProj;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4 vecSunDir;		
float4 vecViewPos;
float4 vecViewDir;

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

float get_MtlMask(float mask,float type,float intens)
{
	mask*=intens;
	mask=(1-mask)*step(0.5,type);
	
	type=max(0,(type-0.5)*2);
	mask=lerp(mask*0.5,mask*0.5+0.5+small,type);
	
	return cut_zero(mask);
}

void VS(		
in float4 vPos		   : POSITION,
in float3 normal	   : NORMAL,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,			
out float3 View	      : TEXCOORD1,
out float3 outnormal	   : TEXCOORD2,
out float2 tTex         : TEXCOORD4,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	
	OutTex = InTex;

	float3 wPos = mul(vPos,matWorld);
	
	tTex=vPos.xz*0.01*vecSkill45.y;
	tTex.x*=-1;
	
	outnormal=mul(normal,matWorld);
	
	View=vecViewPos.xyz-wPos;
}

half2 splitt_float_to_2half(float F)
{
	return half2(floor(F*255.f)/255.f,frac(F*255.f));
}

half3 splitt_float_to_3half(float F)
{
	return half3(floor(F*255.f)/255.f,splitt_float_to_2half(frac(F*255.f)));
}

void PS(	
in float2 Tex	         : TEXCOORD0,			
in float3 View	         : TEXCOORD1,
in float3 normal	      : TEXCOORD2,
in float2 tTex          : TEXCOORD4,

out float4 NM  :COLOR0
) 
{
	float4 mask =tex2D(MASK_SAMPLER,Tex);
	mask.a=1-mask.a;
	
	float2 tTex1=tTex*matMtl[0].y;
	float2 tTex2=tTex*matMtl[0].z;
	float2 tTex3=tTex*matMtl[0].w;
	float2 tTex4=tTex*matMtl[1].x;
	float2 tTex5=tTex*matMtl[1].y;
	
	float4 nm_black=tex2D(NM1_SAMPLER,tTex1); nm_black.a*=matMtl[2].w;
	float4 nm_red  =tex2D(NM2_SAMPLER,tTex2); nm_red.a*=matMtl[3].x;
	float4 nm_green=tex2D(NM3_SAMPLER,tTex3); nm_green.a*=matMtl[3].y;
	float4 nm_blue =tex2D(NM4_SAMPLER,tTex4); nm_blue.a*=matMtl[3].z;
	float4 nm_alpha=tex2D(NM5_SAMPLER,tTex5); nm_alpha.a*=matMtl[3].w;
	
	////////////////////////////////////////////
	
	float4 nm=lerp(nm_black,nm_red,mask.r);
	nm=lerp(nm,nm_green,mask.g);
	nm=lerp(nm,nm_blue,mask.b);
	nm=lerp(nm,nm_alpha,mask.a);
	
	nm.rgb=nm.rbg*2-1;
	nm.r*=-1;
	
	////////////////////////////////////////////
	
	float detail_intens=tex2D(DINTENS_SAMPLER,Tex);
	float4 detail=tex2D(DETAIL_SAMPLER,tTex*2*matMtl[0].x);
	detail.rgb=detail.rbg*2-1;
	detail.r*=-1;
	
	float4 global_col=tex2D(COLOR_SAMPLER,Tex);
	
	float3 os_nm=tex2D(OSNM_SAMPLER,Tex).rbg*2-1;
	os_nm.b*=-1;
	
	if(vecSkill1.z==0)
	{
		float3 os_nm=tex2D(OSNM_SAMPLER,Tex).rbg*2-1;
		os_nm.b*=-1;
		normal=os_nm;	
	}
	
	normal.rb*=vecSkill1.y;
	normal.rb+=nm.rb*vecSkill45.x+detail.rb*detail_intens*vecSkill1.w;
	normal=mul(normal,matWorld);
	normal=normalize(normal);
	/////////////////////////////////////////////////////////////////////////////
	float3 ViewDir=normalize(View);
	float NV=saturate(dot(ViewDir,normal));
	
	////////////////////////////////////////////////////////////////////
	
	float refindex=lerp(vecSkill41.z,vecSkill41.w,nm.a);
	
	float fresnel=lerp(refindex,1,pow(1-NV,5));//approx. fresnel for specular lighting

	/////////////////////////////////////////////////////////////////////////////
	
	normal=normal*0.5f+0.5f;
	
	NM.xyz=normal.xyz;
	NM.w=fresnel*mask_alpha(global_col.a);	
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_b PS();
	}
}
";

STRING* _sMtl_MTBump_Color="COLOR_SAMPLER;NULL;MASK_SAMPLER;DINTENS_SAMPLER;DETAIL_SAMPLER;C1_SAMPLER;C2_SAMPLER;C3_SAMPLER;C4_SAMPLER;C5_SAMPLER;~

bool AUTORELOAD;

float4 vecSkill1;
float4x4 matMtl;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

float4x4 matWorldViewProj;
float4x4 matWorld;
float4x4 matProj;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4 vecSunDir;		
float4 vecViewPos;
float4 vecViewDir;

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

float get_MtlMask(float mask,float type,float intens)
{
	mask*=intens;
	mask=(1-mask)*step(0.5,type);
	
	type=max(0,(type-0.5)*2);
	mask=lerp(mask*0.5,mask*0.5+0.5+small,type);
	
	return cut_zero(mask);
}

void VS(		
in float4 vPos		   : POSITION,
in float3 normal	   : NORMAL,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,			
out float2 tTex         : TEXCOORD4,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	OutTex = InTex;

	tTex=vPos.xz*0.01*vecSkill45.y;
	tTex.x*=-1;
}

half2 splitt_float_to_2half(float F)
{
	return half2(floor(F*255.f)/255.f,frac(F*255.f));
}

half3 splitt_float_to_3half(float F)
{
	return half3(floor(F*255.f)/255.f,splitt_float_to_2half(frac(F*255.f)));
}

void PS(	
in float2 Tex	         : TEXCOORD0,			
in float2 tTex          : TEXCOORD4,

out float4 COL :COLOR0
) 
{
	float4 mask =tex2D(MASK_SAMPLER,Tex);
	mask.a=1-mask.a;
	
	float2 tTex1=tTex*matMtl[0].y;
	float2 tTex2=tTex*matMtl[0].z;
	float2 tTex3=tTex*matMtl[0].w;
	float2 tTex4=tTex*matMtl[1].x;
	float2 tTex5=tTex*matMtl[1].y;
	
	float4 col_black=tex2D(C1_SAMPLER,tTex1);
	float4 col_red  =tex2D(C2_SAMPLER,tTex2);
	float4 col_green=tex2D(C3_SAMPLER,tTex3);
	float4 col_blue =tex2D(C4_SAMPLER,tTex4);
	float4 col_alpha=tex2D(C5_SAMPLER,tTex5);

	float4 col=lerp(col_black,col_red,mask.r);
	col=lerp(col,col_green,mask.g);
	col=lerp(col,col_blue,mask.b);
	col=lerp(col,col_alpha,mask.a);
	
	////////////////////////////////////////////
	
	float detail_intens=tex2D(DINTENS_SAMPLER,Tex);
	float4 detail=tex2D(DETAIL_SAMPLER,tTex*2*matMtl[0].x);
	
	detail.a=0.5+lerp(0.5,detail.a,detail_intens*vecSkill1.w);
	
	float4 global_col=tex2D(COLOR_SAMPLER,Tex);
	
	//vecSkill1.x=0.5;
	col.rgb*=min(1,global_col.rgb+1-vecSkill1.x)*detail.a;
	
	COL.rgb=col.rgb;
	COL.a=mask_alpha(global_col.a)*small;
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}
";

STRING* _sMtl_MTBump_Depth="COLOR_SAMPLER;OSNM_SAMPLER;MASK_SAMPLER;NULL;NULL;C1_SAMPLER;C2_SAMPLER;C3_SAMPLER;C4_SAMPLER;C5_SAMPLER;~

bool AUTORELOAD;

float4 vecSkill1;
float4x4 matMtl;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

float4x4 matWorldViewProj;
float4x4 matWorld;
float4x4 matProj;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4 vecSunDir;		
float4 vecViewPos;
float4 vecViewDir;

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

float get_MtlMask(float mask,float type,float intens)
{
	mask*=intens;
	mask=(1-mask)*step(0.5,type);
	
	type=max(0,(type-0.5)*2);
	mask=lerp(mask*0.5,mask*0.5+0.5+small,type);
	
	return cut_zero(mask);
}

void VS(		
in float4 vPos		   : POSITION,
in float3 normal	   : NORMAL,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,			
out float  Depth        : TEXCOORD3,
out float2 tTex         : TEXCOORD4,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	Depth=Pos.w/vecSkill17.x;
	
	OutTex = InTex;

	tTex=vPos.xz*0.01*vecSkill45.y;
	tTex.x*=-1;
	
}

half2 splitt_float_to_2half(float F)
{
	return half2(floor(F*255.f)/255.f,frac(F*255.f));
}

half3 splitt_float_to_3half(float F)
{
	return half3(floor(F*255.f)/255.f,splitt_float_to_2half(frac(F*255.f)));
}

void PS(	
in float2 Tex	         : TEXCOORD0,			
in float  Depth         : TEXCOORD3,
in float2 tTex          : TEXCOORD4,

out float4 D   :COLOR0
) 
{
	float4 mask =tex2D(MASK_SAMPLER,Tex);
	mask.a=1-mask.a;
	
	float2 tTex1=tTex*matMtl[0].y;
	float2 tTex2=tTex*matMtl[0].z;
	float2 tTex3=tTex*matMtl[0].w;
	float2 tTex4=tTex*matMtl[1].x;
	float2 tTex5=tTex*matMtl[1].y;
	
	float4 col_black=tex2D(C1_SAMPLER,tTex1); col_black.a*=matMtl[1].z;
	float4 col_red  =tex2D(C2_SAMPLER,tTex2); col_red.a*=matMtl[1].w;
	float4 col_green=tex2D(C3_SAMPLER,tTex3); col_green.a*=matMtl[2].x;
	float4 col_blue =tex2D(C4_SAMPLER,tTex4); col_blue.a*=matMtl[2].y;
	float4 col_alpha=tex2D(C5_SAMPLER,tTex5); col_alpha.a*=matMtl[2].z;
	
	float4 col=lerp(col_black,col_red,mask.r);
	col=lerp(col,col_green,mask.g);
	col=lerp(col,col_blue,mask.b);
	col=lerp(col,col_alpha,mask.a);
	
	////////////////////////////////////////////
	float4 global_col=tex2D(COLOR_SAMPLER,Tex);
	
	float roughness=lerp(vecSkill41.x,vecSkill41.y,col.a);
	
	/////////////////////////////////////////////////////////////////////////////
	
	D.xyz=splitt_float_to_3half(Depth);
	D.w=roughness*mask_alpha(global_col.a);
	
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_b PS();
	}
}";

STRING* _sMtl_MTBump_VSMDepth="COLOR_SAMPLER;~
bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

float4 vecViewDir;
float4 vecViewPos;

float4x4 matWorldViewProj;
float4x4 matWorld;

void VS(		
in float4 vPos		   : POSITION,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,			
out float  Depth        : TEXCOORD1,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	Depth=dot(vecViewDir,mul(vPos,matWorld) - vecViewPos);
	
	OutTex = InTex;
}


void PS(	
in float2 Tex	         : TEXCOORD0,			
in float  Depth         : TEXCOORD1,

out float4 D   :COLOR0
) 
{
	D=float4(Depth,Depth*Depth,0,1);
	D.w=tex2D(COLOR_SAMPLER,Tex).w;
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}
";

LF_MTL_CONTAINER* _mtlC_MTBumpy=
{
	sMRT=_sMtl_MTBump_MRT;
	sCOL=_sMtl_MTBump_Color;
	sNM=_sMtl_MTBump_Normals;
	sD=_sMtl_MTBump_Depth;
	sVSMD=_sMtl_MTBump_VSMDepth;
	
	lFlags=NULL;
}