
STRING* _sMtl_OSBump_MRT="COLOR_SAMPLER;NM_SAMPLER;R_SAMPLER;F_SAMPLER;~
bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

float4x4 matWorldViewProj;
float4x4 matWorld;
float4x4 matProj;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4 vecSunDir;		
float4 vecViewPos;
float4 vecViewDir;

void VS(		
in float4 vPos		   : POSITION,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,			
out float3 View	      : TEXCOORD1,
out float  Depth        : TEXCOORD3,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	Depth=Pos.w/vecSkill17.x;
	
	OutTex = InTex*vecSkill45.y;

	float3 wPos = mul(vPos,matWorld);
	
	View=vecViewPos.xyz-wPos;
}

half2 splitt_float_to_2half(float F)
{
	return half2(floor(F*255.f)/255.f,frac(F*255.f));
}

half3 splitt_float_to_3half(float F)
{
	return half3(floor(F*255.f)/255.f,splitt_float_to_2half(frac(F*255.f)));
}

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

float get_MtlMask(float mask,float type,float intens)
{
	mask*=intens;
	mask=(1-mask)*step(0.5,type);
	
	type=max(0,(type-0.5)*2);
	mask=lerp(mask*0.5,mask*0.5+0.5+small,type);
	
	return cut_zero(mask);
}

void PS(	
in float2 Tex	         : TEXCOORD0,			
in float3 View	         : TEXCOORD1,
in float  Depth         : TEXCOORD3,

out float4 COL :COLOR0,
out float4 NM  :COLOR1,
out float4 D   :COLOR2
) 
{
	COL =tex2D(COLOR_SAMPLER,Tex);
	COL.a=mask_alpha(COL.a);
	
	float roughness =tex2D(R_SAMPLER,Tex).r;
	//	COL =1;
	float3 normal=normalize(tex2D(NM_SAMPLER,Tex)*2-1);
	normal.b*=-1;
	
	normal=mul(normal,matWorld);
	/////////////////////////////////////////////////////////////////////////////
	float3 ViewDir=normalize(View);
	float NV=saturate(dot(ViewDir,normal));
	
	////////////////////////////////////////////////////////////////////
	float4 fsampler=tex2D(F_SAMPLER,Tex);
	
	COL.a=get_MtlMask(fsampler.a,int(vecSkill45.z)*0.5,frac(vecSkill45.z)*10)*COL.a;

	////////////////////////////////////////////////////////////////////
	
	float refindex=lerp(vecSkill41.z,vecSkill41.w,fsampler.r);
	
	float fresnel=lerp(refindex,1+(1-refindex),pow(1-NV,5))*0.5f;//approx. fresnel for specular lighting
	
	roughness=lerp(vecSkill41.x,vecSkill41.y,roughness);
	/////////////////////////////////////////////////////////////////////////////
	
	normal=normal*0.5f+0.5f;
	
	NM.xyz=normal.xyz;
	NM.w=fresnel;
	
	D.xyz=splitt_float_to_3half(Depth);
	D.w=roughness;
	
	//	COL.a=small;
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}
";

STRING* _sMtl_OSBump_Normals_t="COLOR_SAMPLER;NM_SAMPLER;NULL;F_SAMPLER;~
bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4x4 matWorldViewProj;
float4x4 matWorld;

float4 vecViewPos;

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

void VS(		
in float4 vPos		   : POSITION,
in float2 InTex	   : TEXCOORD0,
in float4 InTangent	: TEXCOORD2,

out float2 OutTex	      : TEXCOORD1,
out float3 View	      : TEXCOORD2,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	OutTex = InTex*vecSkill45.y;

	float3 wPos = mul(vPos,matWorld);
	
	View=vecViewPos.xyz-wPos;
}

void PS(	
in float2 Tex	         : TEXCOORD1,
in float3 View	         : TEXCOORD2,

out float4 NM  :COLOR0
) 
{
	float A=tex2D(COLOR_SAMPLER,Tex).a;A=1;
	A=mask_alpha(A);
	
	float3 normal=normalize(tex2D(NM_SAMPLER,Tex)*2-1);
	normal.b*=-1;
	
	normal=mul(normal,matWorld);
	
	/////////////////////////////////////////////////////////////////////////////
	float3 ViewDir=normalize(View);
	float NV=saturate(dot(ViewDir,normal));
	
	float refindex=tex2D(F_SAMPLER,Tex).r;
	refindex=lerp(vecSkill41.z,vecSkill41.w,refindex);
	
	float fresnel=lerp(refindex,1+(1-refindex),pow(1-NV,5))*0.5f;//approx. fresnel for specular lighting
	/////////////////////////////////////////////////////////////////////////////
	normal=normal*0.5f+0.5f;
	
	NM.xyz=normal.xyz;
	
	NM.w=cut_zero(fresnel)*A;
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}
";

LF_MTL_CONTAINER* _mtlC_OSBumpy_t=
{
	sMRT=_sMtl_OSBump_MRT;
	sCOL=_sMtl_Bump_Color;
	sNM=_sMtl_OSBump_Normals_t;
	sD=_sMtl_Bump_Depth_t;
	sVSMD=_sMtl_Bump_VSMDepth_t;
	
	lFlags=NULL;
}

STRING* _sMtl_OSBump_Normals="NULL;NM_SAMPLER;NULL;F_SAMPLER;~
bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4x4 matWorldViewProj;
float4x4 matWorld;

float4 vecViewPos;

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

void VS(		
in float4 vPos		   : POSITION,
in float2 InTex	   : TEXCOORD0,
in float4 InTangent	: TEXCOORD2,

out float2 OutTex	      : TEXCOORD1,
out float3 View	      : TEXCOORD2,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	OutTex = InTex*vecSkill45.y;

	float3 wPos = mul(vPos,matWorld);
	
	View=vecViewPos.xyz-wPos;
}

void PS(	
in float2 Tex	         : TEXCOORD1,
in float3 View	         : TEXCOORD2,

out float4 NM  :COLOR0
) 
{	
	float3 normal=normalize(tex2D(NM_SAMPLER,Tex)*2-1);
	normal.b*=-1;
	
	normal=mul(normal,matWorld);
	
	/////////////////////////////////////////////////////////////////////////////
	float3 ViewDir=normalize(View);
	float NV=saturate(dot(ViewDir,normal));
	
	float refindex=tex2D(F_SAMPLER,Tex).r;
	refindex=lerp(vecSkill41.z,vecSkill41.w,refindex);
	
	float fresnel=lerp(refindex,1+(1-refindex),pow(1-NV,5))*0.5f;//approx. fresnel for specular lighting
	/////////////////////////////////////////////////////////////////////////////
	normal=normal*0.5f+0.5f;
	
	NM.xyz=normal.xyz;
	
	NM.w=cut_zero(fresnel);
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}
";

LF_MTL_CONTAINER* _mtlC_OSBumpy=
{
	sMRT=_sMtl_OSBump_MRT;
	sCOL=_sMtl_Bump_Color;
	sNM=_sMtl_OSBump_Normals;
	sD=_sMtl_Bump_Depth;
	sVSMD=_sMtl_Bump_VSMDepth;
	
	lFlags=NULL;
}