
void init_sync_views(VIEW* vwSync_,VIEW* vwTarget_)
{
	vwSync_->clip_near=vwTarget_->clip_near;
	vwSync_->clip_far=vwTarget_->clip_far;
	vwSync_->arc=vwTarget_->arc;
	vwSync_->aspect=vwTarget_->aspect;
}

void sync_views(VIEW* vwSync_,VIEW* vwTarget_)
{
	proc_mode=PROC_LATE;
	
	if(vwSync_!=NULL && vwTarget_!=NULL)
	init_sync_views(vwSync_,vwTarget_);
	
	while(vwSync_!=NULL && vwTarget_!=NULL)
	{
		if(!is(vwSync_,SHOW) || !is(vwTarget_,SHOW))return;
		
		vec_set(vwSync_->x,vwTarget_->x);
		vec_set(vwSync_->pan,vwTarget_->pan);		
		
		wait(1);
	}
}

void ent_transform_pos(ENTITY* eEnt_,VECTOR* vcAngle_,VECTOR* vcOffset_)
{
	VECTOR vcTemp;
	
	vec_set(vcTemp,eEnt_->x);
	vec_rotate(vcTemp,vcAngle_);
	vec_set(eEnt_->x,vcTemp);
	
	vec_add(eEnt_->pan,vcAngle_);
	vec_add(eEnt_->x,vcOffset_);
}

void LF_LIGHT_transform_pos(LF_LIGHT* litLight_,VECTOR* vcAngle_,VECTOR* vcOffset_)
{
	VECTOR vcTemp;
	
	vec_set(vcTemp,litLight_->vcLightPos);
	vec_rotate(vcTemp,vcAngle_);
	vec_set(litLight_->vcLightPos,vcTemp);
	
	vec_add(litLight_->aLightAng,vcAngle_);
	vec_add(litLight_->vcLightPos,vcOffset_);
}

BMAP* _bZBuffer;
void init_zbuffer(var vZBwidth_,var vZBheight_)
{
	if(_bZBuffer!=NULL)
	ptr_remove(_bZBuffer);
	
	_bZBuffer = bmap_createblack(vZBwidth_,vZBheight_,24);
	bmap_zbuffer(_bZBuffer);	
}

void update_zbuffer(var vSM_Resolution_)
{
	var vZBwidth=bmap_width(_bZBuffer);
	var vZBheight=bmap_height(_bZBuffer);
	
	if(vZBwidth<vSM_Resolution_ || vZBheight<vSM_Resolution_)
	init_zbuffer(maxv(vZBwidth,vSM_Resolution_),maxv(vZBheight,vSM_Resolution_));
}

void init_zbuffer_startup()
{
	if(_bZBuffer!=NULL)
	ptr_remove(_bZBuffer);
	
	_bZBuffer = bmap_createblack(screen_size.x, screen_size.y,24);
	bmap_zbuffer(_bZBuffer);	
}

void change_to_highes_resolution()
{
	video_switch(12,0,1);
	wait(2);
	video_set(sys_metrics(0),sys_metrics(1),0,1);
}

void place_down(ENTITY* eEnt_)
{
	VECTOR vcTemp1,vcTemp2,vcTemp3;
	vec_zero(vcTemp1);
	vec_zero(vcTemp2);
	vec_zero(vcTemp3);
	
	c_setminmax(eEnt_);
	wait(1);
	
	vec_set(vcTemp1,eEnt_->x);
	vec_set(vcTemp2,eEnt_->x);
	vcTemp2.z-=5000;
	
	result=c_trace(vcTemp1,vcTemp2,USE_POLYGON + IGNORE_PASSABLE);
	
	if(result>0)
	{
		vec_set(eEnt_->x,target.x);
		eEnt_->z-=eEnt_->min_z;
	}
}

int cone_check(VIEW* vwView_,VECTOR* vcSpPos,var vSpRadius_,var vConeApAng)
{
	VECTOR vcTemp1,vcTemp2,vcTemp3;
	vec_zero(vcTemp1);
	vec_zero(vcTemp2);
	vec_zero(vcTemp3);
	
	var vTemp1=0;
	var vTemp2=0;
	var vTemp3=0;
	
	vec_for_angle(vcTemp1,vwView_->pan);
	vec_diff(vcTemp2,vcSpPos,vwView_->x);
	
	vTemp1=vec_dot(vcTemp1,vcTemp2);
	
	vec_set(vcTemp3,vwView_->x);
	vec_scale(vcTemp1,vTemp1);
	vec_add(vcTemp3,vcTemp1);
	
	vec_diff(vcTemp1,vcSpPos,vcTemp3);
	vTemp2=vec_length(vcTemp1);
	
	vTemp1=tanv(vConeApAng)*vTemp1;
	
	return (vTemp2-vTemp1>vSpRadius_);
}

var get_ConeApAng(VIEW* vwView_)
{
	return atanv( sqrt(2) * tanv(camera->arc*0.5) );
}

var sqrt2(var x)
{
	return sqrt(abs(x));
}

var round(var x)
{
	return integer(x+0.5*sign(x));
}

double round(float x)
{
	return integer(x+(double)0.5*sign(x));
}