
void LF_switch_LightingMode(VIEW* vwView_);
void LF_switch_AccFormat(VIEW* vwView_);
void LF_remove_pipeline(VIEW* vwView_);
void LF_switch_RTresolution(VIEW* vwView_);
void LF_init_AttenuationMaps(var vAttS_PL_,var vAttS_SL_);
void LF_switch_NormalFormat(VIEW* vwView_);
void LF_test_LightIntersection(VIEW* vwView_);

void LF_init_pipeline(VIEW* vwView_)
{
	if(vwView_->skill_y!=0)
	return;
	
	int iRenderTargetSizeX=vwView_->size_x;
	int iRenderTargetSizeY=vwView_->size_y;
	
	if(vwView_->size_x<=0 || vwView_->size_x>screen_size.x || vwView_->size_y<=0 || vwView_->size_y>screen_size.y)
	{
		iRenderTargetSizeX=screen_size.x;
		iRenderTargetSizeY=screen_size.y;
	}
	
	BMAP* bRT_Color=bmap_createblack(iRenderTargetSizeX,iRenderTargetSizeY,32);
	
	vwView_->skill_x=0;
	vwView_->bmap=bRT_Color;
	
	BMAP* bRT_Depth_Buffer=bmap_createblack(iRenderTargetSizeX,iRenderTargetSizeY,32);
	
	BMAP* bRT_Normal_Buffer;
	if(_vLF_NormalFormat==0 || _iFP_Support==0)
	{
		_vLF_NormalFormat=0;
		bRT_Normal_Buffer=bmap_createblack(iRenderTargetSizeX,iRenderTargetSizeY,32);
	}
	else
	{
		bRT_Normal_Buffer=bmap_createblack(iRenderTargetSizeX,iRenderTargetSizeY,12222);
	}

	VIEW* vwRenderNormals=view_create(0);
	vwRenderNormals->skill_x=2;
	vwRenderNormals->size_x=iRenderTargetSizeX;
	vwRenderNormals->size_y=iRenderTargetSizeY;
	//	vwRenderNormals->pos_x=vwView_->pos_x;
	//	vwRenderNormals->pos_y=vwView_->pos_y;
	
	VIEW* vwRenderDepth=view_create(0);
	vwRenderDepth->skill_x=3;
	vwRenderDepth->size_x=iRenderTargetSizeX;
	vwRenderDepth->size_y=iRenderTargetSizeY;
	
	if(_vLF_LightingMode==0 && _iRT_Support==1)
	{
		vwView_->target1=bRT_Normal_Buffer;
		vwView_->target2=bRT_Depth_Buffer;		
	}
	else
	{
		_vLF_LightingMode=1;
		
		set(vwRenderNormals,SHOW);
		vwRenderNormals->bmap=bRT_Normal_Buffer;
		
		set(vwRenderDepth,SHOW);
		vwRenderDepth->bmap=bRT_Depth_Buffer;
		
		sync_views(vwRenderNormals,vwView_);
		sync_views(vwRenderDepth,vwView_);
	}
	
	VIEW* vwRenderLights=view_create(0);
	set(vwRenderLights,SHOW);
	vwRenderLights->skill_x=1;
	vwRenderLights->size_x=iRenderTargetSizeX;
	vwRenderLights->size_y=iRenderTargetSizeY;
	
	sync_views(vwRenderLights,vwView_);
	
	vwView_->stage=vwRenderLights;
	
	///////////////////////////////////////save view pointers in a closed skill chain
	vwRenderNormals->skill_y=vwView_;
	vwRenderDepth->skill_y=vwRenderNormals;
	vwRenderLights->skill_y=vwRenderDepth;		

	vwView_->skill_y=vwRenderLights;
	
	///////////////////////////////////////////
	BMAP* bRT_LightAcc;
	if(_vLF_AccFormat==0 || _iFP_Support==0)
	{
		_vLF_AccFormat=0;
		bRT_LightAcc=bmap_createblack(iRenderTargetSizeX,iRenderTargetSizeY,32);
	}
	else
	{
		bRT_LightAcc=bmap_createblack(iRenderTargetSizeX,iRenderTargetSizeY,12222);
	}
	
	vwRenderLights->bmap=bRT_LightAcc;
	
	///////////////////////////////////////////	
	MATERIAL* mtlDeferredLightingPP;
	
	if(_vLF_LightingMode==0 && _iRT_Support==1)
	mtlDeferredLightingPP=PP_newMtl("ppFX_DeferredLighting.fx",bRT_Color,vwRenderLights->bmap,bRT_Normal_Buffer,NULL);
	else
	mtlDeferredLightingPP=PP_newMtl("ppFX_DeferredLighting_noMRT.fx",bRT_Color,vwRenderLights->bmap,bRT_Normal_Buffer,NULL);
	
	PP_Add(mtlDeferredLightingPP,vwView_,NULL,NULL,NULL,NULL);	
	
	/////////////////////////initialize flags
	LF_PIPE_SETT* psSettings=LF_PIPE_SETT_new();
	
	mtlDeferredLightingPP->skill1=floatv(1);//tonmapper fac
	
	VIEW* vwDeferred=vwRenderLights->stage;
	vwDeferred->skill_y=psSettings;
	
	///////////////////////////////////////////	
	
	LF_switch_LightingMode(vwView_);
	LF_switch_AccFormat(vwView_);
	LF_switch_NormalFormat(vwView_);
	LF_switch_RTresolution(vwView_);
	LF_test_LightIntersection(vwView_);
}

VIEW* LF_get_DeferredView(VIEW* vwView_)
{
	VIEW* vwRenderLights;
	
	vwRenderLights=vwView_->skill_y;
	return vwRenderLights->stage;	
}

void LF_set_AmbientLight(VIEW* vwView_,VECTOR* vcAmbColor_,var vAmbIntens_)
{
	if(vwView_->skill_y==0)
	return;
	
	VIEW* vwDeferred=LF_get_DeferredView(vwView_);
	LF_PIPE_SETT* psSettings=vwDeferred->skill_y;
	///////////////////////////////////
	psSettings->cAmbLightCol.red=vcAmbColor_->x;
	psSettings->cAmbLightCol.green=vcAmbColor_->y;
	psSettings->cAmbLightCol.blue=vcAmbColor_->z;
	psSettings->vAmbLightFac=vAmbIntens_;

	vwDeferred->material->skill5=floatv(vcAmbColor_->x);
	vwDeferred->material->skill6=floatv(vcAmbColor_->y);
	vwDeferred->material->skill7=floatv(vcAmbColor_->z);
	vwDeferred->material->skill8=floatv(vAmbIntens_);
}

void LF_set_TonemappingFactor(VIEW* vwView_,var vToneFac_)
{
	if(vwView_->skill_y==0)
	return;
	
	VIEW* vwDeferred=LF_get_DeferredView(vwView_);
	LF_PIPE_SETT* psSettings=vwDeferred->skill_y;
	///////////////////////////////////
	psSettings->vToneMapperFac=vToneFac_;
	
	vwDeferred->material->skill1=floatv(vToneFac_);
}

void LF_test_LightIntersection(VIEW* vwView_)
{
	VECTOR vcTemp1,vcTemp2,vcTemp3;
	vec_zero(vcTemp1);
	vec_zero(vcTemp2);
	vec_zero(vcTemp3);
	
	int i,j,k;
	
	var vConeApAng=get_ConeApAng(vwView_);
	var vViewArc_old=vwView_->arc;
	((VIEW*)(vwView_->skill_y))->fog_start=vConeApAng-vwView_->clip_near;
	
	while(vwView_!=NULL)
	{
		if(vwView_->skill_y==0)
		return;
		
		if(vViewArc_old!=vwView_->arc)
		{
			vConeApAng=get_ConeApAng(vwView_);
			vwView_->fog_start=vConeApAng-vwView_->clip_near;
		}
		
		for(i=0;i<_iAllLights_Count;i++)		
		{
			LF_LIGHT* litLight=_litAllLights[i];
			
			if(litLight->bShadowMap==NULL || litLight->eLight->skill21==2)
			continue;
			
			vec_fill(vcTemp1,litLight->vLightRange);
			vec_fill(vcTemp2,litLight->vLightRange);
			vec_scale(vcTemp2,-1);

			vec_add(vcTemp1,litLight->vcLightPos);
			vec_add(vcTemp2,litLight->vcLightPos);
			//		draw_box3d(vcTemp1,vcTemp2,vector(255,255,255),100);
			
			if(cone_check(vwView_,litLight->vcLightPos,litLight->vLightRange,vConeApAng))
			{
				if(is(litLight->vwShadowView,SHOW))
				reset_VSMRendering(litLight);
			}
			else
			{
				if(!is(litLight->vwShadowView,SHOW))
				set_VSMRendering(litLight);
			}
		}
		
		vViewArc_old=vwView_->arc;
		
		wait(1);
	}
}

void LF_remove_glow(VIEW* vwView_,int iCurrLightingMode_)
{
	if(vwView_->skill_y==0)
	return;
	
	VIEW* vwRenderLights;
	VIEW* vwDeferred;
	
	vwRenderLights=vwView_->skill_y;
	vwDeferred=vwRenderLights->stage;
	
	LF_PIPE_SETT* psSettings=vwDeferred->skill_y;
	psSettings->iGlow=0;
	
	if(vwDeferred->stage==NULL)return;
	
	//remove glowmask part first but not the skin1 ptr
	if(iCurrLightingMode_==1)
	{
		VIEW* vwGMaskPP=vwDeferred->stage;
		
		ptr_remove(vwGMaskPP->bmap);
		vwGMaskPP->bmap=NULL;
		
		ptr_remove(vwGMaskPP->material->skin2);
		vwGMaskPP->material->skin2=NULL;
		
		ptr_remove(vwGMaskPP->material);
		vwGMaskPP->material=NULL;
		
		vwDeferred->stage=vwGMaskPP->stage;
		
		ptr_remove(vwGMaskPP);
		vwGMaskPP=NULL;
	}
	
	PP_Remove_All(vwDeferred,1);
}

void LF_add_glow(VIEW* vwView_,var vBBound_,var vCPow_)
{
	if(vwView_->skill_y==0)
	return;
	
	int iRenderTargetSizeX=vwView_->size_x;
	int iRenderTargetSizeY=vwView_->size_y;
	
	if(vwView_->size_x<=0 || vwView_->size_x>screen_size.x || vwView_->size_y<=0 || vwView_->size_y>screen_size.y)
	{
		iRenderTargetSizeX=screen_size.x;
		iRenderTargetSizeY=screen_size.y;
	}
	
	VIEW* vwRenderLights;
	VIEW* vwDeferred;
	
	vwRenderLights=vwView_->skill_y;
	vwDeferred=vwRenderLights->stage;
	
	LF_PIPE_SETT* psSettings=vwDeferred->skill_y;
	
	if(vwDeferred->stage==NULL)
	{
		BMAP* bRT_LColor=bmap_createblack(iRenderTargetSizeX,iRenderTargetSizeY,32);
		BMAP* bRT_GMask=bmap_createblack(iRenderTargetSizeX,iRenderTargetSizeY,32);
		BMAP* bRT_GMask2=bmap_createblack(iRenderTargetSizeX,iRenderTargetSizeY,32);
		
		//		PP_Add(mtlDeferredLightingPP,vwView_,bRT_LColor,bRT_GMask,NULL,NULL);	
		
		vwDeferred->bmap=bRT_LColor;
		
		if(_vLF_LightingMode==0 && _iRT_Support==1)
		{
			vwDeferred->target1=bRT_GMask;
			vwDeferred->material->skill2=floatv(vBBound_);
		}
		else
		{
			_vLF_LightingMode=1;
			
			MATERIAL* mtlGMask=PP_newMtl("ppFX_GMask.fx",vwDeferred->material->skin1,bRT_LColor,NULL,NULL);
			PP_Add(mtlGMask,vwView_,bRT_GMask,NULL,NULL,NULL);	
			
			mtlGMask->skill2=floatv(vBBound_);
		}
		
		////////////////	
		
		MATERIAL* mtlDownPP=PP_newMtl("PP_downRGBA.fx",bRT_GMask,NULL,NULL,NULL);
		MATERIAL* mtlDown2PP=PP_newMtl("PP_downRGBA.fx",bRT_GMask2,NULL,NULL,NULL);
		
		PP_Add(mtlDownPP,vwView_,bRT_GMask2,NULL,NULL,NULL);
		PP_Add(mtlDown2PP,vwView_,bRT_GMask,NULL,NULL,NULL);
		PP_Add(mtlDownPP,vwView_,bRT_GMask2,NULL,NULL,NULL);
		//		PP_Add(mtlDownPP,vwView_,bRT_GMask,NULL,NULL,NULL);
		
		MATERIAL* mtlGaussX1PP=PP_newMtl("PP_GaussX_FX.fx",bRT_GMask2,NULL,NULL,NULL);
		mtlGaussX1PP->skill1=floatv(1);
		PP_Add(mtlGaussX1PP,vwView_,bRT_GMask,NULL,NULL,NULL);
		
		MATERIAL* mtlGaussY1PP=PP_newMtl("PP_GaussY_FX.fx",bRT_GMask,NULL,NULL,NULL);
		mtlGaussY1PP->skill1=floatv(1);
		PP_Add(mtlGaussY1PP,vwView_,bRT_GMask2,NULL,NULL,NULL);
		
		MATERIAL* mtlFinalPP=PP_newMtl("ppFX_Final.fx",bRT_LColor,bRT_GMask2,NULL,NULL);
		PP_Add(mtlFinalPP,vwView_,NULL,NULL,NULL,NULL);	
		
		mtlFinalPP->skill1=floatv(vCPow_);
		
		psSettings->iGlow=1;
		psSettings->vGlowBBound=vBBound_;
		psSettings->vGlowCovPow=vCPow_;
	}
}

void LF_add_glow(VIEW* vwView_)
{
	if(vwView_->skill_y==0)
	return;
	
	VIEW* vwRenderLights;
	VIEW* vwDeferred;
	
	vwRenderLights=vwView_->skill_y;
	vwDeferred=vwRenderLights->stage;
	
	LF_PIPE_SETT* psSettings=vwDeferred->skill_y;
	
	LF_add_glow(vwView_,psSettings->vGlowBBound,psSettings->vGlowCovPow);
}

void LF_switch_NormalFormat(VIEW* vwView_)
{
	proc_mode=PROC_LATE;
	
	int iLF_NormalFormat_last=_vLF_NormalFormat;
	
	VIEW* vwRenderNormals;
	VIEW* vwRenderDepth;
	VIEW* vwRenderLights;
	
	vwRenderLights=vwView_->skill_y;
	vwRenderDepth=vwRenderLights->skill_y;
	vwRenderNormals=vwRenderDepth->skill_y;
	
	int iRenderTargetSizeX;
	int iRenderTargetSizeY;
	
	while(vwView_!=NULL)
	{
		if(vwView_->skill_y==0)return;
		
		if(iLF_NormalFormat_last!=_vLF_NormalFormat)
		{
			BMAP** bNormalBufferPtr;
			
			if(_vLF_LightingMode==0)
			{
				bNormalBufferPtr=&(vwView_->target1);
			}
			else
			{
				bNormalBufferPtr=&(vwRenderNormals->bmap);
			}
			
			if(_vLF_NormalFormat==1)
			bmap_to_format(*bNormalBufferPtr,12222);
			else
			bmap_to_format(*bNormalBufferPtr,32);
		}
		
		iLF_NormalFormat_last=_vLF_NormalFormat;
		
		wait(1);
	}
}

void LF_toggle_NormalFormat()
{
	_vLF_NormalFormat=1-_vLF_NormalFormat;
}

void LF_switch_AccFormat(VIEW* vwView_)
{
	proc_mode=PROC_LATE;
	
	int iLF_AccFormat_last=_vLF_AccFormat;
	
	VIEW* vwRenderLights;
	vwRenderLights=vwView_->skill_y;
	
	int iRenderTargetSizeX;
	int iRenderTargetSizeY;
	
	while(vwView_!=NULL)
	{
		if(vwView_->skill_y==0)return;
		
		if(_vLF_AccFormat!=iLF_AccFormat_last)
		{
			BMAP** bAccBufferPtr=&(vwRenderLights->bmap);
			
			if(_vLF_AccFormat==1)
			bmap_to_format(*bAccBufferPtr,12222);
			else
			bmap_to_format(*bAccBufferPtr,32);
		}
		
		iLF_AccFormat_last=_vLF_AccFormat;
		
		wait(1);
	}
}

void LF_toggle_AccFormat()
{
	_vLF_AccFormat=1-_vLF_AccFormat;
}

void LF_switch_LightingMode(VIEW* vwView_)
{
	proc_mode=PROC_LATE;
	
	int iLF_LightingMode_last=_vLF_LightingMode;
	
	VIEW* vwRenderNormals;
	VIEW* vwRenderDepth;
	VIEW* vwRenderLights;
	VIEW* vwDeferred;
	
	vwRenderLights=vwView_->skill_y;
	vwRenderDepth=vwRenderLights->skill_y;
	vwRenderNormals=vwRenderDepth->skill_y;
	
	vwDeferred=vwRenderLights->stage;
	
	LF_PIPE_SETT* psSettings=vwDeferred->skill_y;
	LF_PIPE_SETT* psSettingsSave=LF_PIPE_SETT_new();
	
	while(vwView_!=NULL)
	{
		if(vwView_->skill_y==0)return;
		
		if(_vLF_LightingMode!=iLF_LightingMode_last)
		{
			LF_PIPE_SETT_cpy(psSettingsSave,psSettings);
			LF_remove_glow(vwView_,iLF_LightingMode_last);
			
			if(_vLF_LightingMode==0 && _iRT_Support==1)
			{
				vwView_->target1=vwRenderNormals->bmap;
				vwView_->target2=vwRenderDepth->bmap;
				
				reset(vwRenderNormals,SHOW);
				reset(vwRenderDepth,SHOW);
				
				vwRenderNormals->bmap=NULL;
				vwRenderDepth->bmap=NULL;
				
				effect_load(vwDeferred->material,"ppFX_DeferredLighting.fx");
			}
			else
			{
				_vLF_LightingMode=1;
				
				vwRenderNormals->bmap=vwView_->target1;
				vwRenderDepth->bmap=vwView_->target2;
				
				set(vwRenderNormals,SHOW);
				set(vwRenderDepth,SHOW);
				
				vwView_->target1=NULL;
				vwView_->target2=NULL;
				
				sync_views(vwRenderNormals,vwView_);
				sync_views(vwRenderDepth,vwView_);
				
				effect_load(vwDeferred->material,"ppFX_DeferredLighting_noMRT.fx");
			}

			LF_PIPE_SETT_cpy(psSettings,psSettingsSave);

			if(psSettings->iGlow==1)
			LF_add_glow(vwView_);
		}
		
		iLF_LightingMode_last=_vLF_LightingMode;
		
		wait(1);
	}
}

void LF_toggle_LightingMode()
{
	_vLF_LightingMode=1-_vLF_LightingMode;
}

void LF_switch_RTresolution(VIEW* vwView_)
{
	int iChange=0;
	
	proc_mode=PROC_LATE;
	
	////////////////////////////////////////////////////////////////
	int iVideoScreen_last=video_screen;
	int iRenderTargetSizeX_last=vwView_->size_x;
	int iRenderTargetSizeY_last=vwView_->size_y;
	
	if(vwView_->size_x<=0 || vwView_->size_x>screen_size.x || vwView_->size_y<=0 || vwView_->size_y>screen_size.y)
	{
		iRenderTargetSizeX_last=screen_size.x;
		iRenderTargetSizeY_last=screen_size.y;
	}
	////////////////////////////////////////////////////////////////
	
	VIEW* vwDeferred;
	VIEW* vwRenderLights;
	
	vwRenderLights=vwView_->skill_y;
	vwDeferred=vwRenderLights->stage;
	
	LF_PIPE_SETT* psSettings=vwDeferred->skill_y;
	LF_PIPE_SETT* psSettingsSave=LF_PIPE_SETT_new();
	
	while(vwView_!=NULL)
	{
		if(vwView_->skill_y==0)break;
		
		iChange=0;
		
		if(vwView_->size_x<=0 || vwView_->size_x>screen_size.x || vwView_->size_y<=0 || vwView_->size_y>screen_size.y)
		{
			if(iRenderTargetSizeX_last!=screen_size.x || iRenderTargetSizeY_last!=screen_size.y)
			iChange=1;
		}
		else
		{
			if(iRenderTargetSizeX_last!=vwView_->size_x || iRenderTargetSizeY_last!=vwView_->size_y)
			iChange=1;
		}
		////////////////////////////////////////////////////////////////
		
		if(iChange==1 || (iVideoScreen_last!=video_screen))
		{
			LF_PIPE_SETT_cpy(psSettingsSave,psSettings);
			
			////////////////////////////////////////////////////////////////
			init_zbuffer_startup();
			
			LF_remove_pipeline(vwView_);
			
			wait(2);
			LF_init_pipeline(vwView_);
			
			wait(2);
			LF_init_AttenuationMaps(7,5);
			
			///////////////////////////////////////////			
			vwRenderLights=vwView_->skill_y;
			vwDeferred=vwRenderLights->stage;
			
			LF_PIPE_SETT* psSettingsNew=vwDeferred->skill_y;
			LF_PIPE_SETT_cpy(psSettingsNew,psSettingsSave);
			
			LF_set_AmbientLight(vwView_,psSettingsNew->cAmbLightCol,psSettingsNew->vAmbLightFac);
			LF_set_TonemappingFactor(vwView_,psSettingsNew->vToneMapperFac);
			
			if(psSettingsSave->iGlow==1)
			LF_add_glow(vwView_);
		}
		
		////////////////////////////////////////////////////////////////
		iVideoScreen_last=video_screen;
		iRenderTargetSizeX_last=vwView_->size_x;
		iRenderTargetSizeY_last=vwView_->size_y;
		
		if(vwView_->size_x<=0 || vwView_->size_x>screen_size.x || vwView_->size_y<=0 || vwView_->size_y>screen_size.y)
		{
			iRenderTargetSizeX_last=screen_size.x;
			iRenderTargetSizeY_last=screen_size.y;
		}
		////////////////////////////////////////////////////////////////
		
		wait(1);
	}
}

void LF_remove_pipeline(VIEW* vwView_)
{
	if(vwView_->skill_y==0)
	return;
	
	VIEW* vwRenderNormals;
	VIEW* vwRenderDepth;
	VIEW* vwRenderLights;
	
	vwRenderLights=vwView_->skill_y;
	vwRenderDepth=vwRenderLights->skill_y;
	vwRenderNormals=vwRenderDepth->skill_y;
	
	VIEW* vwDeferred=vwRenderLights->stage;
	LF_PIPE_SETT* psSettings=vwDeferred->skill_y;
	
	LF_remove_glow(vwView_,_vLF_LightingMode);//remove the glow part from the end of the chain first
	LF_PIPE_SETT_remove(psSettings);
	
	//////////////////////////////////////	
	////////////////////////////////BMAPs
	ptr_remove(vwView_->bmap);
	vwView_->bmap=NULL;
	
	if(_vLF_LightingMode==0)
	{
		ptr_remove(vwView_->target1);
		vwView_->target1=NULL;
		
		ptr_remove(vwView_->target2);
		vwView_->target2=NULL;
	}
	else
	{
		ptr_remove(vwRenderNormals->bmap);
		vwRenderNormals->bmap=NULL;
		
		ptr_remove(vwRenderDepth->bmap);
		vwRenderDepth->bmap=NULL;
	}
	
	ptr_remove(vwRenderLights->bmap);
	vwRenderLights->bmap=NULL;
	
	////////////////////////////////MATERIALs
	ptr_remove(vwDeferred->material);
	
	////////////////////////////////VIEWs
	vwRenderDepth->skill_y=0;
	vwRenderLights->skill_y=0;
	vwView_->skill_y=0;
	
	reset(vwRenderNormals,SHOW);
	reset(vwRenderDepth,SHOW);
	reset(vwRenderLights,SHOW);
	
	vwRenderLights->stage=NULL;
	ptr_remove(vwDeferred);
	
	vwView_->stage=NULL;
	ptr_remove(vwRenderLights);
	
	ptr_remove(vwRenderNormals);
	ptr_remove(vwRenderDepth);		
}

void LF_create_AttenuationMap(var vAttS_,BMAP** bAttMap_)
{
	VIEW* vwTemp=view_create(0);
	set(vwTemp,PROCESS_TARGET|SHOW);
	
	vwTemp.size_x=512;
	vwTemp.size_y=512;
	
	if(_iFP_Support!=0)
	*bAttMap_=bmap_createblack(512,1,12);
	else
	*bAttMap_=bmap_createblack(512,1,24);
	
	vwTemp->material=_mtlLF_AttenuationMap_PP;
	vwTemp->material->skill1=floatv(vAttS_);
	
	vwTemp->bmap=*bAttMap_;
	
	wait(1);
	
	ptr_remove(vwTemp);
}

void LF_init_AttenuationMaps(var vAttS_PL_,var vAttS_SL_)
{
	if(_bAttenuationMap_PL!=NULL)
	ptr_remove(_bAttenuationMap_PL);
	
	if(_bAttenuationMap_SL!=NULL)
	ptr_remove(_bAttenuationMap_SL);
	
	LF_create_AttenuationMap(vAttS_PL_,&_bAttenuationMap_PL);
	wait(1);
	LF_create_AttenuationMap(vAttS_SL_,&_bAttenuationMap_SL);
}

void LF_test_RTsupport()
{
	BMAP* bTemp=bmap_createblack(128,128,24);
	
	if(bmap_rendertarget(bTemp,3,0)!=0)
	_iRT_Support=1;
	
	bmap_rendertarget(NULL,3,0);
	
	ptr_remove(bTemp);
}

void LF_test_FPsupport()
{
	BMAP* bTemp=bmap_createblack(128,128,8888);
	
	bmap_to_format(bTemp,12222);
	
	var vFormat=bmap_lock(bTemp,0);
	bmap_unlock(bTemp);
	
	if(vFormat==12222)
	{
		bmap_to_format(bTemp,14444);
		
		vFormat=bmap_lock(bTemp,0);
		bmap_unlock(bTemp);
		
		if(vFormat==14444)
		_iFP_Support=2;
		else
		_iFP_Support=1;
		
	}
	else
	_iFP_Support=0;
}

void LF_set_DefaultSkyCube()
{
	int iUseDefaultSky_last=1;
	
	while(1)
	{
		_eDefaultLFSkyCube->flags2 ^= SHOW;
		
		if(_iUseDefaultSky!=iUseDefaultSky_last)
		{
			if(_iUseDefaultSky==1)
			{
				_eDefaultLFSkyCube->material=_mtlSkyCube;
			}
			else
			{
				_eDefaultLFSkyCube->material=NULL;
			}
		}
		
		iUseDefaultSky_last=_iUseDefaultSky;
		
		wait(1);
	}
}

void LF_INI()
{
	vec_set(sky_color,vector(1,1,1));
	
	LF_set_DefaultSkyCube();
	
	LF_test_RTsupport();
	LF_test_FPsupport();
	
	LF_init_AttenuationMaps(7,5);
}

void LF_SkyCube_init(ENTITY* eSkyC_)
{
	_iUseDefaultSky=0;
	eSkyC_->material=_mtlSkyCube;
	eSkyC_->flags2 |= SHOW;
}

void LF_SkyCube_deinit(ENTITY* eSkyC_)
{
	_iUseDefaultSky=1;
	eSkyC_->material=NULL;
	eSkyC_->flags2 &= ~SHOW;
}

void LF_SkyCube_mod_Col(ENTITY* eSkyC_,VECTOR* vColor_,var vIntens_)
{
	eSkyC_->skill41=floatv(vColor_->x);
	eSkyC_->skill42=floatv(vColor_->y);
	eSkyC_->skill43=floatv(vColor_->z);
	
	eSkyC_->skill44=floatv(vIntens_);
}