
/////////////////////////////////////////////LIGHT STRUCT FUNCS
void create_LigthDebuggingPrimitive(LF_LIGHT* litShow_);
void remove_LigthDebuggingPrimitive(LF_LIGHT* litShow_);
void toggle_LigthDebuggingPrimitive(LF_LIGHT* litShow_);
void LF_toggle_GlobalLightDebugging();
void set_VSMRendering(LF_LIGHT* litLight_);
void reset_VSMRendering(LF_LIGHT* litLight_);
void toggle_VSMRendering(LF_LIGHT* litLight_);

LF_LIGHT **_litAllLights; //contains pointers to all light pointers

void LF_LIGHT_update(LF_LIGHT* litLight_)
{
	int iScale=1+(litLight_->eLight->skill21==0 || litLight_->eLight->skill21==3);
	
	litLight_->eLight->scale_x=litLight_->vLightRange*iScale;
	litLight_->eLight->scale_y=litLight_->vLightRange*iScale;
	litLight_->eLight->scale_z=litLight_->vLightRange*iScale;
	
	c_setminmax(litLight_->eLight);
	
	litLight_->eLight->skill41=floatv(litLight_->vLightRange);
	litLight_->eLight->skill42=floatv(litLight_->cLightColor.red);
	litLight_->eLight->skill43=floatv(litLight_->cLightColor.green);
	litLight_->eLight->skill44=floatv(litLight_->cLightColor.blue);
	
	litLight_->eLight->skill45=floatv(litLight_->vApertureAng);
	litLight_->eLight->skill46=floatv(litLight_->vAngularAtt);
	litLight_->eLight->skill47=floatv(litLight_->vLightStrength);
	litLight_->eLight->skill48=floatv(litLight_->vAmb_AngInfluence);
	
	if(litLight_->eWire!=NULL)
	{
		litLight_->eWire->scale_x=litLight_->vLightRange*iScale;
		litLight_->eWire->scale_y=litLight_->vLightRange*iScale;
		litLight_->eWire->scale_z=litLight_->vLightRange*iScale;
		
		c_setminmax(litLight_->eWire);		
		
		litLight_->eWire->skill41=floatv(litLight_->vLightRange);
		litLight_->eWire->skill42=floatv(litLight_->cLightColor.red);
		litLight_->eWire->skill43=floatv(litLight_->cLightColor.green);
		litLight_->eWire->skill44=floatv(litLight_->cLightColor.blue);
		
		litLight_->eWire->skill45=floatv(litLight_->vApertureAng);
	}
}

void LF_LIGHT_remove(LF_LIGHT* litLight_)
{
	if(litLight_==NULL)
	return;
	
	litLight_->boAlive=FALSE;
	
	int i;
	
	for(i=0;i<_iAllLights_Count;i++)
	if(_litAllLights[i]==litLight_)
	break;
	
	_iAllLights_Count--;
	
	if(_litAllLights[i]->eLight->skill20==1)
	{
		if(_litAllLights[i]->eLight->skill21==0)
		{
			VIEW* vwTempShadowView1=_litAllLights[i]->vwShadowView;
			VIEW* vwTempShadowView2=vwTempShadowView1->skill_y;	
			VIEW* vwTempShadowView3=vwTempShadowView2->skill_y;	
			VIEW* vwTempShadowView4=vwTempShadowView3->skill_y;	
			VIEW* vwTempShadowView5=vwTempShadowView4->skill_y;	
			VIEW* vwTempShadowView6=vwTempShadowView5->skill_y;	
			
			vwTempShadowView1->skill_x=0;
			vwTempShadowView2->skill_x=0;
			vwTempShadowView3->skill_x=0;
			vwTempShadowView4->skill_x=0;
			vwTempShadowView5->skill_x=0;
			vwTempShadowView6->skill_x=0;
			
			reset(vwTempShadowView1,SHOW);
			reset(vwTempShadowView2,SHOW);
			reset(vwTempShadowView3,SHOW);
			reset(vwTempShadowView4,SHOW);
			reset(vwTempShadowView5,SHOW);
			reset(vwTempShadowView6,SHOW);
			
			ptr_remove(vwTempShadowView1);
			ptr_remove(vwTempShadowView2);
			ptr_remove(vwTempShadowView3);
			ptr_remove(vwTempShadowView4);
			ptr_remove(vwTempShadowView5);
			ptr_remove(vwTempShadowView6);
			
			ptr_remove(_litAllLights[i]->bShadowMap);			
		}

		if(_litAllLights[i]->eLight->skill21==1)
		{
			VIEW* vwTempShadowView=_litAllLights[i]->vwShadowView;	
			
			vwTempShadowView->skill_x=0;
			
			reset(vwTempShadowView,SHOW);

			ptr_remove(vwTempShadowView);
			
			ptr_remove(_litAllLights[i]->bShadowMap);			
		}
		
		if(_litAllLights[i]->eLight->skill21==2)
		{
			VIEW* vwTempShadowView1=_litAllLights[i]->vwShadowView;
			VIEW* vwTempShadowView2=vwTempShadowView1->skill_y;
			
			if(vwTempShadowView2->skill_y!=0)
			{
				VIEW* vwTempShadowView3=vwTempShadowView2->skill_y; 
				vwTempShadowView3->skill_x=0; 
				reset(vwTempShadowView3,SHOW); 
				ptr_remove(vwTempShadowView3);
				
				if(vwTempShadowView3->skill_y)
				{
					VIEW* vwTempShadowView4=vwTempShadowView3->skill_y; 
					vwTempShadowView4->skill_x=0; 
					reset(vwTempShadowView4,SHOW); 
					ptr_remove(vwTempShadowView4);		
				}
			}
			
			vwTempShadowView1->skill_x=0;
			vwTempShadowView2->skill_x=0;
			
			reset(vwTempShadowView1,SHOW);
			reset(vwTempShadowView2,SHOW);
			
			ptr_remove(vwTempShadowView1);
			ptr_remove(vwTempShadowView2);
			
			ptr_remove(_litAllLights[i]->bShadowMap);			
		}
	}
	else
	{
		if(_litAllLights[i]->eLight->skill21==1)
		{
			VIEW* vwTempShadowView=_litAllLights[i]->vwShadowView;	
			
			vwTempShadowView->skill_x=0;
			
			reset(vwTempShadowView,SHOW);

			ptr_remove(vwTempShadowView);
		}
	}
	
	//	if(_litAllLights[i]->eWire!=NULL)
	remove_LigthDebuggingPrimitive(_litAllLights[i]);
	
	_litAllLights[i]->eLight->material=NULL;
	
	ptr_remove(_litAllLights[i]->eLight);
	free(_litAllLights[i]);

	if(i != _iAllLights_Count)
	_litAllLights[i] = _litAllLights[_iAllLights_Count];
	
	_litAllLights = realloc(_litAllLights, _iAllLights_Count*sizeof(LF_LIGHT));
}

void init_CubeSmapRendering(LF_LIGHT* litPointLight_)
{
	proc_mode=PROC_LATE;
	
	var i;
	
	var vCubeSettings1[6]={180,90,0,270,90,90};
	var vCubeSettings2[6]={0,0,0,0,-90,90};
	
	//////////////////
	update_zbuffer(litPointLight_->iSMapResolution);
	
	BMAP*	bCubeMap = bmap_createblack(litPointLight_->iSMapResolution*6,litPointLight_->iSMapResolution,14444);
	bmap_to_cubemap(bCubeMap);

	litPointLight_->bShadowMap=bCubeMap;

	ent_setskin(litPointLight_->eLight,litPointLight_->bShadowMap,3);
	
	VIEW* vwShadowViews[6];
	
	for(i=0;i<6;i++)
	{
		vwShadowViews[i]=view_create(0);
		vwShadowViews[i]->skill_x=4;

		vwShadowViews[i]->arc = 90;
		vwShadowViews[i]->pan = vCubeSettings1[i];
		vwShadowViews[i]->tilt = vCubeSettings2[i];
		vwShadowViews[i]->roll = 0;

		vwShadowViews[i]->pos_x = litPointLight_->iSMapResolution*i;
		vwShadowViews[i]->size_x = litPointLight_->iSMapResolution;
		vwShadowViews[i]->size_y = litPointLight_->iSMapResolution;
		set(vwShadowViews[i],SHOW);	
		//		set(vwShadowViews[i],SHOW|NOFLAG1);	
	}
	//	wait(-8);
	
	for(i=0;i<6;i++)
	vwShadowViews[i]->bmap = litPointLight_->bShadowMap;
	
	
	for(i=0;i<5;i++)
	{
		vwShadowViews[i]->skill_y=vwShadowViews[i+1];//pointer chain	
	}
	
	litPointLight_->vwShadowView=vwShadowViews[0];
	
	int iScreenSizeX_old=screen_size.x;
	int iScreenSizeY_old=screen_size.y;
	int iVideoScreen_last=video_screen;
	
	while(vwShadowViews[0]!=NULL)
	{
		if(vwShadowViews[0]->skill_x!=4)
		return;
		
		for(i=0;i<6;i++)
		{
			vwShadowViews[i]->clip_far=litPointLight_->vLightRange*1.5;
			
			vwShadowViews[i]->x=litPointLight_->vcLightPos->x;
			vwShadowViews[i]->y=litPointLight_->vcLightPos->y;
			vwShadowViews[i]->z=litPointLight_->vcLightPos->z;
		}
		
		if(iScreenSizeX_old!=screen_size.x || iScreenSizeY_old!=screen_size.y  || (iVideoScreen_last!=video_screen))//re-initialize
		{
			/////////////
			wait(1);
			update_zbuffer(litPointLight_->iSMapResolution);
			///////////////////////////////////////
			
			ptr_remove(bCubeMap);
			
			BMAP*	bCubeMap = bmap_createblack(litPointLight_->iSMapResolution*6,litPointLight_->iSMapResolution,14444);
			bmap_to_cubemap(bCubeMap);

			litPointLight_->bShadowMap=bCubeMap;

			ent_setskin(litPointLight_->eLight,litPointLight_->bShadowMap,3);
			
			for(i=0;i<6;i++)
			vwShadowViews[i]->bmap = litPointLight_->bShadowMap;
		}
		
		iScreenSizeX_old=screen_size.x;
		iScreenSizeY_old=screen_size.y;
		iVideoScreen_last=video_screen;
		
		wait(1);
	}
}

void init_SpotSmapRendering(LF_LIGHT* litPointLight_)
{
	proc_mode=PROC_LATE;
	
	//////////////////
	update_zbuffer(litPointLight_->iSMapResolution);
	
	BMAP*	bSpotMap = bmap_createblack(litPointLight_->iSMapResolution,litPointLight_->iSMapResolution,14444);
	
	litPointLight_->bShadowMap=bSpotMap;
	
	ent_setskin(litPointLight_->eLight,litPointLight_->bShadowMap,3);
	
	VIEW* vwShadowView=view_create(0);
	vwShadowView->skill_x=4;
	
	vwShadowView->bmap = litPointLight_->bShadowMap;
	vwShadowView->size_x = litPointLight_->iSMapResolution;
	vwShadowView->size_y = litPointLight_->iSMapResolution;
	
	set(vwShadowView,SHOW);	
	
	litPointLight_->vwShadowView=vwShadowView;
	litPointLight_->eLight->skill22=vwShadowView;
	litPointLight_->eLight->skill19=litPointLight_->iSMapResolution;//res for material event
	
	int iScreenSizeX_old=screen_size.x;
	int iScreenSizeY_old=screen_size.y;
	int iVideoScreen_last=video_screen;
	
	while(vwShadowView!=NULL)
	{
		if(vwShadowView->skill_x!=4)
		return;
		
		if(iScreenSizeX_old!=screen_size.x || iScreenSizeY_old!=screen_size.y  || (iVideoScreen_last!=video_screen))//re-initialize
		{
			/////////////
			wait(1);
			update_zbuffer(litPointLight_->iSMapResolution);
			///////////////////////////////////////
			
			ptr_remove(bSpotMap);
			
			BMAP*	bSpotMap = bmap_createblack(litPointLight_->iSMapResolution,litPointLight_->iSMapResolution,14444);

			litPointLight_->bShadowMap=bSpotMap;

			ent_setskin(litPointLight_->eLight,litPointLight_->bShadowMap,3);
			
			vwShadowView->bmap = litPointLight_->bShadowMap;
		}
		
		//////////////////////////////////////////////////////////
		
		vwShadowView->clip_far=litPointLight_->vLightRange*1.5;
		
		vwShadowView->arc = litPointLight_->vApertureAng;
		//		vwShadowView->aspect = vwShadowView->arc/60;
		//		vwShadowView->aspect = 60/vwShadowView->arc;
		
		vwShadowView->x=litPointLight_->vcLightPos->x;
		vwShadowView->y=litPointLight_->vcLightPos->y;
		vwShadowView->z=litPointLight_->vcLightPos->z;

		vwShadowView->pan=litPointLight_->aLightAng->pan;
		vwShadowView->tilt=litPointLight_->aLightAng->tilt;
		vwShadowView->roll=0;
		
		//////////////////////////////////////////////////////////prevent SM flickering due view rotation
		litPointLight_->eLight->skill48=floatv(litPointLight_->aLightAng->roll);
		
		iScreenSizeX_old=screen_size.x;
		iScreenSizeY_old=screen_size.y;
		iVideoScreen_last=video_screen;
		
		wait(1);
	}
}

void set_VSMRendering(LF_LIGHT* litLight_)
{
	VIEW* vwShadowViewChain[6];
	int i;
	
	if(litLight_->eLight->skill21==0)
	{
		vwShadowViewChain[0]=litLight_->vwShadowView;
		
		for(i=1;i<6;i++)
		{
			vwShadowViewChain[i]=vwShadowViewChain[i-1]->skill_y;
			set(vwShadowViewChain[i],SHOW);
		}
	}

	set(litLight_->vwShadowView,SHOW);
} 

void reset_VSMRendering(LF_LIGHT* litLight_)
{
	VIEW* vwShadowViewChain[6];
	int i;
	
	if(litLight_->eLight->skill21==0)
	{
		vwShadowViewChain[0]=litLight_->vwShadowView;
		
		for(i=1;i<6;i++)
		{
			vwShadowViewChain[i]=vwShadowViewChain[i-1]->skill_y;
			reset(vwShadowViewChain[i],SHOW);
		}
	}

	reset(litLight_->vwShadowView,SHOW);
} 

void toggle_VSMRendering(LF_LIGHT* litLight_)
{
	if(litLight_->vwShadowView==NULL)
	return;
	
	if(is(litLight_->vwShadowView,SHOW))
	{
		reset_VSMRendering(litLight_);
	}
	else
	{
		set_VSMRendering(litLight_);
	}
}

void init_SpotCookieProjection(LF_LIGHT* litPointLight_)
{
	proc_mode=PROC_LATE;
	
	VIEW* vwShadowView=view_create(0);
	vwShadowView->skill_x=4;
	
	litPointLight_->vwShadowView=vwShadowView;
	litPointLight_->eLight->skill22=vwShadowView;
	
	while(vwShadowView!=NULL)
	{
		if(vwShadowView->skill_x!=4)
		break;
		
		vwShadowView->arc=litPointLight_->vApertureAng;
		
		vwShadowView->x=litPointLight_->vcLightPos->x;
		vwShadowView->y=litPointLight_->vcLightPos->y;
		vwShadowView->z=litPointLight_->vcLightPos->z;

		vwShadowView->pan=litPointLight_->aLightAng->pan;
		vwShadowView->tilt=litPointLight_->aLightAng->tilt;
		vwShadowView->roll=litPointLight_->aLightAng->roll;
		
		wait(1);
	}
}

void LF_add_LightMat(LF_LIGHT* litLight_)
{
	if(litLight_->eLight->skill21==0)
	{
		if(litLight_->eLight->skill20==1)
		{
			if(litLight_->eLight->skill23==0)
			litLight_->eLight->material=_mtlLightPass_PL_VSM;
			else
			litLight_->eLight->material=_mtlLightPass_PL_VSM_C;
		}
		else
		{
			if(litLight_->eLight->skill23==0)
			litLight_->eLight->material=_mtlLightPass_PL;
			else
			litLight_->eLight->material=_mtlLightPass_PL_C;
		}			
	}
	else
	{
		if(litLight_->eLight->skill20==1)
		{
			if(litLight_->eLight->skill23==0)
			litLight_->eLight->material=_mtlLightPass_SL_VSM;
			else
			litLight_->eLight->material=_mtlLightPass_SL_VSM_C;
		}
		else
		{
			if(litLight_->eLight->skill23==0)
			litLight_->eLight->material=_mtlLightPass_SL;
			else
			litLight_->eLight->material=_mtlLightPass_SL_C;
		}
	}		
}

////void align_quad(ENTITY* eQuad_)
////{
	////	proc_mode=PROC_LATE;
	////	
	////	VECTOR vcTemp;
	////	vec_zero(vcTemp);
	////	
	////	while(eQuad_!=NULL)
	////	{
		////		vec_set(eQuad_->x,camera->x);
		////		
		////		vec_for_angle(vcTemp,camera->pan);
		////		vec_normalize(vcTemp,20);
		////		vec_add(eQuad_->x,vcTemp);
		////		
		////		wait(1);
	////	}
////}

void NewLight_Model_init()
{
	set(my,PASSABLE);
	ent_cloneskin(my);
}

LF_LIGHT* LF_LIGHT_create(int iLType_,var vLightStrength_,VECTOR* vcLightPos_,VECTOR* vcLightAng_,var vLightRange_,var vApertureAng_,var vAngularAtt_,VECTOR* vcLightColor_,int iUseSM_,int iSMapResolution_,BMAP* bCookie_)
{
	_iAllLights_Count += 1;
	
	if(_iAllLights_Count == 1)
	{
		_litAllLights = malloc(_iAllLights_Count*sizeof(LF_LIGHT*));
	}
	else
	{
		_litAllLights = realloc(_litAllLights, _iAllLights_Count*sizeof(LF_LIGHT*));
	}
	
	_litAllLights[_iAllLights_Count-1] = malloc(sizeof(LF_LIGHT));
	
	switch(iLType_)
	{
		case 0: _litAllLights[_iAllLights_Count-1]->eLight=ent_create("geo_sphere2.mdl",nullvector,NewLight_Model_init);
		case 1: _litAllLights[_iAllLights_Count-1]->eLight=ent_create("geo_spot.mdl",nullvector,NewLight_Model_init);
		case 2: _litAllLights[_iAllLights_Count-1]->eLight=ent_create("quad_cube.mdl",nullvector,NewLight_Model_init); 
		//		case 2: _litAllLights[_iAllLights_Count-1]->eLight=ent_create("Quad.mdl",nullvector,NULL);  //1215752192.000
		//		case 2: _litAllLights[_iAllLights_Count-1]->eLight=ent_createlayer("skycube+6.tga",SKY | CUBE | SHOW | SCENE,0);  
		
		default:
	}
	
	_litAllLights[_iAllLights_Count-1]->bShadowMap=NULL;
	_litAllLights[_iAllLights_Count-1]->vwShadowView=NULL;
	
	/////////////////////////test whether hardware supports the lightsource version
	if(_iFP_Support!=2)
	iUseSM_=0;
	
	if(d3d_shaderversion!=3030 && d3d_shaderversion!=30)
	{
		iUseSM_=0;
		bCookie_=NULL;	
	}
	/////////////////////////
	
	if(bCookie_!=NULL && iLType_!=2)
	{
		_litAllLights[_iAllLights_Count-1]->bCookie=bCookie_;
		ent_setskin(_litAllLights[_iAllLights_Count-1]->eLight,bCookie_,4);
		
		_litAllLights[_iAllLights_Count-1]->eLight->skill23=1;
	}
	else
	_litAllLights[_iAllLights_Count-1]->bCookie=NULL;
	
	
	_litAllLights[_iAllLights_Count-1]->eLight->skill21=iLType_;
	_litAllLights[_iAllLights_Count-1]->eLight->skill20=iUseSM_;
	
	LF_add_LightMat(_litAllLights[_iAllLights_Count-1]);
	
	
	_litAllLights[_iAllLights_Count-1]->boAlive=TRUE;
	
	_litAllLights[_iAllLights_Count-1]->vLightStrength=vLightStrength_;
	_litAllLights[_iAllLights_Count-1]->vLightRange=vLightRange_;
	_litAllLights[_iAllLights_Count-1]->vApertureAng=vApertureAng_;
	_litAllLights[_iAllLights_Count-1]->vAngularAtt=vAngularAtt_;
	/////////////////////////////////////////////////////////////////////////////////////////////////
	_litAllLights[_iAllLights_Count-1]->vcLightPos=&_litAllLights[_iAllLights_Count-1]->eLight->x;
	
	_litAllLights[_iAllLights_Count-1]->vcLightPos->x=vcLightPos_->x;
	_litAllLights[_iAllLights_Count-1]->vcLightPos->y=vcLightPos_->y;
	_litAllLights[_iAllLights_Count-1]->vcLightPos->z=vcLightPos_->z;
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	_litAllLights[_iAllLights_Count-1]->aLightAng=&_litAllLights[_iAllLights_Count-1]->eLight->pan;
	
	_litAllLights[_iAllLights_Count-1]->aLightAng->pan=vcLightAng_->x;
	_litAllLights[_iAllLights_Count-1]->aLightAng->tilt=vcLightAng_->y;
	_litAllLights[_iAllLights_Count-1]->aLightAng->roll=vcLightAng_->z;
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	_litAllLights[_iAllLights_Count-1]->cLightColor.red=vcLightColor_->x;
	_litAllLights[_iAllLights_Count-1]->cLightColor.green=vcLightColor_->y;
	_litAllLights[_iAllLights_Count-1]->cLightColor.blue=vcLightColor_->z;
	
	_litAllLights[_iAllLights_Count-1]->iSMapResolution=iSMapResolution_;
	
	if(iUseSM_==1)
	{
		if(iLType_==0)
		init_CubeSmapRendering(_litAllLights[_iAllLights_Count-1]);
		
		if(iLType_==1)
		init_SpotSmapRendering(_litAllLights[_iAllLights_Count-1]);
		
		//		if(iLType_==2)
		//		init_CSmapRendering(_litAllLights[_iAllLights_Count-1]);
	}
	else
	{
		if(bCookie_!=NULL && iLType_==1)
		init_SpotCookieProjection(_litAllLights[_iAllLights_Count-1]);
	}		
	
	_litAllLights[_iAllLights_Count-1]->eWire=NULL;

	if(_iLightDebuggingMode==1 && iLType_!=2)
	create_LigthDebuggingPrimitive(_litAllLights[_iAllLights_Count-1]);

	LF_LIGHT_update(_litAllLights[_iAllLights_Count-1]);
	
	return _litAllLights[_iAllLights_Count-1];
}



void place_CSMView(VIEW* vwCamera_,VIEW* vwCSM_,ANGLE* aLightAng_,var vOff_)
{
	VECTOR vcTemp1,vcTemp2;
	vec_zero(vcTemp1);
	vec_zero(vcTemp2);
	
	vwCSM_->pan = 180+aLightAng_->pan;
	vwCSM_->tilt = -aLightAng_->tilt;
	vwCSM_->roll=0;
	
	vec_for_angle(vcTemp1, vwCamera_->pan);
	vec_scale(vcTemp1, vOff_);
	
	vec_add(vcTemp1, vwCamera_->x);
	
	vec_for_angle(vcTemp2,aLightAng_);
	vec_set(vwCSM_->x, vcTemp2);
	vec_normalize(vwCSM_->x, _vCSM_ViewDist);
	
	vec_add(vwCSM_->x, vcTemp1);
}

void init_CSMView(VIEW* vwCSM_,var vRadius_)
{
	vRadius_+=_vCSM_Tolerance*0.5;
	
	vwCSM_->left = -vRadius_;
	vwCSM_->right = vRadius_;
	vwCSM_->bottom = -vRadius_;
	vwCSM_->top = vRadius_;
	
	set(vwCSM_,SHOW + ISOMETRIC);
}

double calc_x(double r,double c,double v2)
{
	double c2=c*c;

	return (c/(v2+(double)1)) + (( (double)0.5*sqrt((double)4*c2+((double)4*v2+(double)4)*(r*r-c2)) )/(v2+(double)1));
}

void init_CSmapRendering(LF_LIGHT* litLight_,int iCCount)
{
	proc_mode=PROC_LATE;
	
	VECTOR vcTemp1,vcTemp2;
	vec_zero(vcTemp1);
	vec_zero(vcTemp2);
	
	VIEW* vwCamera=litLight_->eLight->skill18;
	//////////////////
	update_zbuffer(litLight_->iSMapResolution);
	
	BMAP*	bCMap = bmap_createblack(litLight_->iSMapResolution*6,litLight_->iSMapResolution,14444);
	bmap_to_cubemap(bCMap);
	
	litLight_->bShadowMap=bCMap;
	
	ent_setskin(litLight_->eLight,litLight_->bShadowMap,3);
	
	/////////////////////////////////////////////////////////////////
	
	//	double Areas[4]={200,800,2000,6000};
	//	double Areas[4]={300,1000,3000,8000};
	
	double Areas[4]={0,0,0,0};

	double R[4]={0,0,0,0};
	double center[4]={0,0,0,0};
	double h[4]={0,0,0,0};
	double h0[4]={0,0,0,0};
	
	double v=tanv((double)get_ConeApAng(vwCamera));
	double v2=v*v;
	
	int i,l;
	
	for(i=0;i<iCCount;i++)
	Areas[i]=(double)litLight_->vCascadeSize[i];
	
	for(i=0;i<4;i++)
	{		
		R[i]=0;
		center[i]=0;
		h[i]=0;
		h0[i]=0;
	}
	
	for(i=0;i<iCCount;i++)
	{
		l=maxv(0,i-1);
		
		if(i!=0)
		{
			h[i]=Areas[l]-h0[l];
			h[i]+=Areas[i]-sqrt(Areas[i]*Areas[i] - R[l]*R[l]);	
			
			center[i]=center[l]+Areas[l]-h[i]+Areas[i];
		}	
		else
		center[i]=center[l]-h[i]+Areas[i];
		
		h0[i]=calc_x(Areas[i],center[i],v2);
		h0[i]-=center[i];
		R[i]=sqrt(Areas[i]*Areas[i]-h0[i]*h0[i]);
	}

	//_vDb01=center[0];
	//_vDb02=center[1];
	//_vDb03=center[2];
	//_vDb04=center[3];
	/////////////////////////////////////////////////////////////////
	int i,j;
	VIEW* vwShadowView[4];
	
	for(i=0;i<iCCount;i++)
	{
		vwShadowView[i]=view_create(0);
		vwShadowView[i]->skill_x=4;
		
		vwShadowView[i]->bmap = litLight_->bShadowMap;
		vwShadowView[i]->size_x = litLight_->iSMapResolution;
		vwShadowView[i]->size_y = litLight_->iSMapResolution;
		vwShadowView[i]->pos_x = litLight_->iSMapResolution*i;
		
		init_CSMView(vwShadowView[i],(var)Areas[i]);
	}
	
	for(i=0;i<iCCount-1;i++)
	{
		vwShadowView[i]->skill_y=vwShadowView[i+1];//pointer chain	
	}
	
	litLight_->vwShadowView=vwShadowView[0];
	litLight_->eLight->skill22=vwShadowView[0];//ptr for material event
	litLight_->eLight->skill19=litLight_->iSMapResolution;//res for material event
	
	int iScreenSizeX_old=screen_size.x;
	int iScreenSizeY_old=screen_size.y;
	int iVideoScreen_last=video_screen;
	double Areas_old[4]={0,0,0,0};
	
	for(i=0;i<4;i++)
	Areas_old[i]=Areas[i];
	
	double dPixelSize[0]={0,0,0,0};
	
	for(i=0;i<4;i++)
	dPixelSize[i]=(Areas[i]*(double)2.0+(double)_vCSM_Tolerance)/(double)litLight_->iSMapResolution;
	
	ENTITY* eDummy=ent_create("dummy.mdl",nullvector,NULL);
	set(eDummy,PASSABLE + INVISIBLE);
	
	while(vwShadowView[0]!=NULL)
	{
		
		for(i=0;i<iCCount;i++)
		if(vwShadowView[i]->skill_x!=4)
		return;	
		
		
		for(i=0;i<iCCount;i++)
		Areas[i]=(double)litLight_->vCascadeSize[i];
		
		///////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////
		
		if(iScreenSizeX_old!=screen_size.x || iScreenSizeY_old!=screen_size.y  || (iVideoScreen_last!=video_screen))//re-initialize
		{
			/////////////
			wait(1);
			update_zbuffer(litLight_->iSMapResolution);
			///////////////////////////////////////	
			
			ptr_remove(bCMap);
			
			BMAP*	bCMap = bmap_createblack(litLight_->iSMapResolution*6,litLight_->iSMapResolution,14444);
			bmap_to_cubemap(bCMap);

			litLight_->bShadowMap=bCMap;

			ent_setskin(litLight_->eLight,litLight_->bShadowMap,3);
			
			for(i=0;i<iCCount;i++)
			vwShadowView[i]->bmap = litLight_->bShadowMap;
		}
		
		for(i=0;i<iCCount;i++)
		{
			if(Areas_old[i]!=Areas[i])
			{
				for(i=0;i<4;i++)
				{
					R[i]=0;
					center[i]=0;
					h[i]=0;
					h0[i]=0;
				}
				
				v=tanv((double)get_ConeApAng(vwCamera));
				v2=v*v;
				
				for(i=0;i<iCCount;i++)
				{
					l=maxv(0,i-1);
					
					if(i!=0)
					{
						h[i]=Areas[l]-h0[l];
						h[i]+=Areas[i]-sqrt(Areas[i]*Areas[i] - R[l]*R[l]);	
						
						center[i]=center[l]+Areas[l]-h[i]+Areas[i];
					}	
					else
					center[i]=center[l]-h[i]+Areas[i];
					
					h0[i]=calc_x(Areas[i],center[i],v2);
					h0[i]-=center[i];
					R[i]=sqrt(Areas[i]*Areas[i]-h0[i]*h0[i]);
				}
				
				for(i=0;i<iCCount;i++)
				init_CSMView(vwShadowView[i],(var)Areas[i]);
				
				for(i=0;i<4;i++)
				dPixelSize[i]=(Areas[i]*(double)2.0+(double)_vCSM_Tolerance)/(double)litLight_->iSMapResolution;
				
				break;
			}
		}
		
		///////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////
		
		for(i=0;i<iCCount;i++)
		{
			//			place_CSMView(vwCamera,vwShadowView[i],litLight_->aLightAng,(var)center[i]);
			
			vwShadowView[i]->pan = 180+litLight_->aLightAng->pan;
			vwShadowView[i]->tilt = -litLight_->aLightAng->tilt;
			vwShadowView[i]->roll=0;
			
			vec_for_angle(vcTemp1, vwCamera->pan);
			vec_scale(vcTemp1, (var)center[i]);
			
			vec_add(vcTemp1, vwCamera->x);
			
			vec_for_angle(vcTemp2,litLight_->aLightAng);
			vec_set(vwShadowView[i]->x, vcTemp2);
			vec_normalize(vwShadowView[i]->x, _vCSM_ViewDist[i]);
			
			vec_add(vwShadowView[i]->x, vcTemp1);
			
			/////////////////////////////////////////////////////////////////////////////////////prevent "peter panning"
			vec_set(eDummy->pan,vwShadowView[i]->pan);
			
			vec_set(vcTemp1,vwShadowView[i]->x);
			vec_to_ent(vcTemp1,eDummy);
			
			vcTemp1.y=round((double)vcTemp1.y/dPixelSize[i])*dPixelSize[i];
			vcTemp1.z=round((double)vcTemp1.z/dPixelSize[i])*dPixelSize[i];
			
			vec_for_ent(vcTemp1,eDummy);
			vec_set(vwShadowView[i]->x,vcTemp1);
			/////////////////////////////////////////////////////////////////////////////////////
		}
		
		//////////////////////////////////
		ENTITY* eL=litLight_->eLight;
		
		eL->skill92=(var)center[0];
		eL->skill93=(var)center[1];
		eL->skill94=(var)center[2];
		eL->skill95=(var)center[3];
		
		eL->skill96=(var)Areas[0];
		eL->skill97=(var)Areas[1];
		eL->skill98=(var)Areas[2];
		eL->skill99=(var)Areas[3];
		
		for(i=0;i<3;i++)
		eL->skill[i]=litLight_->vBlurStrength[i];
		
		for(i=0;i<4;i++)
		eL->skill[3+i]=litLight_->vShadowBias[i];
		
		eL->skill8=litLight_->vCSM_FadeOut;
		///////////////////////////////////////////////////////////
		
		for(i=0;i<iCCount;i++)
		{
			vec_for_angle(vcTemp1,vwShadowView[i]->pan);
			
			vec_set(eL->skill[59+i*3],vcTemp1.x);
			vec_set(eL->skill[79+i*3],vwShadowView[i]->x);
		}
		
		//////////////////////////////////////////////////////////prevent SM flickering due view rotation
		
		iScreenSizeX_old=screen_size.x;
		iScreenSizeY_old=screen_size.y;
		iVideoScreen_last=video_screen;
		
		for(i=0;i<iCCount;i++)
		Areas_old[i]=Areas[i];
		
		wait(1);
	}
}

LF_LIGHT* LF_LIGHT_create_DL_CSM(VIEW* vwView_,var vLightStrength_,VECTOR* vcLightAng_,VECTOR* vcLightColor_,int iSMapResolution_,var* vCascadeSize_,var* vBlurStrength_,var* vShadowBias_)
{
	_iAllLights_Count += 1;
	
	if(_iAllLights_Count == 1)
	{
		_litAllLights = malloc(_iAllLights_Count*sizeof(LF_LIGHT*));
	}
	else
	{
		_litAllLights = realloc(_litAllLights, _iAllLights_Count*sizeof(LF_LIGHT*));
	}
	
	_litAllLights[_iAllLights_Count-1] = malloc(sizeof(LF_LIGHT));
	
	_litAllLights[_iAllLights_Count-1]->eLight=ent_create("quad_cube.mdl",nullvector,NewLight_Model_init); 
	
	_litAllLights[_iAllLights_Count-1]->bShadowMap=NULL;
	_litAllLights[_iAllLights_Count-1]->vwShadowView=NULL;
	
	/////////////////////////test whether hardware supports the lightsource version
	if(_iFP_Support!=2)
	iSMapResolution_=0;
	
	if(d3d_shaderversion!=3030 && d3d_shaderversion!=30)
	iSMapResolution_=0;
	/////////////////////////
	
	_litAllLights[_iAllLights_Count-1]->bCookie=NULL;
	
	_litAllLights[_iAllLights_Count-1]->eLight->skill21=2;
	_litAllLights[_iAllLights_Count-1]->eLight->skill20=(iSMapResolution_>0);
	_litAllLights[_iAllLights_Count-1]->eLight->skill18=vwView_;//save ptr for mtl event
	_litAllLights[_iAllLights_Count-1]->vCSM_FadeOut=0.75;
	
	//	LF_add_LightMat(_litAllLights[_iAllLights_Count-1]);
	
	_litAllLights[_iAllLights_Count-1]->boAlive=TRUE;
	
	_litAllLights[_iAllLights_Count-1]->vLightStrength=vLightStrength_;
	_litAllLights[_iAllLights_Count-1]->vLightRange=1;
	_litAllLights[_iAllLights_Count-1]->vApertureAng=0;
	_litAllLights[_iAllLights_Count-1]->vAngularAtt=0;
	/////////////////////////////////////////////////////////////////////////////////////////////////
	//	_litAllLights[_iAllLights_Count-1]->vcLightPos=&vwView_->x;
	_litAllLights[_iAllLights_Count-1]->vcLightPos=&_litAllLights[_iAllLights_Count-1]->eLight->x;
	
	_litAllLights[_iAllLights_Count-1]->vcLightPos->x=0;
	_litAllLights[_iAllLights_Count-1]->vcLightPos->y=0;
	_litAllLights[_iAllLights_Count-1]->vcLightPos->z=0;
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	_litAllLights[_iAllLights_Count-1]->aLightAng=&_litAllLights[_iAllLights_Count-1]->eLight->pan;
	
	_litAllLights[_iAllLights_Count-1]->aLightAng->pan=vcLightAng_->x;
	_litAllLights[_iAllLights_Count-1]->aLightAng->tilt=vcLightAng_->y;
	_litAllLights[_iAllLights_Count-1]->aLightAng->roll=vcLightAng_->z;
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	_litAllLights[_iAllLights_Count-1]->cLightColor.red=vcLightColor_->x;
	_litAllLights[_iAllLights_Count-1]->cLightColor.green=vcLightColor_->y;
	_litAllLights[_iAllLights_Count-1]->cLightColor.blue=vcLightColor_->z;
	
	_litAllLights[_iAllLights_Count-1]->iSMapResolution=iSMapResolution_;
	
	if(iSMapResolution_>0)
	{
		int i;
		for(i=0;i<4;i++)
		{
			_litAllLights[_iAllLights_Count-1]->vCascadeSize[i]=vCascadeSize_[i];
			_litAllLights[_iAllLights_Count-1]->vBlurStrength[minv(i,2)]=vBlurStrength_[minv(i,2)];
			_litAllLights[_iAllLights_Count-1]->vShadowBias[i]=vShadowBias_[i];
		}
		
		int iCCount=4;
		iCCount-=vCascadeSize_[3]<=0;
		iCCount-=vCascadeSize_[2]<=0;
		
		init_CSmapRendering(_litAllLights[_iAllLights_Count-1],iCCount);	
		
		switch(iCCount)
		{
			case 4: _litAllLights[_iAllLights_Count-1]->eLight->material=_mtlLightPass_DL_VSM;
			case 3: _litAllLights[_iAllLights_Count-1]->eLight->material=_mtlLightPass_DL_VSM_3;
			case 2: _litAllLights[_iAllLights_Count-1]->eLight->material=_mtlLightPass_DL_VSM_2;
			
			default:
		}
	}
	else
	_litAllLights[_iAllLights_Count-1]->eLight->material=_mtlLightPass_DL;
	
	_litAllLights[_iAllLights_Count-1]->eWire=NULL;

	LF_LIGHT_update(_litAllLights[_iAllLights_Count-1]);
	
	return _litAllLights[_iAllLights_Count-1];
}

LF_LIGHT* LF_LIGHT_create_DL(VIEW* vwView_,var vLightStrength_,VECTOR* vcLightAng_,VECTOR* vcLightColor_)
{
	var vEmpty[4]={0,0,0,0};
	return LF_LIGHT_create_DL_CSM(vwView_,vLightStrength_,vcLightAng_,vcLightColor_,0,vEmpty,vEmpty,vEmpty);
}

//LF_LIGHT* LF_LIGHT_create(int iLType_,var vLightStrength_,VECTOR* vcLightPos_,VECTOR* vcLightAng_,var vLightRange_,var vApertureAng_,var vAngularAtt_,VECTOR* vcLightColor_,int iUseSM_,int iSMapResolution_,BMAP* bCookie_)

LF_LIGHT* LF_LIGHT_create_AmbProbe(var vLightStrength_,VECTOR* vcLightPos_,var vLightRange_,var vAngInfluence_)
{
	_iAllLights_Count += 1;
	
	if(_iAllLights_Count == 1)
	{
		_litAllLights = malloc(_iAllLights_Count*sizeof(LF_LIGHT*));
	}
	else
	{
		_litAllLights = realloc(_litAllLights, _iAllLights_Count*sizeof(LF_LIGHT*));
	}
	
	_litAllLights[_iAllLights_Count-1] = malloc(sizeof(LF_LIGHT));
	
	_litAllLights[_iAllLights_Count-1]->eLight=ent_create("geo_sphere2.mdl",vcLightPos_,NewLight_Model_init); 
	
	_litAllLights[_iAllLights_Count-1]->bShadowMap=NULL;
	_litAllLights[_iAllLights_Count-1]->vwShadowView=NULL;
	
	_litAllLights[_iAllLights_Count-1]->bCookie=NULL;
	
	_litAllLights[_iAllLights_Count-1]->eLight->skill21=3;
	_litAllLights[_iAllLights_Count-1]->eLight->skill20=0;
	
	_litAllLights[_iAllLights_Count-1]->boAlive=TRUE;
	
	_litAllLights[_iAllLights_Count-1]->vLightStrength=vLightStrength_;
	_litAllLights[_iAllLights_Count-1]->vLightRange=vLightRange_;
	_litAllLights[_iAllLights_Count-1]->vAmb_AngInfluence=vAngInfluence_;
	_litAllLights[_iAllLights_Count-1]->vApertureAng=0;
	_litAllLights[_iAllLights_Count-1]->vAngularAtt=0;
	/////////////////////////////////////////////////////////////////////////////////////////////////
	_litAllLights[_iAllLights_Count-1]->vcLightPos=&_litAllLights[_iAllLights_Count-1]->eLight->x;
	
	_litAllLights[_iAllLights_Count-1]->vcLightPos->x=vcLightPos_->x;
	_litAllLights[_iAllLights_Count-1]->vcLightPos->y=vcLightPos_->y;
	_litAllLights[_iAllLights_Count-1]->vcLightPos->z=vcLightPos_->z;
	
	_litAllLights[_iAllLights_Count-1]->aLightAng=&_litAllLights[_iAllLights_Count-1]->eLight->pan;
	
	_litAllLights[_iAllLights_Count-1]->aLightAng->pan=0;
	_litAllLights[_iAllLights_Count-1]->aLightAng->tilt=0;
	_litAllLights[_iAllLights_Count-1]->aLightAng->roll=0;
	
	_litAllLights[_iAllLights_Count-1]->cLightColor.red=255;
	_litAllLights[_iAllLights_Count-1]->cLightColor.green=255;
	_litAllLights[_iAllLights_Count-1]->cLightColor.blue=255;
	/////////////////////////////////////////////////////////////////////////////////////////////////

	_litAllLights[_iAllLights_Count-1]->eLight->material=_mtlLightPass_Amb;
	
	_litAllLights[_iAllLights_Count-1]->eWire=NULL;

	LF_LIGHT_update(_litAllLights[_iAllLights_Count-1]);
	
	return _litAllLights[_iAllLights_Count-1];
}
//////////OVERLOADs 
#include "create_light_overloads.c"

void create_LigthDebuggingPrimitive(LF_LIGHT* litShow_)
{
	proc_mode=PROC_LATE;
	
	int iScale;
	
	if(litShow_->eWire==NULL)
	if(litShow_->eLight->skill21!=2)
	{
		switch(litShow_->eLight->skill21)
		{
			case 0: 
			litShow_->eWire=ent_create("geo_sphere_h_debug.mdl",litShow_->vcLightPos,NULL);
			litShow_->eWire->material=_mtlLF_WireFrame_PL;
			
			case 1: 
			litShow_->eWire=ent_create("geo_spot_h_debug.mdl",litShow_->vcLightPos,NULL);
			litShow_->eWire.pan=litShow_->eLight.pan;
			litShow_->eWire.tilt=litShow_->eLight.tilt;
			litShow_->eWire.roll=litShow_->eLight.roll;
			
			litShow_->eWire->material=_mtlLF_WireFrame_SL;
			
			case 3: 
			litShow_->eWire=ent_create("geo_sphere_h_debug.mdl",litShow_->vcLightPos,NULL);
			litShow_->eWire->material=_mtlLF_WireFrame_PL;
			
			default:
		}
		
		reset(litShow_->eWire,INVISIBLE);
		set(litShow_->eWire,PASSABLE);
		
		litShow_->eWire->skill41=floatv(litShow_->vLightRange);
		litShow_->eWire->skill42=floatv(litShow_->cLightColor.red);
		litShow_->eWire->skill43=floatv(litShow_->cLightColor.green);
		litShow_->eWire->skill44=floatv(litShow_->cLightColor.blue);
		
		litShow_->eWire->skill45=floatv(litShow_->vApertureAng);
		
		iScale=1+(litShow_->eLight->skill21==0 || litShow_->eLight->skill21==3);
		
		litShow_->eWire->scale_x=litShow_->vLightRange*iScale;
		litShow_->eWire->scale_y=litShow_->vLightRange*iScale;
		litShow_->eWire->scale_z=litShow_->vLightRange*iScale;
		
		c_setminmax(litShow_->eWire);

		while(litShow_!=NULL)
		{
			if(litShow_->eWire==NULL)
			return;
			
			if(is(litShow_->eWire,INVISIBLE))
			break;
			
			vec_set(litShow_->eWire->x,litShow_->vcLightPos);
			vec_set(litShow_->eWire->pan,litShow_->aLightAng);
			
			wait(1);
		}	
		
		ptr_remove(litShow_->eWire);
		litShow_->eWire=NULL;			
	}
}

void remove_LigthDebuggingPrimitive(LF_LIGHT* litShow_)
{
	if(litShow_->eWire!=NULL)
	{
		set(litShow_->eWire,INVISIBLE);
		ptr_remove(litShow_->eWire);
		litShow_->eWire=NULL;			
	}
}

void toggle_LigthDebuggingPrimitive(LF_LIGHT* litShow_)
{
	if(litShow_->eWire==NULL)
	create_LigthDebuggingPrimitive(litShow_);	
	else
	remove_LigthDebuggingPrimitive(litShow_);
}

void LF_toggle_GlobalLightDebugging()
{
	int i;
	
	if(_iLightDebuggingMode==0)
	{
		for(i=0;i<_iAllLights_Count;i++)
		create_LigthDebuggingPrimitive(_litAllLights[i]);
	}
	else
	{
		for(i=0;i<_iAllLights_Count;i++)
		remove_LigthDebuggingPrimitive(_litAllLights[i]);
	}
	
	_iLightDebuggingMode=1-_iLightDebuggingMode;
}

//////////////////////////////////////////////LF MATERIAL CONTAINER FUNCS

LF_MTL_CONTAINER* LF_MTL_CONTAINER_create(STRING* sMRT_,STRING* sCOL_,STRING* sNM_,STRING* sD_,STRING* sVSMD_,long lFlags_)
{
	LF_MTL_CONTAINER* mtlC_New = malloc(sizeof(LF_MTL_CONTAINER));
	
	mtlC_New->sMRT=str_create(""); str_cpy(mtlC_New->sMRT,sMRT_);
	mtlC_New->sCOL=str_create(""); str_cpy(mtlC_New->sCOL,sCOL_);
	mtlC_New->sNM=str_create("");  str_cpy(mtlC_New->sNM,sNM_);
	mtlC_New->sD=str_create("");   str_cpy(mtlC_New->sD,sD_);
	mtlC_New->sVSMD=str_create("");str_cpy(mtlC_New->sVSMD,sVSMD_);
	
	mtlC_New->lFlags=lFlags_;
	
	return mtlC_New;
}

void LF_MTL_CONTAINER_remove(LF_MTL_CONTAINER* mtlC_Delete_)
{
	ptr_remove(mtlC_Delete_->sMRT);
	ptr_remove(mtlC_Delete_->sCOL);
	ptr_remove(mtlC_Delete_->sNM);
	ptr_remove(mtlC_Delete_->sD);
	ptr_remove(mtlC_Delete_->sVSMD);

	free(mtlC_Delete_);	
}

///////////////////////////////////////////////LF MATERIAL FUNCS
MATERIAL* LF_create_EffectContent(STRING* sEffectString,STRING** sTex)
{
	int i=0;
	int j=0;
	
	STRING* sSampler[16];
	
	for(i=0;i<16;i++)
	sSampler[i]=str_create(""); 
	
	/////////////////////////
	
	STRING* sTemp1=str_create("");
	STRING* sTemp2=str_create("");
	STRING* sTemp3=str_create("");
	STRING* sFinal=str_create("");
	
	var vTemp1=0;
	var vTemp2=0;
	var vTemp3=0;
	/////////////////////////
	
	vTemp1=str_stri(sEffectString,"~");
	vTemp2=str_len(sEffectString);
	
	str_cpy(sTemp1,sEffectString);
	str_trunc(sTemp1,vTemp2-vTemp1+1);

	i=0;
	
	while(str_len(sTemp1)>0)
	{
		if(i>=16)break;
		
		vTemp1=str_stri(sTemp1,";");
		vTemp2=str_len(sTemp1);
		
		str_cpy(sTemp2,sTemp1);
		
		str_clip(sTemp1,vTemp1);
		str_trunc(sTemp2,vTemp2-vTemp1+1);
		
		if(!str_cmp(sTemp2,"NULL"))
		{
			str_cpy(sTemp3," sampler ");
			str_cat(sTemp3,sTemp2);//sampler name
			
			str_cat(sTemp3," = sampler_state { Texture   = <");

				///////////////////
				vTemp1=str_to_num(*sTex[i]);
				
				if(vTemp1==0)
				{
					str_cpy(sTemp2,*sTex[i]);
					str_cat(sTemp2,"_bmap");
				}
				else
				{
					str_cpy(sTemp2,"entSkin");
					str_cat(sTemp2,*sTex[i]);
				}
				
				str_cat(sTemp3,sTemp2);

				//////////
				str_cpy(sSampler[i],sTemp2);

				vTemp1=0;
				for(j=i-1;j>=0;j--)
				{
					if(str_cmp(sSampler[j],sSampler[i]))
					{
						vTemp1=1;
						break;
					}
				}

				if(vTemp1==0)
				{
					str_cat(sFinal," texture ");
					str_cat(sFinal,sTemp2);
					str_cat(sFinal,";");	
				}

				///////////////////
				
			str_cat(sTemp3,">; MinFilter = Anisotropic; MagFilter = Linear; MipFilter = Linear;  MaxAnisotropy =8;  AddressU  = wrap; AddressV  = wrap; };");

			str_cat(sFinal,sTemp3);
		}
		
		i++;
	}

	vTemp1=str_stri(sEffectString,"~");
	
	str_cpy(sTemp1,sEffectString);
	str_clip(sTemp1,vTemp1);
	
	str_cat(sFinal,sTemp1);
	
	//	str_for_num(sTemp1,random(10000));
	//	str_cat(sTemp1,".fx");
	
	
	//create random effect name
	str_cpy(sTemp1,"EFFECT");
	str_for_num(sTemp2,integer(random(9999)));
	str_cat(sTemp1,sTemp2);
	str_cat(sTemp1,".fx");
	
	var vHandle=file_open_write(sTemp1);
	file_str_write(vHandle,sFinal);
	file_close(vHandle);
	
	//	vHandle=file_open_write("TEST.fx");
	//	file_str_write(vHandle,sEffectString);
	//	file_close(vHandle);
	
	MATERIAL* mtlSubMat=mtl_create();
	//	effect_load(mtlSubMat,sTemp1);
	effect_load(mtlSubMat,sTemp1);

	if(_iDevEFFECT==0)
	file_delete(sTemp1);
	
	for(i=0;i<16;i++)
	ptr_remove(sSampler[i]);
	
	ptr_remove(sTemp1);
	ptr_remove(sTemp2);
	ptr_remove(sTemp3);
	ptr_remove(sFinal);
	
	return mtlSubMat;
}

LF_MATERIAL* LF_MATERIAL_create(LF_MTL_CONTAINER* mtlC_MTLs_,
STRING* sTex01_,STRING* sTex02_,STRING* sTex03_,STRING* sTex04_,STRING* sTex05_,STRING* sTex06_,STRING* sTex07_,STRING* sTex08_,
STRING* sTex09_, STRING* sTex10_,STRING* sTex11_,STRING* sTex12_,STRING* sTex13_,STRING* sTex14_,STRING* sTex15_,STRING* sTex16_)
{
	LF_MATERIAL* mtlLF_New = malloc(sizeof(LF_MATERIAL));

	mtlLF_New->mtlAdd=mtl_create();
	set(mtlLF_New->mtlAdd,ENABLE_RENDER + mtlC_MTLs_->lFlags);
	mtlLF_New->mtlAdd->event=FXevent_AddMtl;
	
	///////////////////////////////////////////
	int i;
	for(i=0;i<16;i++)
	mtlLF_New->sTex[i]=str_create(""); 
	
	str_cpy(mtlLF_New->sTex[0],sTex01_);
	str_cpy(mtlLF_New->sTex[1],sTex02_);
	str_cpy(mtlLF_New->sTex[2],sTex03_);
	str_cpy(mtlLF_New->sTex[3],sTex04_);
	
	str_cpy(mtlLF_New->sTex[4],sTex05_);
	str_cpy(mtlLF_New->sTex[5],sTex06_);
	str_cpy(mtlLF_New->sTex[6],sTex07_);
	str_cpy(mtlLF_New->sTex[7],sTex08_);
	
	str_cpy(mtlLF_New->sTex[8],sTex09_);
	str_cpy(mtlLF_New->sTex[9],sTex10_);
	str_cpy(mtlLF_New->sTex[10],sTex11_);
	str_cpy(mtlLF_New->sTex[11],sTex12_);
	
	str_cpy(mtlLF_New->sTex[12],sTex13_);
	str_cpy(mtlLF_New->sTex[13],sTex14_);
	str_cpy(mtlLF_New->sTex[14],sTex15_);
	str_cpy(mtlLF_New->sTex[15],sTex16_);
	///////////////////////////////////////////
	
	mtlLF_New->mtlMRT=LF_create_EffectContent(mtlC_MTLs_->sMRT,mtlLF_New->sTex); _iDevEFFECT=0;
	mtlLF_New->mtlCOL=LF_create_EffectContent(mtlC_MTLs_->sCOL,mtlLF_New->sTex);
	mtlLF_New->mtlNM =LF_create_EffectContent(mtlC_MTLs_->sNM,mtlLF_New->sTex);
	mtlLF_New->mtlD  =LF_create_EffectContent(mtlC_MTLs_->sD,mtlLF_New->sTex);
	mtlLF_New->mtlVSMD=LF_create_EffectContent(mtlC_MTLs_->sVSMD,mtlLF_New->sTex);
	
	return mtlLF_New;
}

#include "create_material_overloads.c"


void LF_MATERIAL_remove(LF_MATERIAL* mtlLF_)
{
	ptr_remove(mtlLF_->mtlAdd);
	
	ptr_remove(mtlLF_->mtlMRT);
	ptr_remove(mtlLF_->mtlCOL);
	ptr_remove(mtlLF_->mtlNM);
	ptr_remove(mtlLF_->mtlD);
	
	int i;
	for(i=0;i<16;i++)
	ptr_remove(mtlLF_->sTex[i]); 
	
	free(mtlLF_);
}

void LF_MATERIAL_add(ENTITY* eEnt_,LF_MATERIAL* mtlLF_)
{
	eEnt_->material=mtlLF_->mtlAdd;
	
	eEnt_->skill30=(mtlLF_->mtlMRT);
	eEnt_->skill31=(mtlLF_->mtlCOL);
	eEnt_->skill32=(mtlLF_->mtlNM);
	eEnt_->skill33=(mtlLF_->mtlD);
	eEnt_->skill34=(mtlLF_->mtlVSMD);
	
	//roughness
	eEnt_->skill41=floatv(0);
	eEnt_->skill42=floatv(1);
	//fresnel
	eEnt_->skill43=floatv(0);
	eEnt_->skill44=floatv(1);
	//bump strength
	eEnt_->skill45=floatv(1);
	//tex scale
	eEnt_->skill46=floatv(1);
	
	//int=mask type 0->no mask 0.5->diff mask 1->bloom mask frac=mask intens
	eEnt_->skill47=floatv(0.1);
	eEnt_->skill49=0.1;//save 'var'version
	
	int i;
	for(i=0;i<20;i++)
	eEnt_->skill[i]=1;
	//
	////	eEnt_->skill48=floatv(1);
}

void LF_EntMtl_Roughness(ENTITY* eEnt_,var vMinR_,var vMaxR_)
{
	eEnt_->skill41=floatv(1-vMaxR_);
	eEnt_->skill42=floatv(1-vMinR_);
}

void LF_EntMtl_Roughness(ENTITY* eEnt_,var vR_)
{
	eEnt_->skill41=floatv(1-vR_);
	eEnt_->skill42=floatv(1-vR_);
}

void LF_EntMtl_Power(ENTITY* eEnt_,var vMinF_,var vMaxF_)
{
	eEnt_->skill43=floatv(vMinF_);
	eEnt_->skill44=floatv(vMaxF_);
}

void LF_EntMtl_Power(ENTITY* eEnt_,var vF_)
{
	eEnt_->skill43=floatv(vF_);
	eEnt_->skill44=floatv(vF_);
}

void LF_EntMtl_BumpStrength(ENTITY* eEnt_,var vBS_)
{
	eEnt_->skill45=floatv(vBS_);
}

void LF_EntMtl_TexScale(ENTITY* eEnt_,var vTS_)
{
	eEnt_->skill46=floatv(vTS_);
}

//void LF_EntMtl_BloomIntens(ENTITY* eEnt_,var vBI_)
//{
	//	eEnt_->skill47=floatv(vBI_);
//}
//
//void LF_EntMtl_DiffIntens(ENTITY* eEnt_,var vDI_)
//{
	//	eEnt_->skill48=floatv(vDI_);
//}

void LF_EntMtl_MaskType(ENTITY* eEnt_,var vMT_)
{
	var vFracPart=fraction(eEnt_->skill49);
	
	eEnt_->skill49=integer(vMT_)+vFracPart;
	eEnt_->skill47=floatv(eEnt_->skill49);
}

void LF_EntMtl_MaskIntens(ENTITY* eEnt_,var vMI_)
{
	var vIntPart=integer(eEnt_->skill49);
	
	eEnt_->skill49=(1-vMI_)*0.1+vIntPart;
	eEnt_->skill47=floatv(eEnt_->skill49);
}
///////////////////////////////////////////////PP_FLAGs FUNCS

LF_PIPE_SETT* LF_PIPE_SETT_create(COLOR* cAmbLightCol_,var vAmbLightFac_,var vToneMapperFac_,int iGlow_,var vGlowBBound_,var vGlowCovPow_)
{
	LF_PIPE_SETT* psNew = malloc(sizeof(LF_PIPE_SETT));
	
	psNew->cAmbLightCol.red=cAmbLightCol_->red;
	psNew->cAmbLightCol.green=cAmbLightCol_->green;
	psNew->cAmbLightCol.blue=cAmbLightCol_->blue;
	psNew->vAmbLightFac=vAmbLightFac_;
	
	psNew->vToneMapperFac=vToneMapperFac_;
	
	psNew->iGlow=iGlow_;
	psNew->vGlowBBound=vGlowBBound_;
	psNew->vGlowCovPow=vGlowCovPow_;
	
	return psNew;
}

LF_PIPE_SETT* LF_PIPE_SETT_new()
{
	return LF_PIPE_SETT_create(nullvector,0,1,0,0,1);
}

void LF_PIPE_SETT_remove(LF_PIPE_SETT* psRemove)
{
	free(psRemove);
}

void LF_PIPE_SETT_cpy(LF_PIPE_SETT* psTo,LF_PIPE_SETT* psFrom)
{
	psTo->cAmbLightCol.red=psFrom->cAmbLightCol.red;
	psTo->cAmbLightCol.green=psFrom->cAmbLightCol.green;
	psTo->cAmbLightCol.blue=psFrom->cAmbLightCol.blue;
	psTo->vAmbLightFac=psFrom->vAmbLightFac;
	
	psTo->vToneMapperFac=psFrom->vToneMapperFac;
	
	psTo->iGlow=psFrom->iGlow;
	psTo->vGlowBBound=psFrom->vGlowBBound;
	psTo->vGlowCovPow=psFrom->vGlowCovPow;
}