
MATERIAL* PP_newMtl(STRING* sEffect_,BMAP* bSkin1_,BMAP* bSkin2_,BMAP* bSkin3_,BMAP* bSkin4_)
{
	MATERIAL* mtlPP=mtl_create();
	effect_load(mtlPP,sEffect_);
	
	mtlPP->skin1=bSkin1_;
	mtlPP->skin2=bSkin2_;
	mtlPP->skin3=bSkin3_;
	mtlPP->skin4=bSkin4_;
	
	return mtlPP;
}

//////////////////////////////////////////////////
//////////Postprocessing Helperfunctions//////////
//////////////////////////////////////////////////
////08.03.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////
///////modified by Hummel with permission/////////
//////////////////////////////////////////////////

//temporary pointers
VIEW* PP_Temp_View;


//Add an effect to a views stage chain
VIEW* PP_Add(MATERIAL* Material,VIEW* View,BMAP* btarget0,BMAP* btarget1,BMAP* btarget2,BMAP* btarget3)
{
	//find the last view of "View"s effectchain and store its pointer
	PP_Temp_View = View;
	while(PP_Temp_View.stage != NULL)
	{
		PP_Temp_View = PP_Temp_View.stage;
	}
	
	//create a new view as the stored views stage
	PP_Temp_View.stage = view_create(0);
	set(PP_Temp_View.stage,PROCESS_TARGET);
	
	//assign "Material" to the just created view
	PP_Temp_View = PP_Temp_View.stage;
	PP_Temp_View.material = Material;
	
	//if a bmap is given, render the view into it
	if(btarget0 != NULL){	PP_Temp_View.bmap    = btarget0; }
	if(btarget1 != NULL){	PP_Temp_View.target1 = btarget1; }
	if(btarget2 != NULL){	PP_Temp_View.target2 = btarget2; }
	if(btarget3 != NULL){	PP_Temp_View.target3 = btarget3; }
	
	//return the pointer to the new view
	return(PP_Temp_View);
}

//remove an effect from a views stage chain
int PP_Remove(MATERIAL* Material,VIEW* View,VIEW* StageView)
{
	//find the view with the material selected or "StageView" and the previous view && ((StageView == NULL)+(PP_Temp_View.stage != NULL)) != 0
	PP_Temp_View = View;
	while(PP_Temp_View.material != Material)
	{
		View = PP_Temp_View;
		PP_Temp_View = PP_Temp_View.stage;
		
		//return one if the stage doesnt exist
		if(PP_Temp_View == NULL){return(1);}
	}
	
	//pass the views stage to the previous view
	View.stage = PP_Temp_View.stage;
	
	//pass the render target
	View.bmap = PP_Temp_View.bmap;
	View.target1 = PP_Temp_View.target1;
	View.target2 = PP_Temp_View.target2;
	View.target3 = PP_Temp_View.target3;
	
	//reset the views bmap to null
	PP_Temp_View.bmap    = NULL;
	PP_Temp_View.target1 = NULL;
	PP_Temp_View.target2 = NULL;
	PP_Temp_View.target3 = NULL;
	
	//remove the view
	ptr_remove(PP_Temp_View);
	PP_Temp_View=NULL;
	
	//return null if everything worked
	return(0);
}

void remove_RenderTargets(VIEW* View)
{
	if(View->bmap!=NULL)    { ptr_remove(View->bmap);    View->bmap=NULL;    }
	if(View->target1!=NULL) { ptr_remove(View->target1); View->target1=NULL; }
	if(View->target2!=NULL) { ptr_remove(View->target2); View->target2=NULL; }
	if(View->target3!=NULL) { ptr_remove(View->target3); View->target3=NULL; }
}

void remove_MaterialSkins(MATERIAL* Material)
{
	if(Material->skin1!=NULL) { ptr_remove(Material->skin1); Material->skin1=NULL; }
	if(Material->skin2!=NULL) { ptr_remove(Material->skin2); Material->skin2=NULL; }
	if(Material->skin3!=NULL) { ptr_remove(Material->skin3); Material->skin3=NULL; }
	if(Material->skin4!=NULL) { ptr_remove(Material->skin4); Material->skin4=NULL; }
}

//remove all postprocessing from the view
void PP_Remove_All(VIEW* View,int iMode)
{
	if(View==NULL){return;}
	if(View->stage == NULL){return;}
	
	PP_Temp_View = View->stage;
	View->stage = NULL;
	
	remove_RenderTargets(View);
	
	//remove the view material
	if(View->material!=NULL && iMode==0)
	{
		remove_MaterialSkins(View->material);
		ptr_remove(View->material);
		View->material=NULL;			
	}
	
	while(PP_Temp_View != NULL)
	{
		View = PP_Temp_View;
		PP_Temp_View = View->stage;
		
		View->stage = NULL;
		
		//reset the views bmap to null
		remove_RenderTargets(View);
		
		//remove the view material
		if(View->material!=NULL)
		{
			remove_MaterialSkins(View->material);
			ptr_remove(View->material);
			View->material=NULL;			
		}
		
		//remove the view
		ptr_remove(View);
		View=NULL;
	}
}