
bool AUTORELOAD;

//float4x4 matWorldViewProj;
float4x4 matViewProj;
float4x4 matWorld;
float4x4 matWorldInv;

float4 vecSkill41;

float4 vecViewDir;		

void VS(		
in float4 vPos		   : POSITION,
in float3 normal	   : NORMAL,

out float  mask         : TEXCOORD1,
out float3 outnormal    : TEXCOORD2,

out float4 Pos	         : POSITION
)
{
	float3 VPos=abs(vPos.xyz);
	float side_mask=max(VPos.x,max(VPos.y,VPos.z));
	
	mask=(side_mask>=0.49 && side_mask<=0.5);
	mask+=length(vPos.xyz)==0;
	
	//invert rotation
	float scale=length(matWorld[0].xyz);
	
	matWorld[0].xyz=normalize(matWorldInv[0].xyz)*scale;
	matWorld[1].xyz=normalize(matWorldInv[1].xyz)*scale;
	matWorld[2].xyz=normalize(matWorldInv[2].xyz)*scale;
	
	outnormal=mul(normal,matWorld);
	
	Pos = mul(vPos,mul(matWorld,matViewProj));
//	Pos = mul(vPos,matWorldViewProj);
}

void PS(	

in float  mask       : TEXCOORD1,
in float3 normal     : TEXCOORD2,


out float4 COL :COLOR0,
out float4 NM  :COLOR1,
out float4 D   :COLOR2
) 
{
	COL.rgb=vecSkill41.yzw/255;
	
	normal=normalize(normal);
	
	float mark=dot(-normal,vecViewDir);
	COL.rgb*=saturate(pow(mark,2)+mask);

	//COL.rgb=mask;

	COL.w=0.5;
	NM=0;
	D=0;
}

technique Shading
{
	pass P0
	{
		fillmode=2;
		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}