
bool AUTORELOAD;

float4x4 matWorldViewProj;
float4x4 matViewProj;
float4x4 matWorld;

float4 vecSkill41;
float4 vecSkill45;

float4 vecViewDir;		
float4 vecTime;		

void VS(		
in float4 vPos		   : POSITION,
in float3 normal	   : NORMAL,

out float  mask         : TEXCOORD1,
out float3 outnormal    : TEXCOORD2,

out float4 Pos	         : POSITION
)
{
	
//	vecSkill45.x=(sin(vecTime.w*0.1)+1)*90;
//	vecSkill45.x=180;

	vecSkill45.x=radians(vecSkill45.x)*0.5;
	float R=sin(vecSkill45.x);
	
	float h=1-0.5*sqrt(4-4*(R*R));
	
	float H=1-h;
	
	float vertex_mask=dot(vPos.xyz,vPos.xyz)>0;
	
	vPos.x+=H*vertex_mask;
	
	vPos.yz=(vPos.yz)*R*vertex_mask;
	
	outnormal=normalize(vPos.xyz);
	
	vPos.xyz=outnormal*vertex_mask;

	outnormal=mul(outnormal,matWorld);

	mask=1-vertex_mask+pow(cos(vecSkill45.x),2);
	//	vPos.xyz+=normalize(vPos.xyz-float3(h*0.5,0,0))*(3.f/vecSkill41.x);

	Pos = mul(vPos,matWorldViewProj);

	//	vPos = mul(vPos,matWorld);
	//	vPos.xyz+=matWorld[0].xyz/vecSkill41.x*(sin(vecTime.w*0.1))*90;
	//	Pos = mul(vPos,matViewProj);
}

void PS(	
in float  mask       : TEXCOORD1,
in float3 normal     : TEXCOORD2,


out float4 COL :COLOR0,
out float4 NM  :COLOR1,
out float4 D   :COLOR2
) 
{
	COL.rgb=vecSkill41.yzw/255;
	
	normal=normalize(normal);
	
	float mark=dot(-normal,vecViewDir);
	COL.rgb*=saturate(pow(mark,2)+mask);

	COL.w=0.5;
	NM=0;
	D=0;
}

technique Shading
{
	pass P0
	{
		fillmode=2;
		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}