bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4x4 matMtl;


float4 vecSkill41;
float4 vecSkill45;

float4x4 matWorldViewProj;
float4x4 matWorld;
float4x4 matProj;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4 vecSunDir;		
float4 vecViewPos;
float4 vecViewDir;

texture entSkin1;
texture entSkin2;
texture entSkin3;
texture entSkin4;


texture bTex1_bmap;
texture bTex2_bmap;
texture bTex3_bmap;
texture bTex4_bmap;
texture bTex5_bmap;

texture bTex1_nm_bmap;
texture bTex2_nm_bmap;
texture bTex3_nm_bmap;
texture bTex4_nm_bmap;
texture bTex5_nm_bmap;

texture bDetail_nm_bmap;
texture bTerr_col_bmap;
texture bTerr_d_bmap;
texture bTerr_nm_bmap;
texture bTerr_mask_bmap;

sampler COLOR_SAMPLER = sampler_state { Texture = <bTerr_col_bmap>; MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = clamp; AddressV  = clamp; };
sampler OSNM_SAMPLER  = sampler_state { Texture = <bTerr_nm_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = clamp; AddressV  = clamp; };
sampler MASK_SAMPLER  = sampler_state { Texture = <bTerr_mask_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = clamp; AddressV  = clamp; };
sampler DINTENS_SAMPLER  = sampler_state { Texture = <bTerr_d_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = clamp; AddressV  = clamp; };

sampler DETAIL_SAMPLER = sampler_state { Texture = <bDetail_nm_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };

sampler C1_SAMPLER = sampler_state { Texture = <bTex1_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler C2_SAMPLER = sampler_state { Texture = <bTex2_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler C3_SAMPLER = sampler_state { Texture = <bTex3_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler C4_SAMPLER = sampler_state { Texture = <bTex4_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler C5_SAMPLER = sampler_state { Texture = <bTex5_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };

sampler NM1_SAMPLER = sampler_state { Texture = <bTex1_nm_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler NM2_SAMPLER = sampler_state { Texture = <bTex2_nm_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler NM3_SAMPLER = sampler_state { Texture = <bTex3_nm_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler NM4_SAMPLER = sampler_state { Texture = <bTex4_nm_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler NM5_SAMPLER = sampler_state { Texture = <bTex5_nm_bmap>;  MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

float get_MtlMask(float mask,float type,float intens)
{
	mask*=intens;
	mask=(1-mask)*step(0.5,type);
	
	type=max(0,(type-0.5)*2);
	mask=lerp(mask*0.5,mask*0.5+0.5+small,type);
	
	return cut_zero(mask);
}

void VS(		
in float4 vPos		   : POSITION,
in float3 normal	   : NORMAL,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,			
out float3 View	      : TEXCOORD1,
out float3 outnormal	   : TEXCOORD2,
out float  Depth        : TEXCOORD3,
out float2 tTex         : TEXCOORD4,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	Depth=Pos.w/vecSkill17.x;
	
	vecSkill45.y=1;
	OutTex = InTex;

	float3 wPos = mul(vPos,matWorld);
	
	tTex=wPos.xz*0.01*vecSkill45.y;
	tTex.x*=-1;
	
	outnormal=mul(normal,matWorld);
	
	View=vecViewPos.xyz-wPos;
}

half2 splitt_float_to_2half(float F)
{
	return half2(floor(F*255.f)/255.f,frac(F*255.f));
}

half3 splitt_float_to_3half(float F)
{
	return half3(floor(F*255.f)/255.f,splitt_float_to_2half(frac(F*255.f)));
}

void VS(		
in float4 vPos		   : POSITION,
in float3 normal	   : NORMAL,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,			
out float3 View	      : TEXCOORD1,
out float3 outnormal	   : TEXCOORD2,
out float  Depth        : TEXCOORD3,
out float2 tTex         : TEXCOORD4,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	Depth=Pos.w/vecSkill17.x;
	
	OutTex = InTex;

	float3 wPos = mul(vPos,matWorld);
	
	tTex=vPos.xz*0.01*vecSkill45.y;
	tTex.x*=-1;
	
	outnormal=normal;
	
	View=vecViewPos.xyz-wPos;
}

half2 splitt_float_to_2half(float F)
{
	return half2(floor(F*255.f)/255.f,frac(F*255.f));
}

half3 splitt_float_to_3half(float F)
{
	return half3(floor(F*255.f)/255.f,splitt_float_to_2half(frac(F*255.f)));
}

void PS(	
in float2 Tex	         : TEXCOORD0,			
in float3 View	         : TEXCOORD1,
in float3 normal	      : TEXCOORD2,
in float  Depth         : TEXCOORD3,
in float2 tTex          : TEXCOORD4,

out float4 COL :COLOR0,
out float4 NM  :COLOR1,
out float4 D   :COLOR2
) 
{
	float4 mask =tex2D(MASK_SAMPLER,Tex);
	
	float2 tTex1=tTex*matMtl[0].y;
	float2 tTex2=tTex*matMtl[0].z;
	float2 tTex3=tTex*matMtl[0].w;
	float2 tTex4=tTex*matMtl[1].x;
	float2 tTex5=tTex*matMtl[1].y;
	
	float4 col_black=tex2D(C1_SAMPLER,tTex1);
	float4 col_red  =tex2D(C2_SAMPLER,tTex2);
	float4 col_green=tex2D(C3_SAMPLER,tTex3);
	float4 col_blue =tex2D(C4_SAMPLER,tTex4);
	float4 col_alpha=tex2D(C5_SAMPLER,tTex5);
	
	float4 nm_black=tex2D(NM1_SAMPLER,tTex1);
	float4 nm_red  =tex2D(NM2_SAMPLER,tTex2);
	float4 nm_green=tex2D(NM3_SAMPLER,tTex3);
	float4 nm_blue =tex2D(NM4_SAMPLER,tTex4);
	float4 nm_alpha=tex2D(NM5_SAMPLER,tTex5);
	
	float4 col=lerp(col_black*matMtl[1].z,col_red*matMtl[1].w,mask.r);
	col=lerp(col,col_green*matMtl[2].x,mask.g);
	col=lerp(col,col_blue*matMtl[2].y,mask.b);
	col=lerp(col,col_alpha*matMtl[2].z,mask.a);
	
	////////////////////////////////////////////
	
	float4 nm=lerp(nm_black*matMtl[2].w,nm_red*matMtl[3].x,mask.r);
	nm=lerp(nm,nm_green*matMtl[3].y,mask.g);
	nm=lerp(nm,nm_blue*matMtl[3].z,mask.b);
	nm=lerp(nm,nm_alpha*matMtl[3].w,mask.a);
	
	nm.rgb=nm.rbg*2-1;
	nm.r*=-1;
	
	////////////////////////////////////////////
	
	float detail_intens=tex2D(DINTENS_SAMPLER,Tex);
	float4 detail=tex2D(DETAIL_SAMPLER,tTex*2*matMtl[0].x);
	detail.rgb=detail.rbg*2-1;
	detail.r*=-1;
	
	detail.a=0.5+lerp(0.5,detail.a,detail_intens*vecSkill1.w);
	
	float4 global_col=tex2D(COLOR_SAMPLER,Tex);
	
	col.rgb=pow(col.rgb,1.f-global_col.rgb*vecSkill1.x*0.5)*detail.a;
	
	float roughness =col.a;
	
	if(vecSkill1.z==1)
	{
		float3 os_nm=tex2D(OSNM_SAMPLER,Tex).rbg*2-1;
		os_nm.b*=-1;
		normal=os_nm;	
	}
	
	normal.rb*=vecSkill1.y;
	normal.rb+=nm.rb*vecSkill45.x+detail.rb*detail_intens*vecSkill1.w;
	normal=mul(normal,matWorld);
	normal=normalize(normal);
	/////////////////////////////////////////////////////////////////////////////
	float3 ViewDir=normalize(View);
	float NV=saturate(dot(ViewDir,normal));
	
	////////////////////////////////////////////////////////////////////
	
	////////////////////////////////////////////////////////////////////
	
	float refindex=lerp(vecSkill41.z,vecSkill41.w,nm.a);
	
	float fresnel=lerp(refindex,1,pow(1-NV,5));//approx. fresnel for specular lighting
	
	roughness=lerp(vecSkill41.x,vecSkill41.y,roughness);
	
	//	roughness=1;
	//	fresnel=1;
	/////////////////////////////////////////////////////////////////////////////
	COL.rgb=col_black.rgb;
	COL.rgb=mask.rgb;
	COL.rgb=col.rgb;
	//	COL.rgb=detail_intens;
	
	COL.a=mask_alpha(global_col.a)*small;
	
	normal=normal*0.5f+0.5f;
	
	NM.xyz=normal.xyz;
	NM.w=fresnel;
	
	D.xyz=splitt_float_to_3half(Depth);
	D.w=roughness;
	
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_a PS();
	}
}
";