bool AUTORELOAD;

float4 vecSkill1;
float4 vecSkill17;//ClipFar.x 

float4 vecSkill41;
float4 vecSkill45;

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float4x4 matWorldViewProj;
float4x4 matWorld;

float4 vecViewPos;

texture entSkin1;
texture entSkin4;
texture entSkin2;

sampler NM_SAMPLER    = sampler_state { Texture   = <entSkin2>; MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler F_SAMPLER     = sampler_state { Texture   = <entSkin4>; MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };
sampler COLOR_SAMPLER = sampler_state { Texture   = <entSkin1>; MinFilter = Linear; MagFilter = Linear; MipFilter = Linear;    AddressU  = wrap; AddressV  = wrap; };

float mask_alpha(float A) { return 1-step(1,1-A); }
float cut_zero(float F) { return F/small2+small; }

void VS(		
in float4 vPos		   : POSITION,
in float2 InTex	   : TEXCOORD0,
in float4 InTangent	: TEXCOORD2,

out float2 OutTex	      : TEXCOORD1,
out float3 View	      : TEXCOORD2,

out float4 Pos	         : POSITION
)
{
	Pos = mul(vPos,matWorldViewProj);
	
	OutTex = InTex;//*vecSkill45.y;

	float3 wPos = mul(vPos,matWorld);
	
	View=vecViewPos.xyz-wPos;
}

void PS(	
in float2 Tex	         : TEXCOORD1,
in float3 View	         : TEXCOORD2,

out float4 NM  :COLOR0
) 
{
	float A=tex2D(COLOR_SAMPLER,Tex).a;A=1;
	A=mask_alpha(A);
	
	float3 normal=normalize(tex2D(NM_SAMPLER,Tex)*2-1);
	normal.b*=-1;
	
	normal=mul(normal,matWorld);
	
	/////////////////////////////////////////////////////////////////////////////
	float3 ViewDir=normalize(View);
	float NV=saturate(dot(ViewDir,normal));
	
	float refindex=tex2D(F_SAMPLER,Tex).r;
	refindex=lerp(vecSkill41.z,vecSkill41.w,refindex);
	
	float fresnel=lerp(refindex,1+(1-refindex),pow(1-NV,5))*0.5f;//approx. fresnel for specular lighting
	/////////////////////////////////////////////////////////////////////////////
	normal=normal*0.5f+0.5f;
	
	NM.xyz=normal.xyz;
	
	NM.w=cut_zero(fresnel)*A;
}

technique Shading
{
	pass P0
	{
		//		fillmode=2;
		//		cullmode=none;
		
		zenable=true;
		zwriteenable=true;
		alphablendenable=false;
		alphatestenable=true;
		
		AlphaRef=0;
		AlphaFunc=Greater;
		
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}