bool AUTORELOAD;

static const float pi=3.141592653589793238462643383279502884197169399375105820974944592f;

float4 vecSkill5;
float4 vecSkill1;

float4 vecViewPort;
float4 vecViewPos;
float4 vecTime;

//float4x4 matMtl;
//float4x4 matEffect;
float4x4 matView;

texture mtlSkin1;
texture mtlSkin2;
texture mtlSkin3;
//texture mtlSkin4;
//texture _bAttenuationMap_PL_bmap;
//texture _bAttenuationMap_SL_bmap;
//
sampler COLOR_SAMPLER = sampler_state { Texture   = <mtlSkin1>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };

sampler LIGHTACC_SAMPLER = sampler_state { Texture   = <mtlSkin2>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };
//sampler TEST_SAMPLER = sampler_state { Texture   = <mtlSkin3>; MinFilter = Point; MagFilter = Point; MipFilter = Point;    AddressU  = clamp; AddressV  = clamp; };

//sampler ATT_SAMPLER = sampler_state { Texture   = <_bAttenuationMap_SL_bmap>; MinFilter = Point; MagFilter = Linear; MipFilter = Linear;    AddressU  = clamp; AddressV  = clamp; };

const float small=1.f/255.f;
const float small2=1.f/(1.f-(1.f/255.f));

float mask_alpha(float A) { return 1-step(1,1-A); }
float add_zero(float F) { return (F-small)*small2; }

const	float RecipLwhiteSqrd=1.f/20.f;

float3 ToneMapper(float3 hdr, float BarLw)
{
	float lumi = dot(hdr,float3(.2126f ,.7152f,.0722f));
	lumi=max(lumi,1);
	
	float aOverBarLw = (0.18f / BarLw);
	float Lxy = aOverBarLw * lumi;
	float numer = (1 + (Lxy * RecipLwhiteSqrd)) * Lxy;
	float denum = 1 + Lxy;
	float Ld = numer / denum ;	
	
	return hdr/Ld;
}

float3 SmoothCurveSin(float3 f)
{
	return sin((f*2-1)*pi*0.5)*0.5+0.5;
}

float3 SmoothCurve(float3 x)
{
	return x*x*(3-2*x);
}

float3 SmoothCurve2(float3 f)
{
	float3 F2=SmoothCurve(f);
	
	float3 lf=1-abs(f*2-1);
	float3 F=lerp(f,F2,lf);
	
	F=SmoothCurve(F);
	
	return F;
}

float3 ContrastCurve(float3 x)
{
	return x*x*x*(4-3*x);
}

float3 bleach_bypass(float3 col,float ds_f)
{
	col=saturate(lerp(col,dot(col,col),ds_f));
	col=SmoothCurve(col);
	return col;
}

float3 norm_color(float3 col)
{
	return col.rgb/max(col.r,max(col.g,col.b));
}

void PS(
in float2 Tex : TEXCOORD0,

out float4 COL : COLOR0,
out float4 GMASK : COLOR1
) 
{	

	//Tex.y-=0.5;
	float4 diff_color=tex2D(COLOR_SAMPLER,Tex);
	
	float mask=add_zero(diff_color.a);
	float diff_mask=min(1,mask*2);
	float glow_mask=(mask-0.5)*2;
	
	diff_mask-=step(small,glow_mask);
	
	diff_mask=max(diff_mask,glow_mask);
	
//	diff_mask=saturate(diff_mask);
//	glow_mask=saturate(glow_mask);
	
//	diff_mask=saturate(diff_mask+glow_mask);
	
	float4 light=max(0,(tex2D(LIGHTACC_SAMPLER,Tex)-small)/(1.f-small));
	
	float3 spec=light.a*light.rgb;
	float3 amb=vecSkill5.xyz/255.f*vecSkill5.w;
	light.rgb=lerp(light.rgb+amb,1,diff_mask);
	
	//	float3 spec_light=saturate(tex2D(LIGHTACC2_SAMPLER,Tex)-(1.f/255.f));
	
	//	float diff_lum=dot(light.rgb,float3(0.2126,0.7152,0.0722));
	//	float3 chroma=light.rgb/(diff_lum+1);float3(0.299f,0.587f,0.114f)
	
	///////////////////
	
	COL.rgb=diff_color.rgb*light.rgb+spec;

	COL.rgb=ToneMapper(COL.rgb,0.04f*vecSkill1.x);
//		COL.rgb=ToneMapper(COL.rgb,0.04f*_vLF_ToneMapperFac_var);
	
	//	COL.rgb=lerp(COL.rgb,bleach_bypass(COL.rgb,0.6),0.6);

	float lum=dot(COL.rgb,float3(0.2126,0.7152,0.0722));
	float lum_mask=max(0,lum-vecSkill1.y);
//	lum_mask*=lum_mask;
	
	//	float lum_mask=pow(max(0,lum-0.1),3);
	//	COL.rgb=saturate(COL.rgb*lum_mask);
	GMASK.rgb=norm_color(COL.rgb)*lum_mask;
	GMASK.rgb=lerp(GMASK.rgb,diff_color.rgb,glow_mask);
	GMASK.a=1;
	
//			COL.rgb=spec;
//			COL.rgb=light.rgb;
//			COL.rgb=diff_color.rgb;
//			COL.rgb=diff_mask;
//			COL.rgb=mask;
//			COL.rgb=glow_mask;
//			COL.rgb=GMASK.rgb;
	
//	COL.rgb=0.5;
	
	//	COL.rgb=saturate(lerp(COL.rgb,dot(COL.rgb,COL.rgb),0.6));
	//	COL.rgb=SmoothCurve(COL.rgb);
	
	//	COL.rgb=saturate(lerp(COL.rgb,length(COL.rgb),0.6));
	//	COL.rgb=ContrastCurve(COL.rgb);
	
	//	COL.rgb=SmoothCurve2(COL.rgb);
	//	light.rgb=ToneMapper(light.rgb,0.04f);
	


	//			COL.rgb=diff_color.rgb*saturate(light.rgb);
	//	float L=length(light.rgb);
	//	COL.rgb=L;
	//	COL.rgb=(light.w*light.rgb);
	//			COL.rgb=light.rgb;
	//			COL.rgb=diff_mask;
	
	//	Tex.x*=Tex.x;
	//	Tex.x+=vecViewPort.w*0.5;
	//			Tex.x=1.0;
	//	float att=tex1D(ATT_SAMPLER,Tex.x).r;

	//	float att=tex1D(ATT_SAMPLER,Tex.x+(1-0.994285135)).r/0.968;
	
	//	COL.rgb=1-pow(1-saturate(COL.r-(1-Tex.y)),500);
	
	//	if(att>(1-Tex.y))
	//	COL.rgb=1;
	//	else
	//	COL.rgb=0;
	//	
	//	//	if(att>=0.994285135)
	//		if(att>=1)
	//		COL.rgb=lerp(float3(1,0,0),COL.rgb,0.5);
	
	COL.w=1;
}

technique Shading
{
	pass one
	{
		PixelShader = compile ps_2_0 PS();
	}
}

